/*     */ package com.google.code.yanf4j.nio.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.config.Configuration;
/*     */ import com.google.code.yanf4j.core.CodecFactory;
/*     */ import com.google.code.yanf4j.core.EventType;
/*     */ import com.google.code.yanf4j.core.Handler;
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import com.google.code.yanf4j.core.SocketOption;
/*     */ import com.google.code.yanf4j.core.WriteMessage;
/*     */ import com.google.code.yanf4j.core.impl.StandardSocketOption;
/*     */ import com.google.code.yanf4j.nio.NioSession;
/*     */ import com.google.code.yanf4j.nio.NioSessionConfig;
/*     */ import java.io.IOException;
/*     */ import java.net.Socket;
/*     */ import java.nio.channels.SelectionKey;
/*     */ import java.nio.channels.SocketChannel;
/*     */ import java.util.Map;
/*     */ import java.util.Queue;
/*     */ import org.slf4j.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class SocketChannelController
/*     */   extends NioController
/*     */ {
/*  26 */   protected boolean soLingerOn = false;
/*     */   
/*     */   public void setSoLinger(boolean on, int value) {
/*  29 */     this.soLingerOn = on;
/*  30 */     this.socketOptions.put(StandardSocketOption.SO_LINGER, Integer.valueOf(value));
/*     */   }
/*     */   
/*     */ 
/*     */   public SocketChannelController() {}
/*     */   
/*     */   public SocketChannelController(Configuration configuration)
/*     */   {
/*  38 */     super(configuration, null, null);
/*     */   }
/*     */   
/*     */ 
/*     */   public SocketChannelController(Configuration configuration, CodecFactory codecFactory)
/*     */   {
/*  44 */     super(configuration, null, codecFactory);
/*     */   }
/*     */   
/*     */   public SocketChannelController(Configuration configuration, Handler handler, CodecFactory codecFactory)
/*     */   {
/*  49 */     super(configuration, handler, codecFactory);
/*     */   }
/*     */   
/*     */   protected final void dispatchReadEvent(SelectionKey key)
/*     */   {
/*  54 */     Session session = (Session)key.attachment();
/*  55 */     if (session != null) {
/*  56 */       ((NioSession)session).onEvent(EventType.READABLE, key.selector());
/*     */     } else {
/*  58 */       log.warn("Could not find session for readable event,maybe it is closed");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   protected final void dispatchWriteEvent(SelectionKey key)
/*     */   {
/*  65 */     Session session = (Session)key.attachment();
/*  66 */     if (session != null) {
/*  67 */       ((NioSession)session).onEvent(EventType.WRITEABLE, key.selector());
/*     */     } else {
/*  69 */       log.warn("Could not find session for writable event,maybe it is closed");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   protected NioSession buildSession(SocketChannel sc)
/*     */   {
/*  76 */     Queue<WriteMessage> queue = buildQueue();
/*  77 */     NioSessionConfig sessionConfig = buildSessionConfig(sc, queue);
/*  78 */     NioSession session = new NioTCPSession(sessionConfig, this.configuration.getSessionReadBufferSize());
/*     */     
/*  80 */     return session;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final void configureSocketChannel(SocketChannel sc)
/*     */     throws IOException
/*     */   {
/*  91 */     sc.socket().setSoTimeout(this.soTimeout);
/*  92 */     sc.configureBlocking(false);
/*  93 */     if (this.socketOptions.get(StandardSocketOption.SO_REUSEADDR) != null) {
/*  94 */       sc.socket().setReuseAddress(((Boolean)StandardSocketOption.SO_REUSEADDR.type().cast(this.socketOptions.get(StandardSocketOption.SO_REUSEADDR))).booleanValue());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  99 */     if (this.socketOptions.get(StandardSocketOption.SO_SNDBUF) != null) {
/* 100 */       sc.socket().setSendBufferSize(((Integer)StandardSocketOption.SO_SNDBUF.type().cast(this.socketOptions.get(StandardSocketOption.SO_SNDBUF))).intValue());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 105 */     if (this.socketOptions.get(StandardSocketOption.SO_KEEPALIVE) != null) {
/* 106 */       sc.socket().setKeepAlive(((Boolean)StandardSocketOption.SO_KEEPALIVE.type().cast(this.socketOptions.get(StandardSocketOption.SO_KEEPALIVE))).booleanValue());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 111 */     if (this.socketOptions.get(StandardSocketOption.SO_LINGER) != null) {
/* 112 */       sc.socket().setSoLinger(this.soLingerOn, ((Integer)StandardSocketOption.SO_LINGER.type().cast(this.socketOptions.get(StandardSocketOption.SO_LINGER))).intValue());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 118 */     if (this.socketOptions.get(StandardSocketOption.SO_RCVBUF) != null) {
/* 119 */       sc.socket().setReceiveBufferSize(((Integer)StandardSocketOption.SO_RCVBUF.type().cast(this.socketOptions.get(StandardSocketOption.SO_RCVBUF))).intValue());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 125 */     if (this.socketOptions.get(StandardSocketOption.TCP_NODELAY) != null) {
/* 126 */       sc.socket().setTcpNoDelay(((Boolean)StandardSocketOption.TCP_NODELAY.type().cast(this.socketOptions.get(StandardSocketOption.TCP_NODELAY))).booleanValue());
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\nio\impl\SocketChannelController.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */