/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain.reportjobmodel;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JSException;
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJob;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobAlert;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobMailNotification;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobRepositoryDestination;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobSimpleTrigger;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobSource;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobTrigger;
/*     */ import java.sql.Timestamp;
/*     */ import java.util.Set;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElements;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @XmlRootElement(name="jobModel")
/*     */ @JasperServerAPI
/*     */ public class ReportJobModel
/*     */   extends ReportJob
/*     */ {
/*     */   public static enum ReportJobSortType
/*     */   {
/*  61 */     NONE, 
/*  62 */     SORTBY_JOBID, 
/*  63 */     SORTBY_JOBNAME, 
/*  64 */     SORTBY_REPORTURI, 
/*  65 */     SORTBY_REPORTNAME, 
/*  66 */     SORTBY_REPORTFOLDER, 
/*  67 */     SORTBY_OWNER, 
/*  68 */     SORTBY_STATUS, 
/*  69 */     SORTBY_LASTRUN, 
/*  70 */     SORTBY_NEXTRUN;
/*     */     
/*     */     private ReportJobSortType() {} }
/*  73 */   private boolean isCreationDateModified = false;
/*  74 */   private boolean isSourceModified = false;
/*  75 */   private boolean isTriggerModified = false;
/*  76 */   private boolean isMailNotificationModified = false;
/*  77 */   private boolean isAlertModified = false;
/*  78 */   private boolean isContentRespositoryDestinationModified = false;
/*  79 */   private boolean isDescriptionModified = false;
/*  80 */   private boolean isLabelModified = false;
/*  81 */   private boolean isBaseOutputFileNameModified = false;
/*  82 */   private boolean isOutputFormatsModified = false;
/*  83 */   private boolean isUsernameModified = false;
/*  84 */   private boolean isOutputLocaleModified = false;
/*  85 */   private boolean isRuntimeInformationModified = false;
/*     */   
/*  87 */   private ReportJobRuntimeInformationModel runtimeInformation = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public ReportJobSource getSource()
/*     */   {
/* 102 */     return getSourceModel();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobSourceModel getSourceModel()
/*     */   {
/* 113 */     ReportJobSource model = super.getSource();
/* 114 */     if (model == null) return null;
/* 115 */     if ((model instanceof ReportJobSourceModel)) return (ReportJobSourceModel)model;
/* 116 */     throw new JSException("Please use ReportJobSourceModel instead of ReportJobSource in ReportJobModel class.");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setSource(ReportJobSource source)
/*     */   {
/* 130 */     if (source == null) { setSourceModel(null);
/* 131 */     } else if ((source instanceof ReportJobSourceModel)) setSourceModel((ReportJobSourceModel)source); else {
/* 132 */       throw new JSException("Please use ReportJobSourceModel instead of ReportJobSource in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSourceModel(ReportJobSourceModel source)
/*     */   {
/* 146 */     this.isSourceModified = true;
/* 147 */     super.setSource(source);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public ReportJobTrigger getTrigger()
/*     */   {
/* 160 */     return getTriggerModel();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElements({@XmlElement(name="simpleTriggerModel", type=ReportJobSimpleTriggerModel.class), @XmlElement(name="calendarTriggerModel", type=ReportJobCalendarTriggerModel.class)})
/*     */   public ReportJobTrigger getTriggerModel()
/*     */   {
/* 173 */     ReportJobTrigger model = super.getTrigger();
/* 174 */     if (model == null) return null;
/* 175 */     if (((model instanceof ReportJobSimpleTriggerModel)) || ((model instanceof ReportJobCalendarTriggerModel))) return model;
/* 176 */     throw new JSException("Please useReportJobTriggerModel instead of ReportJobTrigger in ReportJobModel class.");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setTrigger(ReportJobTrigger trigger)
/*     */   {
/* 194 */     setTriggerModel(trigger);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setTriggerModel(ReportJobTrigger trigger)
/*     */   {
/* 211 */     this.isTriggerModified = true;
/* 212 */     if (trigger == null) { super.setTrigger(null);
/* 213 */     } else if (((trigger instanceof ReportJobSimpleTriggerModel)) || ((trigger instanceof ReportJobCalendarTriggerModel))) {
/* 214 */       super.setTrigger(trigger);
/*     */     } else {
/* 216 */       if ((trigger instanceof ReportJobSimpleTrigger)) {
/* 217 */         throw new JSException("Please use ReportJobSimpleTriggerModel or  instead of ReportJobSimpleTrigger in ReportJobModel class.");
/*     */       }
/* 219 */       throw new JSException("Please use ReportJobCalendarTriggerModel or  instead of ReportJobCalendarTrigger in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public ReportJobAlert getAlert()
/*     */   {
/* 234 */     return getAlertModel();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobAlertModel getAlertModel()
/*     */   {
/* 246 */     ReportJobAlert model = super.getAlert();
/* 247 */     if (model == null) return null;
/* 248 */     if ((model instanceof ReportJobAlertModel)) return (ReportJobAlertModel)model;
/* 249 */     throw new JSException("Please use ReportJobAlertModel instead of ReportJobAlert in ReportJobModel class.");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setAlert(ReportJobAlertModel alert)
/*     */   {
/* 263 */     if (alert == null) { setAlertModel(null);
/* 264 */     } else if ((alert instanceof ReportJobAlertModel)) setAlertModel(alert); else {
/* 265 */       throw new JSException("Please use ReportJobAlertModel instead of ReportJobAlert in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setAlertModel(ReportJobAlertModel alert)
/*     */   {
/* 278 */     super.setAlert(alert);
/* 279 */     this.isAlertModified = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public ReportJobMailNotification getMailNotification()
/*     */   {
/* 295 */     return getMailNotificationModel();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobMailNotificationModel getMailNotificationModel()
/*     */   {
/* 307 */     ReportJobMailNotification model = super.getMailNotification();
/* 308 */     if (model == null) return null;
/* 309 */     if ((model instanceof ReportJobMailNotificationModel)) return (ReportJobMailNotificationModel)model;
/* 310 */     throw new JSException("Please use ReportJobMailNotificationModel instead of ReportJobMailNotification in ReportJobModel class.");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setMailNotification(ReportJobMailNotificationModel mailNotification)
/*     */   {
/* 324 */     if (mailNotification == null) { setMailNotificationModel(null);
/* 325 */     } else if ((mailNotification instanceof ReportJobMailNotificationModel)) setMailNotificationModel(mailNotification); else {
/* 326 */       throw new JSException("Please use ReportJobMailNotificationModel instead of ReportJobMailNotification in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMailNotificationModel(ReportJobMailNotificationModel mailNotification)
/*     */   {
/* 339 */     super.setMailNotification(mailNotification);
/* 340 */     this.isMailNotificationModified = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public ReportJobRepositoryDestination getContentRepositoryDestination()
/*     */   {
/* 360 */     return getContentRepositoryDestinationModel();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElement(name="repositoryDestinationModel")
/*     */   public ReportJobRepositoryDestinationModel getContentRepositoryDestinationModel()
/*     */   {
/* 378 */     ReportJobRepositoryDestination model = super.getContentRepositoryDestination();
/* 379 */     if (model == null) return null;
/* 380 */     if ((model instanceof ReportJobRepositoryDestinationModel)) return (ReportJobRepositoryDestinationModel)model;
/* 381 */     throw new JSException("Please use ReportJobRepositoryDestinationModel instead of ReportJobRepositoryDestination in ReportJobModel class.");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setContentRepositoryDestination(ReportJobRepositoryDestinationModel contentRepositoryDestination)
/*     */   {
/* 398 */     if (contentRepositoryDestination == null) { setContentRepositoryDestinationModel(null);
/* 399 */     } else if ((contentRepositoryDestination instanceof ReportJobRepositoryDestinationModel))
/* 400 */       setContentRepositoryDestinationModel(contentRepositoryDestination); else {
/* 401 */       throw new JSException("Please use ReportJobRepositoryDestinationModel instead of ReportJobRepositoryDestinationModel in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setContentRepositoryDestinationModel(ReportJobRepositoryDestinationModel contentRepositoryDestination)
/*     */   {
/* 416 */     super.setContentRepositoryDestination(contentRepositoryDestination);
/* 417 */     this.isContentRespositoryDestinationModified = true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobRuntimeInformationModel getRuntimeInformationModel()
/*     */   {
/* 426 */     return this.runtimeInformation;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setRuntimeInformationModel(ReportJobRuntimeInformationModel runtimeInformationModel)
/*     */   {
/* 435 */     this.isRuntimeInformationModified = true;
/* 436 */     this.runtimeInformation = runtimeInformationModel;
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public long getId()
/*     */   {
/* 445 */     return super.getId();
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/* 451 */   public void setId(long id) { super.setId(id); }
/*     */   
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public int getVersion()
/*     */   {
/* 460 */     return super.getVersion();
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/* 466 */   public void setVersion(int version) { super.setVersion(version); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setDescription(String description)
/*     */   {
/* 475 */     this.isDescriptionModified = true;
/* 476 */     super.setDescription(description);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setCreationDate(Timestamp creationDate)
/*     */   {
/* 486 */     this.isCreationDateModified = true;
/* 487 */     super.setCreationDate(creationDate);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setLabel(String label)
/*     */   {
/* 496 */     this.isLabelModified = true;
/* 497 */     super.setLabel(label);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setBaseOutputFilename(String baseOutputFilename)
/*     */   {
/* 507 */     this.isBaseOutputFileNameModified = true;
/* 508 */     super.setBaseOutputFilename(baseOutputFilename);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputFormatsSet(Set<Byte> outputFormats)
/*     */   {
/* 519 */     this.isOutputFormatsModified = true;
/* 520 */     super.setOutputFormatsSet(outputFormats);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean addOutputFormat(byte outputFormat)
/*     */   {
/* 531 */     this.isOutputFormatsModified = true;
/* 532 */     return super.addOutputFormat(outputFormat);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean removeOutputFormat(byte outputFormat)
/*     */   {
/* 542 */     this.isOutputFormatsModified = true;
/* 543 */     return super.removeOutputFormat(outputFormat);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setUsername(String username)
/*     */   {
/* 558 */     this.isUsernameModified = true;
/* 559 */     super.setUsername(username);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputLocale(String outputLocale)
/*     */   {
/* 572 */     this.isOutputLocaleModified = true;
/* 573 */     super.setOutputLocale(outputLocale);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isCreationDateModified()
/*     */   {
/* 581 */     return this.isCreationDateModified;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public boolean isSourceModified()
/*     */   {
/* 588 */     return this.isSourceModified;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public boolean isTriggerModified()
/*     */   {
/* 595 */     return this.isTriggerModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isMailNotificationModified()
/*     */   {
/* 601 */     return this.isMailNotificationModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isAlertModified()
/*     */   {
/* 607 */     return this.isAlertModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isContentRespositoryDestinationModified()
/*     */   {
/* 613 */     return this.isContentRespositoryDestinationModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isDescriptionModified()
/*     */   {
/* 619 */     return this.isDescriptionModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isLabelModified()
/*     */   {
/* 625 */     return this.isLabelModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isBaseOutputFileNameModified()
/*     */   {
/* 631 */     return this.isBaseOutputFileNameModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isOutputFormatsModified()
/*     */   {
/* 637 */     return this.isOutputFormatsModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isUsernameModified()
/*     */   {
/* 643 */     return this.isUsernameModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isOutputLocaleModified()
/*     */   {
/* 649 */     return this.isOutputLocaleModified;
/*     */   }
/*     */   
/*     */ 
/*     */   public boolean isRuntimeInformationModified()
/*     */   {
/* 655 */     return this.isRuntimeInformationModified;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\reportjobmodel\ReportJobModel.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */