/*     */ package com.jaspersoft.jasperserver.irplugin;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.wsclient.WSClient;
/*     */ import it.businesslogic.ireport.export.JRTxtExporter;
/*     */ import it.businesslogic.ireport.export.JRTxtExporterParameter;
/*     */ import it.businesslogic.ireport.gui.MainFrame;
/*     */ import it.businesslogic.ireport.gui.logpane.LogTextArea;
/*     */ import it.businesslogic.ireport.util.Misc;
/*     */ import java.awt.Frame;
/*     */ import java.awt.Window;
/*     */ import java.io.File;
/*     */ import java.io.PrintWriter;
/*     */ import java.io.StringWriter;
/*     */ import java.net.URL;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Properties;
/*     */ import net.sf.jasperreports.engine.JRExporter;
/*     */ import net.sf.jasperreports.engine.JRExporterParameter;
/*     */ import net.sf.jasperreports.engine.JasperPrint;
/*     */ import net.sf.jasperreports.engine.export.JExcelApiExporter;
/*     */ import net.sf.jasperreports.engine.export.JRCsvExporter;
/*     */ import net.sf.jasperreports.engine.export.JRCsvExporterParameter;
/*     */ import net.sf.jasperreports.engine.export.JRGraphics2DExporter;
/*     */ import net.sf.jasperreports.engine.export.JRHtmlExporter;
/*     */ import net.sf.jasperreports.engine.export.JRHtmlExporterParameter;
/*     */ import net.sf.jasperreports.engine.export.JRPdfExporter;
/*     */ import net.sf.jasperreports.engine.export.JRPdfExporterParameter;
/*     */ import net.sf.jasperreports.engine.export.JRRtfExporter;
/*     */ import net.sf.jasperreports.engine.export.JRTextExporter;
/*     */ import net.sf.jasperreports.engine.export.JRTextExporterParameter;
/*     */ import net.sf.jasperreports.engine.export.JRXlsAbstractExporterParameter;
/*     */ import net.sf.jasperreports.engine.export.JRXlsExporter;
/*     */ import net.sf.jasperreports.view.JasperViewer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ReportRunner
/*     */   implements Runnable
/*     */ {
/*     */   private RepositoryReportUnit reportUnit;
/*     */   private Map map;
/*     */   private JServer server;
/*     */   private LogTextArea lta;
/*     */   
/*     */   public void run()
/*     */   {
/*     */     try
/*     */     {
/*  75 */       this.lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\" color=\"#0000CC\"><b>" + IRPlugin.getFormattedString("compiler.fillReportOnServer", "Filling report on server: {0}", new Object[] { "" + getServer().getUrl() }) + "</b> </font><hr>", true);
/*     */       
/*  77 */       Map params = getReportParameters();
/*  78 */       JasperPrint print = getServer().getWSClient().runReport(getReportUnit().getDescriptor(), params);
/*  79 */       MainFrame.getMainInstance();exportPrint(MainFrame.IREPORT_TMP_DIR, getReportUnit().getDescriptor().getName(), print, getLta());
/*     */     }
/*     */     catch (Exception t) {
/*  82 */       StringWriter sw = new StringWriter();
/*  83 */       t.printStackTrace(new PrintWriter(sw));
/*  84 */       sw.flush();
/*  85 */       this.lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\" color=\"#CC0000\">" + t.getMessage() + "</font><hr>", true);
/*  86 */       this.lta.logOnConsole(sw.toString(), false);
/*     */     }
/*     */   }
/*     */   
/*     */   protected Map getReportParameters() {
/*  91 */     Map params = new HashMap(getMap());
/*  92 */     if (!params.containsKey("REPORT_LOCALE")) {
/*  93 */       String locale = getReportLocale();
/*  94 */       if ((locale != null) && (locale.length() > 0))
/*     */       {
/*  96 */         params.put("REPORT_LOCALE", locale);
/*     */       }
/*     */     }
/*  99 */     return params;
/*     */   }
/*     */   
/*     */   protected String getReportLocale() {
/* 103 */     return getMainFrame().getProperties().getProperty("reportLocale");
/*     */   }
/*     */   
/*     */ 
/*     */   public RepositoryReportUnit getReportUnit()
/*     */   {
/* 109 */     return this.reportUnit;
/*     */   }
/*     */   
/*     */   public void setReportUnit(RepositoryReportUnit reportUnit) {
/* 113 */     this.reportUnit = reportUnit;
/*     */   }
/*     */   
/*     */   public Map getMap() {
/* 117 */     return this.map;
/*     */   }
/*     */   
/*     */   public void setMap(Map map) {
/* 121 */     this.map = map;
/*     */   }
/*     */   
/*     */   public JServer getServer() {
/* 125 */     return this.server;
/*     */   }
/*     */   
/*     */   public void setServer(JServer server) {
/* 129 */     this.server = server;
/*     */   }
/*     */   
/*     */   public LogTextArea getLta() {
/* 133 */     return this.lta;
/*     */   }
/*     */   
/*     */   public void setLta(LogTextArea lta) {
/* 137 */     this.lta = lta;
/*     */   }
/*     */   
/*     */ 
/*     */   public void exportPrint(String tmpDir, String fileName, JasperPrint print, LogTextArea lta)
/*     */   {
/* 143 */     String status = "";
/* 144 */     if (!tmpDir.endsWith(File.separator)) {
/* 145 */       tmpDir = tmpDir + File.separator;
/*     */     }
/* 147 */     int format = getMainFrame().getReportViewer();
/*     */     
/* 149 */     if (print != null)
/*     */     {
/* 151 */       JRExporter exporter = null;
/* 152 */       lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\" color=\"#0000CC\"><b>" + IRPlugin.getString("compiler.reportFilled", "Report filled") + "</b>&nbsp;" + IRPlugin.getFormattedString("compiler.pagesGenerated", "(pages generated: {0,number,integer} )", new Object[] { new Integer(print.getPages().size()) }) + "</font><hr>", true);
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 159 */       status = "exporting report";
/* 160 */       long start = System.currentTimeMillis();
/* 161 */       String viewer_program = "";
/* 162 */       String exportingMessage = "";
/*     */       
/* 164 */       boolean errorExporting = false;
/*     */       
/*     */       try
/*     */       {
/* 168 */         if (format == 2)
/*     */         {
/* 170 */           exporter = new JRPdfExporter();
/* 171 */           if (getMainFrame().getProperties().getProperty("PDF_IS_ENCRYPTED") != null)
/* 172 */             exporter.setParameter(JRPdfExporterParameter.IS_ENCRYPTED, new Boolean(getMainFrame().getProperties().getProperty("PDF_IS_ENCRYPTED")));
/* 173 */           if (getMainFrame().getProperties().getProperty("PDF_IS_128_BIT_KEY") != null)
/* 174 */             exporter.setParameter(JRPdfExporterParameter.IS_128_BIT_KEY, new Boolean(getMainFrame().getProperties().getProperty("PDF_IS_128_BIT_KEY")));
/* 175 */           if (getMainFrame().getProperties().getProperty("PDF_USER_PASSWORD") != null)
/* 176 */             exporter.setParameter(JRPdfExporterParameter.USER_PASSWORD, getMainFrame().getProperties().getProperty("PDF_USER_PASSWORD"));
/* 177 */           if (getMainFrame().getProperties().getProperty("PDF_OWNER_PASSWORD") != null)
/* 178 */             exporter.setParameter(JRPdfExporterParameter.OWNER_PASSWORD, getMainFrame().getProperties().getProperty("PDF_OWNER_PASSWORD"));
/* 179 */           if (getMainFrame().getProperties().getProperty("PDF_PERMISSIONS") != null)
/* 180 */             exporter.setParameter(JRPdfExporterParameter.PERMISSIONS, new Integer(getMainFrame().getProperties().getProperty("PDF_PERMISSIONS")));
/* 181 */           fileName = Misc.changeFileExtension(fileName, "pdf");
/* 182 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.pdf", "Exporting pdf to file (using iText)... {0}", new Object[] { fileName });
/*     */           
/* 184 */           viewer_program = getMainFrame().getProperties().getProperty("ExternalPDFViewer");
/*     */         }
/* 186 */         else if (format == 16)
/*     */         {
/* 188 */           exporter = new JRCsvExporter();
/* 189 */           if (getMainFrame().getProperties().getProperty("CSV_FIELD_DELIMITER") != null)
/* 190 */             exporter.setParameter(JRCsvExporterParameter.FIELD_DELIMITER, getMainFrame().getProperties().getProperty("CSV_FIELD_DELIMITER"));
/* 191 */           fileName = Misc.changeFileExtension(fileName, "csv");
/* 192 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.cvs", "Exporting CSV to file... {0}", new Object[] { fileName });
/* 193 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalCSVViewer"), "");
/*     */         }
/* 195 */         else if (format == 4)
/*     */         {
/* 197 */           exporter = new JRHtmlExporter();
/* 198 */           if (getMainFrame().getProperties().getProperty("HTML_IMAGES_DIR_NAME") != null)
/* 199 */             exporter.setParameter(JRHtmlExporterParameter.IMAGES_DIR_NAME, getMainFrame().getProperties().getProperty("HTML_IMAGES_DIR_NAME"));
/* 200 */           if (getMainFrame().getProperties().getProperty("HTML_IS_OUTPUT_IMAGES_TO_DIR") != null)
/* 201 */             exporter.setParameter(JRHtmlExporterParameter.IS_OUTPUT_IMAGES_TO_DIR, new Boolean(getMainFrame().getProperties().getProperty("HTML_IS_OUTPUT_IMAGES_TO_DIR")));
/* 202 */           if (getMainFrame().getProperties().getProperty("HTML_IMAGES_URI") != null)
/* 203 */             exporter.setParameter(JRHtmlExporterParameter.IMAGES_URI, getMainFrame().getProperties().getProperty("HTML_IMAGES_URI"));
/* 204 */           if (getMainFrame().getProperties().getProperty("HTML_HTML_HEADER") != null)
/* 205 */             exporter.setParameter(JRHtmlExporterParameter.HTML_HEADER, getMainFrame().getProperties().getProperty("HTML_HTML_HEADER"));
/* 206 */           if (getMainFrame().getProperties().getProperty("HTML_BETWEEN_PAGES_HTML") != null)
/* 207 */             exporter.setParameter(JRHtmlExporterParameter.BETWEEN_PAGES_HTML, getMainFrame().getProperties().getProperty("HTML_BETWEEN_PAGES_HTML"));
/* 208 */           if (getMainFrame().getProperties().getProperty("HTML_HTML_FOOTER") != null)
/* 209 */             exporter.setParameter(JRHtmlExporterParameter.HTML_FOOTER, getMainFrame().getProperties().getProperty("HTML_HTML_FOOTER"));
/* 210 */           if (getMainFrame().getProperties().getProperty("HTML_IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS") != null)
/* 211 */             exporter.setParameter(JRHtmlExporterParameter.IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS, new Boolean(getMainFrame().getProperties().getProperty("HTML_IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS")));
/* 212 */           if (getMainFrame().getProperties().getProperty("HTML_IS_WHITE_PAGE_BACKGROUND") != null)
/* 213 */             exporter.setParameter(JRHtmlExporterParameter.IS_WHITE_PAGE_BACKGROUND, new Boolean(getMainFrame().getProperties().getProperty("HTML_IS_WHITE_PAGE_BACKGROUND")));
/* 214 */           if (getMainFrame().getProperties().getProperty("HTML_IS_USING_IMAGES_TO_ALIGN") != null)
/* 215 */             exporter.setParameter(JRHtmlExporterParameter.IS_USING_IMAGES_TO_ALIGN, new Boolean(getMainFrame().getProperties().getProperty("HTML_IS_USING_IMAGES_TO_ALIGN")));
/* 216 */           fileName = Misc.changeFileExtension(fileName, "html");
/* 217 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.html", "Exporting HTML to file... {0}", new Object[] { fileName });
/* 218 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalHTMLViewer"), "");
/*     */         }
/* 220 */         else if (format == 8)
/*     */         {
/* 222 */           exporter = new JRXlsExporter();
/* 223 */           if (getMainFrame().getProperties().getProperty("XLS_IS_ONE_PAGE_PER_SHEET") != null)
/* 224 */             exporter.setParameter(JRXlsAbstractExporterParameter.IS_ONE_PAGE_PER_SHEET, new Boolean(getMainFrame().getProperties().getProperty("XLS_IS_ONE_PAGE_PER_SHEET")));
/* 225 */           if (getMainFrame().getProperties().getProperty("XLS_IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS") != null)
/* 226 */             exporter.setParameter(JRXlsAbstractExporterParameter.IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS, new Boolean(getMainFrame().getProperties().getProperty("XLS_IS_REMOVE_EMPTY_SPACE_BETWEEN_ROWS")));
/* 227 */           if (getMainFrame().getProperties().getProperty("XLS_IS_WHITE_PAGE_BACKGROUND") != null)
/* 228 */             exporter.setParameter(JRXlsAbstractExporterParameter.IS_WHITE_PAGE_BACKGROUND, new Boolean(getMainFrame().getProperties().getProperty("XLS_IS_WHITE_PAGE_BACKGROUND")));
/* 229 */           if (getMainFrame().getProperties().getProperty("XLS_IS_AUTO_DETECT_CELL_TYPE") != null)
/* 230 */             exporter.setParameter(JRXlsAbstractExporterParameter.IS_AUTO_DETECT_CELL_TYPE, new Boolean(getMainFrame().getProperties().getProperty("XLS_IS_AUTO_DETECT_CELL_TYPE")));
/* 231 */           fileName = Misc.changeFileExtension(fileName, "xls");
/* 232 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.xls", "Exporting xls to file (using POI)...  {0}", new Object[] { fileName });
/* 233 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalXLSViewer"), "");
/*     */         }
/* 235 */         else if (format == 512)
/*     */         {
/* 237 */           exporter = new JExcelApiExporter();
/* 238 */           if (getMainFrame().getProperties().getProperty("XLS2_IS_FONT_SIZE_FIX_ENABLED") != null)
/* 239 */             exporter.setParameter(JRXlsAbstractExporterParameter.IS_FONT_SIZE_FIX_ENABLED, new Boolean(getMainFrame().getProperties().getProperty("XLS2_IS_FONT_SIZE_FIX_ENABLED")));
/* 240 */           fileName = Misc.changeFileExtension(fileName, "xls");
/* 241 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.xls2", "Exporting xls to file (using JExcelApi)... {0}", new Object[] { fileName });
/*     */           
/* 243 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalXLSViewer"), "");
/*     */         }
/* 245 */         else if (format == 1)
/*     */         {
/* 247 */           exporter = new JRGraphics2DExporter();
/* 248 */           exportingMessage = "Exporting to Java2D ";
/* 249 */           viewer_program = null;
/*     */         }
/* 251 */         else if (format == 32)
/*     */         {
/* 253 */           exportingMessage = IRPlugin.getString("compiler.exporting.jasper", "Viewing with JasperReports Viewer");
/* 254 */           exporter = null;
/* 255 */           viewer_program = null;
/*     */         }
/* 257 */         else if (format == 64)
/*     */         {
/* 259 */           exporter = new JRTxtExporter();
/* 260 */           if (getMainFrame().getProperties().getProperty("TXT_PAGE_ROWS") != null)
/* 261 */             exporter.setParameter(JRTxtExporterParameter.PAGE_ROWS, getMainFrame().getProperties().getProperty("TXT_PAGE_ROWS"));
/* 262 */           if (getMainFrame().getProperties().getProperty("TXT_PAGE_COLUMNS") != null)
/* 263 */             exporter.setParameter(JRTxtExporterParameter.PAGE_COLUMNS, getMainFrame().getProperties().getProperty("TXT_PAGE_COLUMNS"));
/* 264 */           if (getMainFrame().getProperties().getProperty("TXT_ADD_FORM_FEED") != null)
/* 265 */             exporter.setParameter(JRTxtExporterParameter.ADD_FORM_FEED, new Boolean(getMainFrame().getProperties().getProperty("TXT_ADD_FORM_FEED")));
/* 266 */           fileName = Misc.changeFileExtension(fileName, "txt");
/* 267 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.txt", "Exporting txt (iReport) to file... {0}", new Object[] { fileName });
/* 268 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalTXTViewer"), "");
/*     */         }
/* 270 */         else if (format == 128)
/*     */         {
/* 272 */           exporter = new JRTextExporter();
/* 273 */           if (getMainFrame().getProperties().getProperty("JRTXT_PAGE_WIDTH") != null)
/* 274 */             exporter.setParameter(JRTextExporterParameter.PAGE_WIDTH, new Integer(getMainFrame().getProperties().getProperty("JRTXT_PAGE_WIDTH")));
/* 275 */           if (getMainFrame().getProperties().getProperty("JRTXT_PAGE_HEIGHT") != null)
/* 276 */             exporter.setParameter(JRTextExporterParameter.PAGE_HEIGHT, new Integer(getMainFrame().getProperties().getProperty("JRTXT_PAGE_HEIGHT")));
/* 277 */           if (getMainFrame().getProperties().getProperty("JRTXT_CHARACTER_WIDTH") != null)
/* 278 */             exporter.setParameter(JRTextExporterParameter.CHARACTER_WIDTH, new Integer(getMainFrame().getProperties().getProperty("JRTXT_CHARACTER_WIDTH")));
/* 279 */           if (getMainFrame().getProperties().getProperty("JRTXT_CHARACTER_HEIGHT") != null)
/* 280 */             exporter.setParameter(JRTextExporterParameter.CHARACTER_HEIGHT, new Integer(getMainFrame().getProperties().getProperty("JRTXT_CHARACTER_HEIGHT")));
/* 281 */           if (getMainFrame().getProperties().getProperty("JRTXT_BETWEEN_PAGES_TEXT") != null)
/* 282 */             exporter.setParameter(JRTextExporterParameter.BETWEEN_PAGES_TEXT, getMainFrame().getProperties().getProperty("JRTXT_BETWEEN_PAGES_TEXT"));
/* 283 */           fileName = Misc.changeFileExtension(fileName, "txt");
/* 284 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.txt2", "Exporting txt (jasperReports) to file... {0}", new Object[] { fileName });
/* 285 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalTXTViewer"), "");
/*     */         }
/* 287 */         else if (format == 256)
/*     */         {
/* 289 */           exporter = new JRRtfExporter();
/* 290 */           fileName = Misc.changeFileExtension(fileName, "rtf");
/* 291 */           exportingMessage = IRPlugin.getFormattedString("compiler.exporting.rtf", "Exporting RTF to file... {0}", new Object[] { fileName });
/* 292 */           viewer_program = Misc.nvl(getMainFrame().getProperties().getProperty("ExternalRTFViewer"), "");
/*     */         }
/* 294 */         URL img_url = getClass().getResource("/it/businesslogic/ireport/icons/printer_mini.png");
/* 295 */         lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\"><img align=\"right\" src=\"" + img_url + "\"> &nbsp;" + exportingMessage + "</font>", true);
/*     */         
/*     */ 
/* 298 */         if (exporter != null)
/*     */         {
/* 300 */           exporter.setParameter(JRExporterParameter.OUTPUT_FILE_NAME, tmpDir + fileName);
/* 301 */           exporter.setParameter(JRExporterParameter.JASPER_PRINT, print);
/* 302 */           exporter.exportReport();
/*     */         }
/* 304 */         else if (format == 32)
/*     */         {
/* 306 */           JasperViewer jasperViewer = new JasperViewer(print, false);
/* 307 */           jasperViewer.setTitle("iReport JasperViewer");
/* 308 */           jasperViewer.setVisible(true);
/*     */         }
/*     */       }
/*     */       catch (Throwable ex2)
/*     */       {
/* 313 */         errorExporting = true;
/* 314 */         lta.logOnConsole(IRPlugin.getString("compiler.exporting.error", "Error exporting print...") + "\n");
/* 315 */         ex2.printStackTrace();
/* 316 */         lta.logOnConsole("" + ex2);
/*     */       }
/*     */       
/*     */ 
/* 320 */       if (!errorExporting)
/*     */       {
/* 322 */         lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\" color=\"#0000CC\"><b>" + IRPlugin.getFormattedString("compiler.exporting.time", "Export running time: {0,number,long} millisecs", new Object[] { new Long(System.currentTimeMillis() - start) }) + "</b></font><hr>", true);
/*     */         
/*     */ 
/* 325 */         Runtime rt = Runtime.getRuntime();
/* 326 */         if ((viewer_program == null) || (viewer_program.equals("")))
/*     */         {
/* 328 */           if (format != 32) {
/* 329 */             lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\">" + IRPlugin.getString("compiler.exporting.noviewer", "No external viewer specified for this type of print. Set it in the options frame!") + "</font>", true);
/*     */           }
/*     */           
/*     */         }
/*     */         else {
/*     */           try
/*     */           {
/* 336 */             File f = new File(fileName);
/*     */             
/* 338 */             String execute_string = viewer_program + " " + f + "";
/* 339 */             lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\">" + IRPlugin.getFormattedString("compiler.exporting.executing", "Executing: {0}", new Object[] { execute_string }) + "</font>", true);
/*     */             
/*     */ 
/* 342 */             rt.exec(execute_string);
/*     */           }
/*     */           catch (Exception ex)
/*     */           {
/* 346 */             lta.logOnConsole(IRPlugin.getString("compiler.exporting.viewing", "Error viewing report...") + "\n");
/* 347 */             ex.printStackTrace();
/*     */           }
/*     */         }
/*     */       }
/*     */       else
/*     */       {
/* 353 */         lta.logOnConsole("<font face=\"SansSerif\"  size=\"3\" color=\"#CC0000\"><b>" + IRPlugin.getString("compiler.exporting.exporterror", "Error exporting the report, try to run the report using the internal viewer.") + "</b></font><hr>", true);
/*     */       }
/*     */       
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/* 360 */       lta.logOnConsole(IRPlugin.getString("compiler.printNotFilled", "Print not filled.") + "\n");
/*     */     }
/*     */   }
/*     */   
/*     */   public MainFrame getMainFrame()
/*     */   {
/* 366 */     return MainFrame.getMainInstance();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\ReportRunner.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */