/*      */ package com.jaspersoft.jasperserver.irplugin.gui;
/*      */ 
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Argument;
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Request;
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceProperty;
/*      */ import com.jaspersoft.jasperserver.irplugin.ControlsSet;
/*      */ import com.jaspersoft.jasperserver.irplugin.IRPlugin;
/*      */ import com.jaspersoft.jasperserver.irplugin.JServer;
/*      */ import com.jaspersoft.jasperserver.irplugin.ReportRunner;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryFile;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryFolder;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryJrxmlFile;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryReportUnit;
/*      */ import com.jaspersoft.jasperserver.irplugin.ResourcesSet;
/*      */ import com.jaspersoft.jasperserver.irplugin.gui.explorer.ResourceChooser;
/*      */ import com.jaspersoft.jasperserver.irplugin.gui.wizard.NewReportUnitWizard;
/*      */ import com.jaspersoft.jasperserver.irplugin.wsclient.WSClient;
/*      */ import com.jaspersoft.jasperserver.ws.xml.Marshaller;
/*      */ import it.businesslogic.ireport.FontListLoader;
/*      */ import it.businesslogic.ireport.IRFont;
/*      */ import it.businesslogic.ireport.IReportConnection;
/*      */ import it.businesslogic.ireport.Report;
/*      */ import it.businesslogic.ireport.connection.JDBCConnection;
/*      */ import it.businesslogic.ireport.gui.JReportFrame;
/*      */ import it.businesslogic.ireport.gui.MainFrame;
/*      */ import it.businesslogic.ireport.gui.docking.GenericDragTargetListener;
/*      */ import it.businesslogic.ireport.gui.logpane.LogPane;
/*      */ import it.businesslogic.ireport.gui.logpane.LogTextArea;
/*      */ import it.businesslogic.ireport.plugin.IReportPlugin;
/*      */ import it.businesslogic.ireport.util.I18n;
/*      */ import it.businesslogic.ireport.util.LanguageChangedEvent;
/*      */ import it.businesslogic.ireport.util.LanguageChangedListener;
/*      */ import java.awt.BorderLayout;
/*      */ import java.awt.Component;
/*      */ import java.awt.Container;
/*      */ import java.awt.Cursor;
/*      */ import java.awt.Dialog;
/*      */ import java.awt.dnd.DropTarget;
/*      */ import java.awt.event.ActionEvent;
/*      */ import java.awt.event.ActionListener;
/*      */ import java.awt.event.MouseAdapter;
/*      */ import java.awt.event.MouseEvent;
/*      */ import java.io.File;
/*      */ import java.io.PrintStream;
/*      */ import java.io.PrintWriter;
/*      */ import java.io.StringWriter;
/*      */ import java.util.ArrayList;
/*      */ import java.util.Date;
/*      */ import java.util.HashMap;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Properties;
/*      */ import java.util.Vector;
/*      */ import javax.swing.AbstractButton;
/*      */ import javax.swing.ImageIcon;
/*      */ import javax.swing.JButton;
/*      */ import javax.swing.JComponent;
/*      */ import javax.swing.JFileChooser;
/*      */ import javax.swing.JMenu;
/*      */ import javax.swing.JMenuItem;
/*      */ import javax.swing.JOptionPane;
/*      */ import javax.swing.JPanel;
/*      */ import javax.swing.JPopupMenu;
/*      */ import javax.swing.JScrollPane;
/*      */ import javax.swing.JSeparator;
/*      */ import javax.swing.JToolBar;
/*      */ import javax.swing.JTree;
/*      */ import javax.swing.SwingUtilities;
/*      */ import javax.swing.event.TreeSelectionEvent;
/*      */ import javax.swing.event.TreeSelectionListener;
/*      */ import javax.swing.tree.DefaultMutableTreeNode;
/*      */ import javax.swing.tree.DefaultTreeModel;
/*      */ import javax.swing.tree.TreeModel;
/*      */ import javax.swing.tree.TreePath;
/*      */ import javax.swing.tree.TreeSelectionModel;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class RepositoryExplorer
/*      */   extends JPanel
/*      */ {
/*   86 */   private IRPlugin plugin = null;
/*   87 */   private boolean treeEnabled = true;
/*      */   
/*      */ 
/*      */   public RepositoryExplorer(IRPlugin plugin)
/*      */   {
/*   92 */     initComponents();
/*      */     
/*   94 */     this.jTreeRepository.setDragEnabled(true);
/*   95 */     this.jTreeRepository.setTransferHandler(new ReportElementTransferHandler());
/*      */     
/*   97 */     this.jTreeRepository.setDropTarget(new DropTarget(this.jTreeRepository, new GenericDragTargetListener()));
/*   98 */     setPlugin(plugin);
/*   99 */     this.jTreeRepository.setCellRenderer(new RepositoryTreeCellRenderer());
/*  100 */     this.jTreeRepository.getSelectionModel().setSelectionMode(1);
/*      */     
/*  102 */     loadServerList();
/*      */     
/*  104 */     I18n.addOnLanguageChangedListener(new LanguageChangedListener() {
/*      */       public void languageChanged(LanguageChangedEvent languageChangedEvent) {
/*  106 */         RepositoryExplorer.this.applyI18n();
/*  107 */         RepositoryExplorer.this.jTreeRepository.updateUI();
/*      */       }
/*      */       
/*  110 */     });
/*  111 */     applyI18n();
/*      */   }
/*      */   
/*      */ 
/*      */   public void applyI18n()
/*      */   {
/*  117 */     this.jButtonAddServer.setToolTipText(IRPlugin.getString("tooltip.newserver", "Add new server"));
/*  118 */     this.jButtonNewReportUnit.setToolTipText(IRPlugin.getString("tooltip.newreportunit", "Create a new Report Unit"));
/*  119 */     this.jButtonSaveJrxml.setToolTipText(IRPlugin.getString("tooltip.savejrxml", "Save jrxml"));
/*  120 */     this.jButtonRunReport.setToolTipText(IRPlugin.getString("tooltip.runreportunit", "Run Report Unit"));
/*      */     
/*  122 */     this.jMenuAdd.setText(IRPlugin.getString("menu.add", "Add"));
/*  123 */     this.jMenuItemBundle.setText(IRPlugin.getString("menu.bundle", "Resource bundle"));
/*  124 */     this.jMenuItemConnection.setText(IRPlugin.getString("menu.connection", "Import JDBC connection definition"));
/*  125 */     this.jMenuItemDataType.setText(IRPlugin.getString("menu.dataType", "Datatype"));
/*  126 */     this.jMenuItemDatasource.setText(IRPlugin.getString("menu.datasource", "Datasource"));
/*  127 */     this.jMenuItemXMLADatasource.setText(IRPlugin.getString("menu.xmlaConnection", "XMLA Connection"));
/*  128 */     this.jMenuItemDelete.setText(IRPlugin.getString("menu.delete", "Delete"));
/*  129 */     this.jMenuItemEditJRXML.setText(IRPlugin.getString("menu.editJRXML", "Edit JRXML"));
/*  130 */     this.jMenuItemExplore.setText(IRPlugin.getString("menu.explore", "Explore"));
/*  131 */     this.jMenuItemFolder.setText(IRPlugin.getString("menu.folder", "Folder"));
/*  132 */     this.jMenuItemFont.setText(IRPlugin.getString("menu.font", "Font file"));
/*  133 */     this.jMenuItemGet.setText(IRPlugin.getString("menu.get", "Export file"));
/*  134 */     this.jMenuItemImage.setText(IRPlugin.getString("menu.image", "Image"));
/*  135 */     this.jMenuItemImportFont.setText(IRPlugin.getString("menu.importFont", "Add this font to the font list"));
/*  136 */     this.jMenuItemInputControl.setText(IRPlugin.getString("menu.inputControl", "Input control"));
/*  137 */     this.jMenuItemJar.setText(IRPlugin.getString("menu.jar", "Jar archive"));
/*  138 */     this.jMenuItemJrxml.setText(IRPlugin.getString("menu.Jrxml", "JRXML document"));
/*  139 */     this.jMenuItemLinkInputControl.setText(IRPlugin.getString("menu.linkInputControl", "Link an existing input control"));
/*  140 */     this.jMenuItemListOfValues.setText(IRPlugin.getString("menu.listOfValues", "List of values"));
/*  141 */     this.jMenuItemLocalInputControl.setText(IRPlugin.getString("menu.localInputControl", "Create a local input control"));
/*  142 */     this.jMenuItemLogin.setText(IRPlugin.getString("menu.login", "Login"));
/*  143 */     this.jMenuItemNewServer.setText(IRPlugin.getString("menu.newServer", "New server"));
/*  144 */     this.jMenuItemProperties.setText(IRPlugin.getString("menu.properties", "Properties"));
/*  145 */     this.jMenuItemQuery.setText(IRPlugin.getString("menu.query", "Query"));
/*  146 */     this.jMenuItemReference.setText(IRPlugin.getString("menu.reference", "Reference"));
/*  147 */     this.jMenuItemRefresh.setText(IRPlugin.getString("menu.refresh", "Refresh"));
/*  148 */     this.jMenuItemRefreshContent.setText(IRPlugin.getString("menu.refreshContent", "Refresh content"));
/*  149 */     this.jMenuItemReportUnit.setText(IRPlugin.getString("menu.reportUnit", "Report Unit"));
/*  150 */     this.jMenuItemRunRU.setText(IRPlugin.getString("menu.runReportUnit", "Run Report Unit"));
/*  151 */     this.jMenuItemServerDelete.setText(IRPlugin.getString("menu.serverDelete", "Delete server"));
/*  152 */     this.jMenuItemServerSettings.setText(IRPlugin.getString("menu.serverSettings", "Server settings"));
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void loadServerList()
/*      */   {
/*  163 */     this.jTreeRepository.removeAll();
/*  164 */     DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode();
/*  165 */     ((DefaultTreeModel)this.jTreeRepository.getModel()).setRoot(rootNode);
/*      */     
/*  167 */     for (int i = 0; i < getPlugin().getJServers().size(); i++)
/*      */     {
/*  169 */       JServer server = (JServer)getPlugin().getJServers().get(i);
/*  170 */       DefaultMutableTreeNode serverNode = new DefaultMutableTreeNode(server);
/*  171 */       rootNode.add(serverNode);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*  176 */     this.jTreeRepository.updateUI();
/*      */   }
/*      */   
/*      */   public IRPlugin getPlugin() {
/*  180 */     return this.plugin;
/*      */   }
/*      */   
/*      */   public void setPlugin(IRPlugin plugin) {
/*  184 */     this.plugin = plugin;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void updateToolBar()
/*      */   {
/*  193 */     TreePath path = this.jTreeRepository.getSelectionPath();
/*  194 */     if (path == null) { return;
/*      */     }
/*  196 */     this.jButtonSaveJrxml.setEnabled(false);
/*  197 */     this.jButtonNewReportUnit.setEnabled(false);
/*  198 */     this.jButtonRunReport.setEnabled(false);
/*      */     
/*  200 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*      */ 
/*      */ 
/*  204 */     if ((selectedNode.getUserObject() instanceof RepositoryJrxmlFile))
/*      */     {
/*  206 */       RepositoryJrxmlFile rf = (RepositoryJrxmlFile)selectedNode.getUserObject();
/*  207 */       if (rf.getReportFrame() != null)
/*      */       {
/*  209 */         this.jButtonSaveJrxml.setEnabled(true);
/*      */       }
/*      */     }
/*      */     
/*  213 */     if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/*  215 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/*  216 */       if (rf.getDescriptor().getWsType().equals("folder"))
/*      */       {
/*      */ 
/*  219 */         this.jButtonNewReportUnit.setEnabled(true);
/*      */       }
/*      */       
/*  222 */       if (rf.getDescriptor().getWsType().equals("ReportOptionsResource"))
/*      */       {
/*  224 */         this.jButtonRunReport.setEnabled(true);
/*      */       }
/*      */     }
/*      */     
/*  228 */     if (getParentReportUnit(selectedNode) != null)
/*      */     {
/*  230 */       this.jButtonRunReport.setEnabled(true);
/*      */ 
/*      */     }
/*  233 */     else if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/*  235 */       this.jButtonNewReportUnit.setEnabled(true);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private void initComponents()
/*      */   {
/*  246 */     this.jPopupMenuServer = new JPopupMenu();
/*  247 */     this.jMenuItemRunRU = new JMenuItem();
/*  248 */     this.jMenuItemEditJRXML = new JMenuItem();
/*  249 */     this.jMenuItemConnection = new JMenuItem();
/*  250 */     this.jMenuItemImportFont = new JMenuItem();
/*  251 */     this.jMenuItemExplore = new JMenuItem();
/*  252 */     this.jMenuItemGet = new JMenuItem();
/*  253 */     this.jMenuItemDelete = new JMenuItem();
/*  254 */     this.jSeparator3 = new JSeparator();
/*  255 */     this.jMenuAdd = new JMenu();
/*  256 */     this.jMenuItemReportUnit = new JMenuItem();
/*  257 */     this.jSeparator5 = new JSeparator();
/*  258 */     this.jMenuItemFolder = new JMenuItem();
/*  259 */     this.jMenuItemReference = new JMenuItem();
/*  260 */     this.jSeparator4 = new JSeparator();
/*  261 */     this.jMenuItemImage = new JMenuItem();
/*  262 */     this.jMenuItemBundle = new JMenuItem();
/*  263 */     this.jMenuItemJrxml = new JMenuItem();
/*  264 */     this.jMenuItemJar = new JMenuItem();
/*  265 */     this.jMenuItemFont = new JMenuItem();
/*  266 */     this.jSeparator6 = new JSeparator();
/*  267 */     this.jMenuItemDatasource = new JMenuItem();
/*  268 */     this.jMenuItemXMLADatasource = new JMenuItem();
/*  269 */     this.jSeparator7 = new JSeparator();
/*  270 */     this.jMenuItemDataType = new JMenuItem();
/*  271 */     this.jMenuItemListOfValues = new JMenuItem();
/*  272 */     this.jMenuItemQuery = new JMenuItem();
/*  273 */     this.jMenuItemInputControl = new JMenuItem();
/*  274 */     this.jSeparator1 = new JSeparator();
/*  275 */     this.jMenuItemLogin = new JMenuItem();
/*  276 */     this.jMenuItemNewServer = new JMenuItem();
/*  277 */     this.jMenuItemServerSettings = new JMenuItem();
/*  278 */     this.jMenuItemServerDelete = new JMenuItem();
/*  279 */     this.jSeparator2 = new JSeparator();
/*  280 */     this.jMenuItemRefresh = new JMenuItem();
/*  281 */     this.jMenuItemRefreshContent = new JMenuItem();
/*  282 */     this.jMenuItemProperties = new JMenuItem();
/*  283 */     this.jPopupMenuRUInputControls = new JPopupMenu();
/*  284 */     this.jMenuItemLocalInputControl = new JMenuItem();
/*  285 */     this.jMenuItemLinkInputControl = new JMenuItem();
/*  286 */     this.jToolBar1 = new JToolBar();
/*  287 */     this.jButtonAddServer = new JButton();
/*  288 */     this.jButtonNewReportUnit = new JButton();
/*  289 */     this.jButtonSaveJrxml = new JButton();
/*  290 */     this.jButtonRunReport = new JButton();
/*  291 */     this.jScrollPane1 = new JScrollPane();
/*  292 */     this.jTreeRepository = new JTree();
/*      */     
/*  294 */     this.jPopupMenuServer.addMouseListener(new MouseAdapter() {
/*      */       public void mouseClicked(MouseEvent evt) {
/*  296 */         RepositoryExplorer.this.jPopupMenuServerMouseClicked(evt);
/*      */       }
/*      */       
/*  299 */     });
/*  300 */     this.jMenuItemRunRU.setText("Run Report Unit");
/*  301 */     this.jMenuItemRunRU.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  303 */         RepositoryExplorer.this.jMenuItemRunRUActionPerformed(evt);
/*      */       }
/*      */       
/*  306 */     });
/*  307 */     this.jPopupMenuServer.add(this.jMenuItemRunRU);
/*      */     
/*  309 */     this.jMenuItemEditJRXML.setText("Edit JRXML");
/*  310 */     this.jMenuItemEditJRXML.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  312 */         RepositoryExplorer.this.jMenuItemEditJRXMLActionPerformed(evt);
/*      */       }
/*      */       
/*  315 */     });
/*  316 */     this.jPopupMenuServer.add(this.jMenuItemEditJRXML);
/*      */     
/*  318 */     this.jMenuItemConnection.setText("Import JDBC connection definition");
/*  319 */     this.jMenuItemConnection.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  321 */         RepositoryExplorer.this.jMenuItemConnectionActionPerformed(evt);
/*      */       }
/*      */       
/*  324 */     });
/*  325 */     this.jPopupMenuServer.add(this.jMenuItemConnection);
/*      */     
/*  327 */     this.jMenuItemImportFont.setText("Add this font to the font list");
/*  328 */     this.jMenuItemImportFont.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  330 */         RepositoryExplorer.this.jMenuItemImportFontActionPerformed(evt);
/*      */       }
/*      */       
/*  333 */     });
/*  334 */     this.jPopupMenuServer.add(this.jMenuItemImportFont);
/*      */     
/*  336 */     this.jMenuItemExplore.setText("Explore");
/*  337 */     this.jMenuItemExplore.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  339 */         RepositoryExplorer.this.jMenuItemExploreActionPerformed(evt);
/*      */       }
/*      */       
/*  342 */     });
/*  343 */     this.jPopupMenuServer.add(this.jMenuItemExplore);
/*      */     
/*  345 */     this.jMenuItemGet.setText("Export file");
/*  346 */     this.jMenuItemGet.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  348 */         RepositoryExplorer.this.jMenuItemGetActionPerformed(evt);
/*      */       }
/*      */       
/*  351 */     });
/*  352 */     this.jPopupMenuServer.add(this.jMenuItemGet);
/*      */     
/*  354 */     this.jMenuItemDelete.setText("Delete");
/*  355 */     this.jMenuItemDelete.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  357 */         RepositoryExplorer.this.jMenuItemDeleteActionPerformed(evt);
/*      */       }
/*      */       
/*  360 */     });
/*  361 */     this.jPopupMenuServer.add(this.jMenuItemDelete);
/*      */     
/*  363 */     this.jPopupMenuServer.add(this.jSeparator3);
/*      */     
/*  365 */     this.jMenuAdd.setText("Add");
/*  366 */     this.jMenuItemReportUnit.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/reportunit.png")));
/*  367 */     this.jMenuItemReportUnit.setText("Report Unit");
/*  368 */     this.jMenuItemReportUnit.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  370 */         RepositoryExplorer.this.jMenuItemReportUnitActionPerformed(evt);
/*      */       }
/*      */       
/*  373 */     });
/*  374 */     this.jMenuAdd.add(this.jMenuItemReportUnit);
/*      */     
/*  376 */     this.jMenuAdd.add(this.jSeparator5);
/*      */     
/*  378 */     this.jMenuItemFolder.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/folder.png")));
/*  379 */     this.jMenuItemFolder.setText("Folder");
/*  380 */     this.jMenuItemFolder.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  382 */         RepositoryExplorer.this.jMenuItemFolderActionPerformed(evt);
/*      */       }
/*      */       
/*  385 */     });
/*  386 */     this.jMenuAdd.add(this.jMenuItemFolder);
/*      */     
/*  388 */     this.jMenuItemReference.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/link.png")));
/*  389 */     this.jMenuItemReference.setText("Reference");
/*  390 */     this.jMenuItemReference.setEnabled(false);
/*  391 */     this.jMenuItemReference.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  393 */         RepositoryExplorer.this.jMenuItemReferenceActionPerformed(evt);
/*      */       }
/*      */       
/*  396 */     });
/*  397 */     this.jMenuAdd.add(this.jMenuItemReference);
/*      */     
/*  399 */     this.jMenuAdd.add(this.jSeparator4);
/*      */     
/*  401 */     this.jMenuItemImage.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/picture.png")));
/*  402 */     this.jMenuItemImage.setText("Image");
/*  403 */     this.jMenuItemImage.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  405 */         RepositoryExplorer.this.jMenuItemImageActionPerformed(evt);
/*      */       }
/*      */       
/*  408 */     });
/*  409 */     this.jMenuAdd.add(this.jMenuItemImage);
/*      */     
/*  411 */     this.jMenuItemBundle.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/bundle.png")));
/*  412 */     this.jMenuItemBundle.setText("Resource bundle");
/*  413 */     this.jMenuItemBundle.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  415 */         RepositoryExplorer.this.jMenuItemBundleActionPerformed(evt);
/*      */       }
/*      */       
/*  418 */     });
/*  419 */     this.jMenuAdd.add(this.jMenuItemBundle);
/*      */     
/*  421 */     this.jMenuItemJrxml.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/jrxml_file.png")));
/*  422 */     this.jMenuItemJrxml.setText("JRXML document");
/*  423 */     this.jMenuItemJrxml.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  425 */         RepositoryExplorer.this.jMenuItemJrxmlActionPerformed(evt);
/*      */       }
/*      */       
/*  428 */     });
/*  429 */     this.jMenuAdd.add(this.jMenuItemJrxml);
/*      */     
/*  431 */     this.jMenuItemJar.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/jar.png")));
/*  432 */     this.jMenuItemJar.setText("Jar archive");
/*  433 */     this.jMenuItemJar.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  435 */         RepositoryExplorer.this.jMenuItemJarActionPerformed(evt);
/*      */       }
/*      */       
/*  438 */     });
/*  439 */     this.jMenuAdd.add(this.jMenuItemJar);
/*      */     
/*  441 */     this.jMenuItemFont.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/font.png")));
/*  442 */     this.jMenuItemFont.setText("Font file");
/*  443 */     this.jMenuItemFont.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  445 */         RepositoryExplorer.this.jMenuItemFontActionPerformed(evt);
/*      */       }
/*      */       
/*  448 */     });
/*  449 */     this.jMenuAdd.add(this.jMenuItemFont);
/*      */     
/*  451 */     this.jMenuAdd.add(this.jSeparator6);
/*      */     
/*  453 */     this.jMenuItemDatasource.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/datasource.png")));
/*  454 */     this.jMenuItemDatasource.setText("Datasource");
/*  455 */     this.jMenuItemDatasource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  457 */         RepositoryExplorer.this.jMenuItemDataSourceActionPerformed(evt);
/*      */       }
/*      */       
/*  460 */     });
/*  461 */     this.jMenuAdd.add(this.jMenuItemDatasource);
/*      */     
/*  463 */     this.jMenuItemXMLADatasource.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/datasource.png")));
/*  464 */     this.jMenuItemXMLADatasource.setText("XMLA Connection");
/*  465 */     this.jMenuItemXMLADatasource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  467 */         RepositoryExplorer.this.jMenuItemDatasourcejMenuItemDataSourceActionPerformed1(evt);
/*      */       }
/*      */       
/*  470 */     });
/*  471 */     this.jMenuAdd.add(this.jMenuItemXMLADatasource);
/*      */     
/*  473 */     this.jMenuAdd.add(this.jSeparator7);
/*      */     
/*  475 */     this.jMenuItemDataType.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/datatype.png")));
/*  476 */     this.jMenuItemDataType.setText("Datatype");
/*  477 */     this.jMenuItemDataType.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  479 */         RepositoryExplorer.this.jMenuItemDatasourcejMenuItemDataSourceActionPerformed(evt);
/*      */       }
/*      */       
/*  482 */     });
/*  483 */     this.jMenuAdd.add(this.jMenuItemDataType);
/*      */     
/*  485 */     this.jMenuItemListOfValues.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/lov.png")));
/*  486 */     this.jMenuItemListOfValues.setText("List of values");
/*  487 */     this.jMenuItemListOfValues.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  489 */         RepositoryExplorer.this.jMenuItemDataTypejMenuItemDatasourcejMenuItemDataSourceActionPerformed(evt);
/*      */       }
/*      */       
/*  492 */     });
/*  493 */     this.jMenuAdd.add(this.jMenuItemListOfValues);
/*      */     
/*  495 */     this.jMenuItemQuery.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/query.png")));
/*  496 */     this.jMenuItemQuery.setText("Query");
/*  497 */     this.jMenuItemQuery.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  499 */         RepositoryExplorer.this.jMenuItemQueryActionPerformed(evt);
/*      */       }
/*      */       
/*  502 */     });
/*  503 */     this.jMenuAdd.add(this.jMenuItemQuery);
/*      */     
/*  505 */     this.jMenuItemInputControl.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/inputcontrol.png")));
/*  506 */     this.jMenuItemInputControl.setText("Input control");
/*  507 */     this.jMenuItemInputControl.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  509 */         RepositoryExplorer.this.jMenuItemInputControlActionPerformed(evt);
/*      */       }
/*      */       
/*  512 */     });
/*  513 */     this.jMenuAdd.add(this.jMenuItemInputControl);
/*      */     
/*  515 */     this.jPopupMenuServer.add(this.jMenuAdd);
/*      */     
/*  517 */     this.jPopupMenuServer.add(this.jSeparator1);
/*      */     
/*  519 */     this.jMenuItemLogin.setText("Login");
/*  520 */     this.jMenuItemLogin.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  522 */         RepositoryExplorer.this.jMenuItemLoginActionPerformed(evt);
/*      */       }
/*      */       
/*  525 */     });
/*  526 */     this.jPopupMenuServer.add(this.jMenuItemLogin);
/*      */     
/*  528 */     this.jMenuItemNewServer.setText("New server");
/*  529 */     this.jMenuItemNewServer.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  531 */         RepositoryExplorer.this.jMenuItemNewServerActionPerformed(evt);
/*      */       }
/*      */       
/*  534 */     });
/*  535 */     this.jPopupMenuServer.add(this.jMenuItemNewServer);
/*      */     
/*  537 */     this.jMenuItemServerSettings.setText("Server settings");
/*  538 */     this.jMenuItemServerSettings.setEnabled(false);
/*  539 */     this.jMenuItemServerSettings.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  541 */         RepositoryExplorer.this.jMenuItemServerSettingsActionPerformed(evt);
/*      */       }
/*      */       
/*  544 */     });
/*  545 */     this.jPopupMenuServer.add(this.jMenuItemServerSettings);
/*      */     
/*  547 */     this.jMenuItemServerDelete.setText("Delete server");
/*  548 */     this.jMenuItemServerDelete.setEnabled(false);
/*  549 */     this.jMenuItemServerDelete.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  551 */         RepositoryExplorer.this.jMenuItemServerDeleteActionPerformed(evt);
/*      */       }
/*      */       
/*  554 */     });
/*  555 */     this.jPopupMenuServer.add(this.jMenuItemServerDelete);
/*      */     
/*  557 */     this.jPopupMenuServer.add(this.jSeparator2);
/*      */     
/*  559 */     this.jMenuItemRefresh.setText("Refresh");
/*  560 */     this.jMenuItemRefresh.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  562 */         RepositoryExplorer.this.jMenuItemRefreshActionPerformed(evt);
/*      */       }
/*      */       
/*  565 */     });
/*  566 */     this.jPopupMenuServer.add(this.jMenuItemRefresh);
/*      */     
/*  568 */     this.jMenuItemRefreshContent.setText("Refresh content");
/*  569 */     this.jMenuItemRefreshContent.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  571 */         RepositoryExplorer.this.jMenuItemRefreshContentActionPerformed(evt);
/*      */       }
/*      */       
/*  574 */     });
/*  575 */     this.jPopupMenuServer.add(this.jMenuItemRefreshContent);
/*      */     
/*  577 */     this.jMenuItemProperties.setText("Properties");
/*  578 */     this.jMenuItemProperties.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  580 */         RepositoryExplorer.this.jMenuItemPropertiesActionPerformed(evt);
/*      */       }
/*      */       
/*  583 */     });
/*  584 */     this.jPopupMenuServer.add(this.jMenuItemProperties);
/*      */     
/*  586 */     this.jMenuItemLocalInputControl.setText("Create a local input control");
/*  587 */     this.jMenuItemLocalInputControl.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  589 */         RepositoryExplorer.this.jMenuItemLocalInputControlActionPerformed(evt);
/*      */       }
/*      */       
/*  592 */     });
/*  593 */     this.jPopupMenuRUInputControls.add(this.jMenuItemLocalInputControl);
/*      */     
/*  595 */     this.jMenuItemLinkInputControl.setText("Link an existing input control");
/*  596 */     this.jMenuItemLinkInputControl.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  598 */         RepositoryExplorer.this.jMenuItemLinkInputControlActionPerformed(evt);
/*      */       }
/*      */       
/*  601 */     });
/*  602 */     this.jPopupMenuRUInputControls.add(this.jMenuItemLinkInputControl);
/*      */     
/*  604 */     setLayout(new BorderLayout());
/*      */     
/*  606 */     this.jButtonAddServer.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/server_add.png")));
/*  607 */     this.jButtonAddServer.setText("\n");
/*  608 */     this.jButtonAddServer.setToolTipText("Add new server");
/*  609 */     this.jButtonAddServer.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  611 */         RepositoryExplorer.this.jButtonAddServerActionPerformed(evt);
/*      */       }
/*      */       
/*  614 */     });
/*  615 */     this.jToolBar1.add(this.jButtonAddServer);
/*      */     
/*  617 */     this.jButtonNewReportUnit.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/publish.png")));
/*  618 */     this.jButtonNewReportUnit.setToolTipText("Create a new Report Unit");
/*  619 */     this.jButtonNewReportUnit.setEnabled(false);
/*  620 */     this.jButtonNewReportUnit.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  622 */         RepositoryExplorer.this.jButtonPublishReportActionPerformed1(evt);
/*      */       }
/*      */       
/*  625 */     });
/*  626 */     this.jToolBar1.add(this.jButtonNewReportUnit);
/*      */     
/*  628 */     this.jButtonSaveJrxml.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/upload_jrxml.png")));
/*  629 */     this.jButtonSaveJrxml.setToolTipText("Save jrxml");
/*  630 */     this.jButtonSaveJrxml.setEnabled(false);
/*  631 */     this.jButtonSaveJrxml.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  633 */         RepositoryExplorer.this.jButtonSaveJrxmlActionPerformed(evt);
/*      */       }
/*      */       
/*  636 */     });
/*  637 */     this.jToolBar1.add(this.jButtonSaveJrxml);
/*      */     
/*  639 */     this.jButtonRunReport.setIcon(new ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/run_report.png")));
/*  640 */     this.jButtonRunReport.setToolTipText("Run Report Unit");
/*  641 */     this.jButtonRunReport.setEnabled(false);
/*  642 */     this.jButtonRunReport.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  644 */         RepositoryExplorer.this.jButtonRunReportActionPerformed(evt);
/*      */       }
/*      */       
/*  647 */     });
/*  648 */     this.jToolBar1.add(this.jButtonRunReport);
/*      */     
/*  650 */     add(this.jToolBar1, "North");
/*      */     
/*  652 */     this.jTreeRepository.setRootVisible(false);
/*  653 */     this.jTreeRepository.addTreeSelectionListener(new TreeSelectionListener() {
/*      */       public void valueChanged(TreeSelectionEvent evt) {
/*  655 */         RepositoryExplorer.this.jTreeRepositoryValueChanged(evt);
/*      */       }
/*  657 */     });
/*  658 */     this.jTreeRepository.addMouseListener(new MouseAdapter() {
/*      */       public void mouseClicked(MouseEvent evt) {
/*  660 */         RepositoryExplorer.this.jTreeRepositoryMouseClicked(evt);
/*      */       }
/*      */       
/*  663 */     });
/*  664 */     this.jScrollPane1.setViewportView(this.jTreeRepository);
/*      */     
/*  666 */     add(this.jScrollPane1, "Center");
/*      */   }
/*      */   
/*      */   private void jMenuItemDatasourcejMenuItemDataSourceActionPerformed1(ActionEvent evt)
/*      */   {
/*  671 */     newResource("olapXmlaCon");
/*      */   }
/*      */   
/*      */   private void jMenuItemQueryActionPerformed(ActionEvent evt) {
/*  675 */     newResource("query");
/*      */   }
/*      */   
/*      */   private void jMenuItemRunRUActionPerformed(ActionEvent evt)
/*      */   {
/*  680 */     jButtonRunReportActionPerformed(evt);
/*      */   }
/*      */   
/*      */   private void jButtonRunReportActionPerformed(ActionEvent evt)
/*      */   {
/*  685 */     TreePath path = this.jTreeRepository.getSelectionPath();
/*  686 */     if (path == null) return;
/*  687 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*  689 */     RepositoryReportUnit reportUnit = null;
/*  690 */     ResourceDescriptor optionsRd = null;
/*  691 */     HashMap defaultValues = new HashMap();
/*  692 */     if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/*  694 */       if (((RepositoryFolder)selectedNode.getUserObject()).getDescriptor().getWsType().equals("ReportOptionsResource")) {
/*      */         try
/*      */         {
/*  697 */           optionsRd = ((RepositoryFolder)selectedNode.getUserObject()).getDescriptor();
/*  698 */           String ruURI = optionsRd.getResourcePropertyValue("PROP_RU_URI");
/*  699 */           ResourceDescriptor reportRd = new ResourceDescriptor();
/*  700 */           reportRd.setUriString(ruURI);
/*  701 */           reportRd = ((RepositoryFolder)selectedNode.getUserObject()).getServer().getWSClient().get(reportRd, null);
/*  702 */           reportUnit = new RepositoryReportUnit(((RepositoryFolder)selectedNode.getUserObject()).getServer(), reportRd);
/*  703 */           reportUnit.setLoaded(false);
/*      */           
/*      */ 
/*  706 */           ResourceProperty rp = optionsRd.getResourceProperty("PROP_VALUES");
/*      */           
/*  708 */           List list = rp.getProperties();
/*  709 */           if (list != null)
/*      */           {
/*  711 */             for (int i = 0; i < list.size(); i++)
/*      */             {
/*  713 */               ResourceProperty li = (ResourceProperty)list.get(i);
/*  714 */               String value = li.getValue() == null ? "" : li.getValue();
/*  715 */               if (li.getProperties().size() > 0)
/*      */               {
/*  717 */                 ArrayList listVal = new ArrayList();
/*  718 */                 for (int k = 0; k < li.getProperties().size(); k++)
/*      */                 {
/*  720 */                   ResourceProperty sli = (ResourceProperty)li.getProperties().get(k);
/*  721 */                   listVal.add(sli.getValue());
/*      */                 }
/*      */                 
/*  724 */                 defaultValues.put(li.getName(), listVal);
/*      */               }
/*      */               else
/*      */               {
/*  728 */                 defaultValues.put(li.getName(), value);
/*      */               }
/*      */               
/*      */             }
/*      */           }
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/*  736 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*  742 */     if (reportUnit == null)
/*      */     {
/*  744 */       reportUnit = getParentReportUnit(selectedNode);
/*      */     }
/*      */     
/*  747 */     if (reportUnit != null)
/*      */     {
/*  749 */       JServer server = reportUnit.getServer();
/*  750 */       LogTextArea lta = MainFrame.getMainInstance().getLogPane().createNewLog();
/*  751 */       lta.setTitle(IRPlugin.getFormattedString("repositoryExplorer.message.runningReport", "Running {0}", new Object[] { reportUnit.getDescriptor().getName() }));
/*  752 */       MainFrame.getMainInstance().getLogPane().setActiveLog(lta);
/*      */       
/*      */       try
/*      */       {
/*  756 */         List list = server.getWSClient().list(reportUnit.getDescriptor());
/*      */         
/*  758 */         String dsUri = null;
/*      */         
/*  760 */         List inputcontrols = new ArrayList();
/*      */         
/*  762 */         for (int i = 0; i < list.size(); i++)
/*      */         {
/*  764 */           ResourceDescriptor sub_rd = (ResourceDescriptor)list.get(i);
/*  765 */           if (sub_rd.getWsType().equals("inputControl"))
/*      */           {
/*  767 */             inputcontrols.add(sub_rd);
/*      */           }
/*  769 */           else if (sub_rd.getWsType().equals("datasource"))
/*      */           {
/*  771 */             dsUri = sub_rd.getReferenceUri();
/*      */           }
/*  773 */           else if (isDataSource(sub_rd))
/*      */           {
/*  775 */             dsUri = sub_rd.getUriString();
/*      */           }
/*      */         }
/*      */         
/*      */ 
/*      */ 
/*  781 */         for (int i = 0; i < inputcontrols.size(); i++)
/*      */         {
/*  783 */           ResourceDescriptor ic = (ResourceDescriptor)inputcontrols.get(i);
/*      */           
/*      */ 
/*  786 */           if ((ic.getControlType() == 4) || (ic.getControlType() == 9) || (ic.getControlType() == 7) || (ic.getControlType() == 11))
/*      */           {
/*      */ 
/*      */ 
/*      */ 
/*  791 */             String dsUriQuery = null;
/*  792 */             inputcontrols.remove(ic);
/*      */             
/*  794 */             System.out.println("Looking for the right ds...");
/*      */             
/*  796 */             List args = new ArrayList();
/*      */             
/*      */ 
/*  799 */             for (int k = 0; (dsUriQuery == null) && (k < ic.getChildren().size()); k++)
/*      */             {
/*  801 */               ResourceDescriptor sub_ic = (ResourceDescriptor)ic.getChildren().get(k);
/*  802 */               System.out.println("Found child..." + sub_ic.getName() + " (" + sub_ic.getWsType() + ")");
/*  803 */               if (sub_ic.getWsType().equals("query"))
/*      */               {
/*  805 */                 System.out.println("Found the query child...");
/*      */                 
/*  807 */                 for (int k2 = 0; k2 < sub_ic.getChildren().size(); k2++)
/*      */                 {
/*  809 */                   ResourceDescriptor sub_sub_ic = (ResourceDescriptor)sub_ic.getChildren().get(k2);
/*  810 */                   if (isDataSource(sub_sub_ic))
/*      */                   {
/*  812 */                     System.out.println("Found the ds child...");
/*  813 */                     dsUriQuery = sub_sub_ic.getUriString();
/*      */                     
/*  815 */                     break;
/*      */                   }
/*      */                 }
/*      */               }
/*      */             }
/*  820 */             if (dsUriQuery == null) dsUriQuery = dsUri;
/*  821 */             System.out.println("Using..." + dsUriQuery);
/*  822 */             ic.setResourceProperty("PROP_QUERY_DATA", null);
/*  823 */             args.add(new Argument("IC_GET_QUERY_DATA", dsUriQuery));
/*  824 */             ic = server.getWSClient().get(ic, null, args);
/*      */             
/*  826 */             inputcontrols.add(i, ic);
/*      */           }
/*      */         }
/*  829 */         Map map = null;
/*  830 */         if (inputcontrols.size() > 0)
/*      */         {
/*  832 */           ReportUnitRunDialog rurd = new ReportUnitRunDialog(MainFrame.getMainInstance(), true);
/*  833 */           rurd.setServer(server);
/*  834 */           rurd.setInputControls(inputcontrols, defaultValues);
/*      */           
/*  836 */           rurd.setVisible(true);
/*  837 */           if (rurd.getDialogResult() == 0)
/*      */           {
/*  839 */             map = rurd.getParametersValues();
/*      */           }
/*      */           else {
/*      */             return;
/*      */           }
/*      */           
/*      */         }
/*      */         else
/*      */         {
/*  848 */           map = new HashMap();
/*      */         }
/*      */         
/*      */ 
/*  852 */         ReportRunner rr = new ReportRunner();
/*  853 */         rr.setLta(lta);
/*  854 */         rr.setMap(map);
/*  855 */         rr.setReportUnit(reportUnit);
/*  856 */         rr.setServer(server);
/*      */         
/*  858 */         Thread t = new Thread(rr);
/*  859 */         t.start();
/*      */ 
/*      */       }
/*      */       catch (Exception ex)
/*      */       {
/*  864 */         StringWriter sw = new StringWriter();
/*  865 */         ex.printStackTrace(new PrintWriter(sw));
/*  866 */         sw.flush();
/*  867 */         lta.logOnConsole(sw.toString(), false);
/*  868 */         ex.printStackTrace();
/*      */       }
/*      */       finally
/*      */       {
/*  872 */         lta.setRemovable(true);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemLinkInputControlActionPerformed(ActionEvent evt)
/*      */   {
/*  881 */     ResourceChooser rc = new ResourceChooser();
/*      */     
/*  883 */     TreePath path = this.jTreeRepository.getSelectionPath();
/*  884 */     if (path == null) return;
/*  885 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*      */ 
/*  888 */     JServer server = null;
/*      */     
/*  890 */     String reportUnitUri = null;
/*      */     
/*  892 */     if ((selectedNode.getUserObject() instanceof ControlsSet))
/*      */     {
/*  894 */       RepositoryFolder rf = ((ControlsSet)selectedNode.getUserObject()).getReportUnit();
/*  895 */       rc.setServer(rf.getServer());
/*  896 */       reportUnitUri = rf.getDescriptor().getUriString();
/*      */       
/*  898 */       if (rc.showDialog(this, null) == 0)
/*      */       {
/*  900 */         ResourceDescriptor rd = rc.getSelectedDescriptor();
/*  901 */         if ((rd == null) || (rd.getUriString() == null))
/*      */         {
/*  903 */           return;
/*      */         }
/*      */         
/*  906 */         if (!rd.getWsType().equals("inputControl"))
/*      */         {
/*  908 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("repositoryExplorer.message.invalidInputControl", "{0} is not an Input Control!", new Object[] { rd.getName() }), "", 0);
/*      */           
/*      */ 
/*  911 */           return;
/*      */         }
/*      */         
/*  914 */         ResourceDescriptor newRd = new ResourceDescriptor();
/*  915 */         newRd.setWsType("inputControl");
/*  916 */         newRd.setIsReference(true);
/*  917 */         newRd.setReferenceUri(rd.getUriString());
/*  918 */         newRd.setIsNew(true);
/*  919 */         newRd.setUriString(reportUnitUri + "/<cotnrols>");
/*      */         try {
/*  921 */           newRd = rf.getServer().getWSClient().modifyReportUnitResource(reportUnitUri, newRd, null);
/*      */           
/*  923 */           addChild(selectedNode, rf.getServer(), newRd);
/*      */           
/*  925 */           if (!this.jTreeRepository.isExpanded(path))
/*      */           {
/*  927 */             this.jTreeRepository.expandPath(path);
/*      */           }
/*  929 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         catch (Exception ex) {
/*  932 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/*  933 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemLocalInputControlActionPerformed(ActionEvent evt)
/*      */   {
/*  943 */     newResource("inputControl");
/*      */   }
/*      */   
/*      */   private void jMenuItemInputControlActionPerformed(ActionEvent evt)
/*      */   {
/*  948 */     newResource("inputControl");
/*      */   }
/*      */   
/*      */   private void jMenuItemDataTypejMenuItemDatasourcejMenuItemDataSourceActionPerformed(ActionEvent evt) {
/*  952 */     newResource("lov");
/*      */   }
/*      */   
/*      */   private void jMenuItemDatasourcejMenuItemDataSourceActionPerformed(ActionEvent evt) {
/*  956 */     newResource("dataType");
/*      */   }
/*      */   
/*      */   private void jMenuItemReferenceActionPerformed(ActionEvent evt)
/*      */   {
/*  961 */     newResource("reference");
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemDataSourceActionPerformed(ActionEvent evt)
/*      */   {
/*  967 */     newResource("datasource");
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemImportFontActionPerformed(ActionEvent evt)
/*      */   {
/*  973 */     TreePath path = this.jTreeRepository.getSelectionPath();
/*  974 */     if (path == null) return;
/*  975 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*  977 */     if ((selectedNode.getUserObject() instanceof RepositoryFile))
/*      */     {
/*  979 */       RepositoryFile repoFile = (RepositoryFile)selectedNode.getUserObject();
/*  980 */       if (repoFile.getDescriptor().getWsType().equals("font"))
/*      */       {
/*  982 */         Vector currentFonts = MainFrame.getMainInstance().getTtfFonts();
/*  983 */         for (int i = 0; i < currentFonts.size(); i++)
/*      */         {
/*  985 */           IRFont irfont = (IRFont)currentFonts.elementAt(i);
/*  986 */           if ((irfont.getFile() + "").equals("repo:" + repoFile.getDescriptor().getUriString()))
/*      */           {
/*  988 */             return;
/*      */           }
/*      */         }
/*      */         
/*      */         try
/*      */         {
/*  994 */           String fontFile = repoFile.getFile();
/*  995 */           if (fontFile != null)
/*      */           {
/*      */ 
/*  998 */             IRFont newFont = new IRFont(FontListLoader.loadFont(fontFile), "repo:" + repoFile.getDescriptor().getUriString());
/*  999 */             MainFrame.getMainInstance().getTtfFonts().add(newFont);
/* 1000 */             MainFrame.getMainInstance().updateFontsLists();
/*      */           }
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/* 1005 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1006 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemConnectionActionPerformed(ActionEvent evt)
/*      */   {
/* 1015 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1016 */     if (path == null) return;
/* 1017 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1019 */     if ((selectedNode.getUserObject() instanceof RepositoryFile))
/*      */     {
/* 1021 */       RepositoryFile rf = (RepositoryFile)selectedNode.getUserObject();
/* 1022 */       if (rf.getDescriptor().getWsType().equals("jdbc"))
/*      */       {
/* 1024 */         Vector v = MainFrame.getMainInstance().getConnections();
/*      */         
/* 1026 */         int index = -1;
/* 1027 */         for (int i = 0; i < v.size(); i++)
/*      */         {
/* 1029 */           IReportConnection con = (IReportConnection)v.elementAt(i);
/* 1030 */           if (con.getName().equals(rf.getDescriptor().getLabel()))
/*      */           {
/* 1032 */             if (JOptionPane.showConfirmDialog(this, IRPlugin.getFormattedString("repositoryExplorer.message.duplicatedConnectionName", "A connection named {0} is already present.\nWould you like to replace the existing connection?", new Object[] { rf.getDescriptor().getLabel() })) != 0)
/*      */             {
/*      */ 
/*      */ 
/*      */ 
/* 1037 */               return;
/*      */             }
/*      */             
/*      */ 
/* 1041 */             index = i;
/* 1042 */             break;
/*      */           }
/*      */         }
/*      */         
/*      */ 
/* 1047 */         JDBCConnection jdbcConnection = new JDBCConnection();
/* 1048 */         jdbcConnection.setName(rf.getDescriptor().getLabel());
/* 1049 */         jdbcConnection.setUrl(rf.getDescriptor().getConnectionUrl());
/* 1050 */         jdbcConnection.setJDBCDriver(rf.getDescriptor().getDriverClass());
/* 1051 */         jdbcConnection.setUsername(rf.getDescriptor().getUsername());
/* 1052 */         jdbcConnection.setPassword(rf.getDescriptor().getPassword());
/*      */         
/* 1054 */         if (index >= 0)
/*      */         {
/* 1056 */           MainFrame.getMainInstance().getConnections().setElementAt(jdbcConnection, index);
/*      */         }
/*      */         else
/*      */         {
/* 1060 */           MainFrame.getMainInstance().getConnections().add(jdbcConnection);
/*      */         }
/* 1062 */         MainFrame.getMainInstance().setActiveConnection(jdbcConnection);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void jMenuItemReportUnitActionPerformed(ActionEvent evt)
/*      */   {
/* 1069 */     jButtonPublishReportActionPerformed1(evt);
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemDeleteActionPerformed(ActionEvent evt)
/*      */   {
/* 1075 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1076 */     if (path == null) return;
/* 1077 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1079 */     if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1081 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/*      */       
/* 1083 */       String reportUnitUri = null;
/*      */       
/* 1085 */       String msg = IRPlugin.getFormattedString("repositoryExplorer.message.confirmDeleteFolder", "Are you sure you want to remove the folder {0}\n and all its contents?", new Object[] { rf.getDescriptor().getLabel() });
/*      */       
/*      */ 
/* 1088 */       RepositoryReportUnit reportUnit = null;
/* 1089 */       for (int i = path.getPathCount() - 2; i > 0; i--)
/*      */       {
/* 1091 */         DefaultMutableTreeNode ancestorNode = (DefaultMutableTreeNode)path.getPath()[i];
/* 1092 */         if ((ancestorNode.getUserObject() instanceof RepositoryReportUnit))
/*      */         {
/* 1094 */           reportUnit = (RepositoryReportUnit)ancestorNode.getUserObject();
/* 1095 */           break;
/*      */         }
/*      */       }
/*      */       
/* 1099 */       if (reportUnit != null)
/*      */       {
/* 1101 */         reportUnitUri = reportUnit.getDescriptor().getUriString();
/*      */       }
/*      */       
/*      */ 
/* 1105 */       if (rf.getDescriptor().getWsType().equals("folder"))
/*      */       {
/* 1107 */         msg = IRPlugin.getFormattedString("repositoryExplorer.message.confirmDeleteFolder", "Are you sure you want to remove the folder {0}\n and all its contents?", new Object[] { rf.getDescriptor().getLabel() });
/*      */       }
/* 1109 */       else if (rf.getDescriptor().getWsType().equals("reportUnit"))
/*      */       {
/* 1111 */         msg = IRPlugin.getFormattedString("repositoryExplorer.message.confirmDeleteReportUnit", "Are you sure you want to remove the report unit {0}\n and all its contents?", new Object[] { rf.getDescriptor().getLabel() });
/*      */       }
/*      */       
/* 1114 */       System.out.println(rf.getDescriptor().getWsType());
/* 1115 */       if (isDataSource(rf.getDescriptor()))
/*      */       {
/* 1117 */         if ((((DefaultMutableTreeNode)selectedNode.getParent()).getUserObject() instanceof ResourcesSet))
/*      */         {
/* 1119 */           JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getString("repositoryExplorer.message.cannotDeleteRUDatasource", "You can not delete the report datasource.\nUse Report Unit properties menu item to modify the datasource type."), "", 0);
/*      */ 
/*      */         }
/*      */         
/*      */ 
/*      */ 
/*      */       }
/*      */       else
/*      */       {
/* 1128 */         msg = IRPlugin.getFormattedString("repositoryExplorer.message.confirmDeleteResource", "Are you sure you want to remove the resource {0} ?", new Object[] { rf.getDescriptor().getLabel() });
/*      */       }
/*      */       
/* 1131 */       if (JOptionPane.showConfirmDialog(this, msg) == 0)
/*      */       {
/*      */         try
/*      */         {
/* 1135 */           rf.getServer().getWSClient().delete(rf.getDescriptor(), reportUnitUri);
/*      */           
/* 1137 */           DefaultMutableTreeNode parent = (DefaultMutableTreeNode)selectedNode.getParent();
/* 1138 */           if (parent != null)
/*      */           {
/* 1140 */             parent.remove(selectedNode);
/* 1141 */             this.jTreeRepository.updateUI();
/*      */           }
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/* 1146 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1147 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void jMenuItemFontActionPerformed(ActionEvent evt) {
/* 1154 */     newResource("font");
/*      */   }
/*      */   
/*      */   private void jMenuItemJarActionPerformed(ActionEvent evt) {
/* 1158 */     newResource("jar");
/*      */   }
/*      */   
/*      */   private void jMenuItemJrxmlActionPerformed(ActionEvent evt) {
/* 1162 */     newResource("jrxml");
/*      */   }
/*      */   
/*      */   private void jMenuItemBundleActionPerformed(ActionEvent evt) {
/* 1166 */     newResource("prop");
/*      */   }
/*      */   
/*      */   private void jMenuItemImageActionPerformed(ActionEvent evt) {
/* 1170 */     newResource("img");
/*      */   }
/*      */   
/*      */   private void jMenuItemFolderActionPerformed(ActionEvent evt)
/*      */   {
/* 1175 */     newResource("folder");
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jButtonPublishReportActionPerformed1(ActionEvent evt)
/*      */   {
/* 1182 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1183 */     if (path == null) return;
/* 1184 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1186 */     String parentFolder = "/";
/* 1187 */     JServer server = null;
/* 1188 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1190 */       server = (JServer)selectedNode.getUserObject();
/*      */     }
/* 1192 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1194 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/* 1195 */       parentFolder = rf.getDescriptor().getUriString();
/* 1196 */       server = rf.getServer();
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/* 1202 */     List datasources = null;
/*      */     
/* 1204 */     if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true"))
/*      */     {
/*      */       try {
/* 1207 */         datasources = server.getWSClient().listDatasources();
/*      */       }
/*      */       catch (Exception ex) {
/* 1210 */         JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("repositoryExplorer.message.errorListingDatasources", "Error getting the list of available datasources:\n{0}", new Object[] { ex.getMessage() }));
/*      */         
/* 1212 */         ex.printStackTrace();
/* 1213 */         return;
/*      */       }
/*      */       
/* 1216 */       if ((datasources == null) || (datasources.size() == 0))
/*      */       {
/* 1218 */         JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getString("repositoryExplorer.message.noDatasourceFound", "No datasources was found on the server.\nPlease create a new datasource on the server before create a report unit."));
/*      */       }
/*      */       
/*      */ 
/*      */     }
/*      */     else
/*      */     {
/*      */ 
/* 1226 */       datasources = new ArrayList();
/*      */     }
/*      */     
/* 1229 */     NewReportUnitWizard sr = new NewReportUnitWizard();
/* 1230 */     sr.setParentFolder(parentFolder);
/* 1231 */     sr.setDatasources(datasources);
/* 1232 */     sr.setServer(server);
/* 1233 */     sr.startWizard();
/*      */     
/* 1235 */     ResourceDescriptor rd = sr.getNewResourceDescriptor();
/* 1236 */     if (rd != null)
/*      */     {
/* 1238 */       addChild(selectedNode, server, rd);
/* 1239 */       this.jTreeRepository.updateUI();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private void jButtonSaveJrxmlActionPerformed(ActionEvent evt)
/*      */   {
/* 1261 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1262 */     if (path == null) return;
/* 1263 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1265 */     if ((selectedNode.getUserObject() instanceof RepositoryJrxmlFile))
/*      */     {
/* 1267 */       RepositoryJrxmlFile rf = (RepositoryJrxmlFile)selectedNode.getUserObject();
/*      */       
/* 1269 */       if (rf.getReportFrame() != null)
/*      */       {
/* 1271 */         if (MainFrame.getMainInstance().getActiveReportFrame() != rf.getReportFrame())
/*      */         {
/* 1273 */           MainFrame.getMainInstance().setActiveReportForm(rf.getReportFrame());
/*      */         }
/*      */         
/* 1276 */         MainFrame.getMainInstance().jMenuItemSaveActionPerformed(new ActionEvent(this, 0, "Save"));
/*      */         
/* 1278 */         String fileToUpdate = rf.getReportFrame().getReport().getFilename();
/*      */         
/*      */         try
/*      */         {
/* 1282 */           RepositoryReportUnit reportUnit = null;
/* 1283 */           for (int i = path.getPathCount() - 1; i > 0; i--)
/*      */           {
/* 1285 */             DefaultMutableTreeNode ancestorNode = (DefaultMutableTreeNode)path.getPath()[i];
/* 1286 */             if ((ancestorNode.getUserObject() instanceof RepositoryReportUnit))
/*      */             {
/* 1288 */               reportUnit = (RepositoryReportUnit)ancestorNode.getUserObject();
/* 1289 */               break;
/*      */             }
/*      */           }
/*      */           
/* 1293 */           if (reportUnit != null)
/*      */           {
/* 1295 */             if (rf.validateUrls(reportUnit.getServer(), reportUnit))
/*      */             {
/* 1297 */               rf.getServer().getWSClient().modifyReportUnitResource(reportUnit.getDescriptor().getUriString(), rf.getDescriptor(), new File(fileToUpdate));
/*      */             }
/*      */             else
/*      */             {
/* 1301 */               JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getString("repositoryExplorer.message.operationCanceledByUser", "Operation canceled by the user"), IRPlugin.getString("repositoryExplorer.message.operationResult", "Operation result"), 2);
/*      */ 
/*      */             }
/*      */             
/*      */ 
/*      */           }
/*      */           else
/*      */           {
/* 1309 */             rf.getServer().getWSClient().modifyReportUnitResource(null, rf.getDescriptor(), new File(fileToUpdate));
/*      */           }
/* 1311 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getString("repositoryExplorer.message.jrxmlUpdated", "Jrxml file succesfully updated."), IRPlugin.getString("repositoryExplorer.message.operationResult", "Operation result"), 1);
/*      */ 
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/* 1316 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }), "Operation result", 0);
/* 1317 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private void jTreeRepositoryValueChanged(TreeSelectionEvent evt)
/*      */   {
/* 1328 */     updateToolBar();
/*      */   }
/*      */   
/*      */   private void jMenuItemEditJRXMLActionPerformed(ActionEvent evt)
/*      */   {
/* 1333 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1334 */     if (path == null) return;
/* 1335 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1337 */     if ((selectedNode.getUserObject() instanceof RepositoryJrxmlFile))
/*      */     {
/* 1339 */       RepositoryJrxmlFile rf = (RepositoryJrxmlFile)selectedNode.getUserObject();
/*      */       try
/*      */       {
/* 1342 */         rf.editFile();
/* 1343 */         this.jButtonSaveJrxml.setEnabled(true);
/*      */       }
/*      */       catch (Exception ex) {
/* 1346 */         JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1347 */         ex.printStackTrace();
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemGetActionPerformed(ActionEvent evt)
/*      */   {
/* 1355 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1356 */     if (path == null) return;
/* 1357 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1359 */     if ((selectedNode.getUserObject() instanceof RepositoryFile))
/*      */     {
/* 1361 */       RepositoryFile rf = (RepositoryFile)selectedNode.getUserObject();
/* 1362 */       JFileChooser jfc = new JFileChooser();
/* 1363 */       jfc.setSelectedFile(new File(rf.getDescriptor().getName()));
/*      */       
/* 1365 */       if (jfc.showSaveDialog(this) == 0) {
/*      */         try
/*      */         {
/* 1368 */           rf.getServer().getWSClient().get(rf.getDescriptor(), jfc.getSelectedFile());
/*      */         }
/*      */         catch (Exception ex) {
/* 1371 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1372 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void jMenuItemRefreshContentActionPerformed(ActionEvent evt)
/*      */   {
/* 1380 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1381 */     if (path == null) return;
/* 1382 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*      */ 
/* 1385 */     boolean isLoaded = false;
/* 1386 */     String uri = "/";
/* 1387 */     JServer server = null;
/* 1388 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1390 */       server = (JServer)selectedNode.getUserObject();
/* 1391 */       isLoaded = server.isLoaded();
/*      */     }
/* 1393 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1395 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/* 1396 */       isLoaded = rf.isLoaded();
/* 1397 */       uri = rf.getDescriptor().getUriString();
/* 1398 */       server = rf.getServer();
/*      */     }
/*      */     
/* 1401 */     if (!isLoaded)
/*      */     {
/* 1403 */       selectedNode.removeAllChildren();
/* 1404 */       jMenuItemExploreActionPerformed(evt);
/*      */     }
/*      */     else
/*      */     {
/*      */       try
/*      */       {
/* 1410 */         ResourceDescriptor descriptor = new ResourceDescriptor();
/* 1411 */         descriptor.setWsType("folder");
/* 1412 */         descriptor.setUriString(uri);
/*      */         
/* 1414 */         if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */         {
/* 1416 */           descriptor.setWsType("reportUnit");
/*      */         }
/*      */         
/* 1419 */         List list = server.getWSClient().list(descriptor);
/*      */         
/*      */ 
/*      */ 
/* 1423 */         if (descriptor.getWsType().equals("reportUnit"))
/*      */         {
/* 1425 */           updateReportUnitNodeContent(selectedNode, list);
/*      */         }
/*      */         else
/*      */         {
/* 1429 */           List updatedNodes = new ArrayList();
/* 1430 */           for (int i = 0; i < list.size(); i++)
/*      */           {
/* 1432 */             ResourceDescriptor rd = (ResourceDescriptor)list.get(i);
/*      */             
/*      */ 
/* 1435 */             boolean found = false;
/* 1436 */             for (int j = 0; j < selectedNode.getChildCount(); j++)
/*      */             {
/* 1438 */               RepositoryFolder rf = (RepositoryFolder)((DefaultMutableTreeNode)selectedNode.getChildAt(j)).getUserObject();
/* 1439 */               if (rf.getDescriptor().getUriString().equals(rd.getUriString()))
/*      */               {
/* 1441 */                 rf.setDescriptor(rd);
/* 1442 */                 updatedNodes.add(selectedNode.getChildAt(j));
/* 1443 */                 found = true;
/* 1444 */                 break;
/*      */               }
/*      */             }
/*      */             
/* 1448 */             if (!found)
/*      */             {
/* 1450 */               DefaultMutableTreeNode newNode = addChild(selectedNode, server, rd);
/* 1451 */               updatedNodes.add(newNode);
/*      */             }
/*      */           }
/*      */           
/*      */ 
/*      */ 
/* 1457 */           for (int j = 0; j < selectedNode.getChildCount(); j++)
/*      */           {
/* 1459 */             if (!updatedNodes.contains(selectedNode.getChildAt(j)))
/*      */             {
/* 1461 */               selectedNode.remove(j);
/* 1462 */               j--;
/*      */             }
/*      */           }
/*      */         }
/*      */         
/* 1467 */         if (list.size() > 0)
/*      */         {
/* 1469 */           if (!this.jTreeRepository.isExpanded(path))
/*      */           {
/* 1471 */             this.jTreeRepository.expandPath(path);
/*      */           }
/*      */         }
/* 1474 */         this.jTreeRepository.updateUI();
/*      */       }
/*      */       catch (Exception ex)
/*      */       {
/* 1478 */         JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1479 */         ex.printStackTrace();
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemRefreshActionPerformed(ActionEvent evt)
/*      */   {
/* 1487 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1488 */     if (path == null) return;
/* 1489 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1491 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1493 */       return;
/*      */     }
/* 1495 */     if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1497 */       SwingUtilities.invokeLater(new Runnable()
/*      */       {
/*      */         public void run() {
/*      */           try {
/* 1501 */             Thread.currentThread().setContextClassLoader(MainFrame.getMainInstance().getReportClassLoader());
/* 1502 */             RepositoryExplorer.this.jTreeRepository.setCursor(new Cursor(3));
/*      */             
/* 1504 */             TreePath path = RepositoryExplorer.this.jTreeRepository.getSelectionPath();
/* 1505 */             DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */             
/*      */ 
/*      */ 
/* 1509 */             if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */             {
/* 1511 */               RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/* 1512 */               JServer server = rf.getServer();
/* 1513 */               WSClient wsclient = server.getWSClient();
/* 1514 */               ResourceDescriptor rd = wsclient.get(rf.getDescriptor(), null);
/* 1515 */               rf.setDescriptor(rd);
/* 1516 */               RepositoryExplorer.this.jTreeRepository.updateUI();
/*      */             }
/*      */           }
/*      */           catch (Exception ex)
/*      */           {
/* 1521 */             JOptionPane.showMessageDialog(RepositoryExplorer.this.getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1522 */             ex.printStackTrace();
/*      */           }
/*      */           finally
/*      */           {
/* 1526 */             RepositoryExplorer.this.jTreeRepository.setCursor(null);
/*      */           }
/*      */         }
/*      */       });
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemPropertiesActionPerformed(ActionEvent evt)
/*      */   {
/* 1537 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1538 */     if (path == null) return;
/* 1539 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1541 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1543 */       jMenuItemServerSettingsActionPerformed(evt);
/*      */     }
/* 1545 */     else if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */     {
/* 1547 */       RepositoryReportUnit rf = (RepositoryReportUnit)selectedNode.getUserObject();
/* 1548 */       ReportUnitDialog rrd = new ReportUnitDialog(MainFrame.getMainInstance(), true);
/* 1549 */       rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1550 */       rrd.setServer(rf.getServer());
/*      */       
/* 1552 */       rrd.setControlsSupportActive(false);
/* 1553 */       rrd.setResourcesSupportActive(false);
/*      */       
/* 1555 */       List datasources = null;
/* 1556 */       if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true")) {
/*      */         try
/*      */         {
/* 1559 */           datasources = rf.getServer().getWSClient().listDatasources();
/* 1560 */           rrd.setDatasources(datasources);
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/* 1564 */           JOptionPane.showMessageDialog(getPlugin().getMainFrame(), IRPlugin.getFormattedString("repositoryExplorer.message.errorListingDatasources", "Error getting the list of available datasources:\n{0}", new Object[] { ex.getMessage() }));
/*      */           
/* 1566 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */       
/* 1570 */       rrd.setResource(rf);
/* 1571 */       rrd.setVisible(true);
/*      */       
/* 1573 */       if (rrd.getDialogResult() == 0)
/*      */       {
/* 1575 */         this.jTreeRepository.updateUI();
/*      */       }
/*      */     }
/* 1578 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1580 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/*      */       
/* 1582 */       if ((rf.getDescriptor().getWsType().equals("jdbc")) || (rf.getDescriptor().getWsType().equals("jndi")) || (rf.getDescriptor().getWsType().equals("bean")))
/*      */       {
/*      */ 
/*      */ 
/* 1586 */         DataSourceDialog dsd = new DataSourceDialog(MainFrame.getMainInstance(), true);
/* 1587 */         dsd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1588 */         dsd.setServer(rf.getServer());
/* 1589 */         dsd.setResource(rf);
/* 1590 */         dsd.setVisible(true);
/*      */         
/* 1592 */         if (dsd.getDialogResult() == 0)
/*      */         {
/* 1594 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         
/*      */       }
/* 1598 */       else if (rf.getDescriptor().getWsType().equals("olapXmlaCon"))
/*      */       {
/* 1600 */         XMLAConnectionDialog dsd = new XMLAConnectionDialog(MainFrame.getMainInstance(), true);
/* 1601 */         dsd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1602 */         dsd.setServer(rf.getServer());
/* 1603 */         dsd.setResource(rf);
/* 1604 */         dsd.setVisible(true);
/*      */         
/* 1606 */         if (dsd.getDialogResult() == 0)
/*      */         {
/* 1608 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         
/*      */       }
/* 1612 */       else if (rf.getDescriptor().getWsType().equals("reference"))
/*      */       {
/* 1614 */         ResourceReferenceDialog rrd = new ResourceReferenceDialog(MainFrame.getMainInstance(), true);
/* 1615 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1616 */         rrd.setServer(rf.getServer());
/* 1617 */         rrd.setResource(rf);
/* 1618 */         rrd.setVisible(true);
/*      */         
/* 1620 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1622 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/* 1625 */       else if (rf.getDescriptor().getWsType().equals("dataType"))
/*      */       {
/* 1627 */         DataTypeDialog rrd = new DataTypeDialog(MainFrame.getMainInstance(), true);
/* 1628 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1629 */         rrd.setServer(rf.getServer());
/* 1630 */         rrd.setResource(rf);
/* 1631 */         rrd.setVisible(true);
/*      */         
/* 1633 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1635 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/* 1638 */       else if (rf.getDescriptor().getWsType().equals("lov"))
/*      */       {
/* 1640 */         ListOfValuesDialog rrd = new ListOfValuesDialog(MainFrame.getMainInstance(), true);
/* 1641 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1642 */         rrd.setServer(rf.getServer());
/* 1643 */         rrd.setResource(rf);
/* 1644 */         rrd.setVisible(true);
/*      */         
/* 1646 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1648 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/* 1651 */       else if (rf.getDescriptor().getWsType().equals("query"))
/*      */       {
/* 1653 */         QueryDialog rrd = new QueryDialog(MainFrame.getMainInstance(), true);
/* 1654 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1655 */         rrd.setServer(rf.getServer());
/*      */         
/* 1657 */         List datasources = null;
/* 1658 */         if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true")) {
/*      */           try
/*      */           {
/* 1661 */             datasources = rf.getServer().getWSClient().listDatasources();
/* 1662 */             rrd.setDatasources(datasources);
/*      */           }
/*      */           catch (Exception ex)
/*      */           {
/* 1666 */             JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getFormattedString("repositoryExplorer.message.errorListingDatasources", "Error getting the list of available datasources:\n{0}", new Object[] { ex.getMessage() }));
/*      */             
/* 1668 */             ex.printStackTrace();
/*      */           }
/*      */         }
/* 1671 */         rrd.setResource(rf);
/* 1672 */         rrd.setVisible(true);
/*      */         
/* 1674 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1676 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/* 1679 */       else if (rf.getDescriptor().getWsType().equals("inputControl"))
/*      */       {
/* 1681 */         InputControlDialog rrd = new InputControlDialog(MainFrame.getMainInstance(), true);
/* 1682 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1683 */         rrd.setServer(rf.getServer());
/* 1684 */         rrd.setResource(rf);
/* 1685 */         rrd.setVisible(true);
/*      */         
/* 1687 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1689 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/* 1692 */       else if (rf.getDescriptor().getWsType().equals("ReportOptionsResource"))
/*      */       {
/* 1694 */         ReportOptionsDialog rrd = new ReportOptionsDialog(MainFrame.getMainInstance(), true);
/* 1695 */         rrd.setParentFolder(rf.getDescriptor().getParentFolder());
/* 1696 */         rrd.setServer(rf.getServer());
/* 1697 */         rrd.setResource(rf);
/* 1698 */         rrd.setVisible(true);
/*      */         
/* 1700 */         if (rrd.getDialogResult() == 0)
/*      */         {
/* 1702 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/* 1707 */         ObjectPropertiesDialog opd = new ObjectPropertiesDialog(MainFrame.getMainInstance(), true);
/* 1708 */         opd.setResource(rf);
/* 1709 */         opd.setVisible(true);
/*      */         
/* 1711 */         if (opd.getDialogResult() == 0)
/*      */         {
/* 1713 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemLoginActionPerformed(ActionEvent evt)
/*      */   {
/* 1723 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1724 */     if (path == null) return;
/* 1725 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/* 1726 */     JServer server = null;
/*      */     
/* 1728 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1730 */       server = (JServer)selectedNode.getUserObject();
/*      */     }
/* 1732 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 1734 */       server = ((RepositoryFolder)selectedNode.getUserObject()).getServer();
/*      */     }
/*      */     
/* 1737 */     if (server == null) { return;
/*      */     }
/* 1739 */     SwingUtilities.invokeLater(new Runnable()
/*      */     {
/*      */       public void run() {
/*      */         try {
/* 1743 */           Thread.currentThread().setContextClassLoader(MainFrame.getMainInstance().getReportClassLoader());
/* 1744 */           RepositoryExplorer.this.jTreeRepository.setCursor(new Cursor(3));
/*      */           
/* 1746 */           TreePath path = RepositoryExplorer.this.jTreeRepository.getSelectionPath();
/* 1747 */           DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */           
/* 1749 */           JServer server = null;
/*      */           
/* 1751 */           if ((selectedNode.getUserObject() instanceof JServer))
/*      */           {
/* 1753 */             server = (JServer)selectedNode.getUserObject();
/*      */           }
/* 1755 */           else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */           {
/* 1757 */             server = ((RepositoryFolder)selectedNode.getUserObject()).getServer();
/*      */           }
/*      */           
/* 1760 */           wsclient = server.getWSClient();
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/*      */           WSClient wsclient;
/*      */           
/* 1766 */           JOptionPane.showMessageDialog(RepositoryExplorer.this.getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1767 */           ex.printStackTrace();
/*      */         }
/*      */         finally
/*      */         {
/* 1771 */           RepositoryExplorer.this.jTreeRepository.setCursor(null);
/*      */         }
/*      */       }
/*      */     });
/*      */   }
/*      */   
/* 1777 */   int nFont = 0;
/*      */   private JButton jButtonAddServer;
/*      */   private JButton jButtonNewReportUnit;
/*      */   
/*      */   private void exploreSelectedNode() {
/* 1782 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 1783 */     if (path == null) return;
/* 1784 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 1786 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 1788 */       JServer server = (JServer)selectedNode.getUserObject();
/* 1789 */       if (!server.isLoaded())
/*      */       {
/*      */ 
/*      */ 
/*      */         try
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/* 1798 */           setTreeEnabled(false);
/*      */           
/* 1800 */           Runnable r = new Runnable() {
/*      */             private final JServer val$server;
/*      */             
/*      */             public void run() {
/* 1804 */               this.val$server.setLoading(true);
/* 1805 */               RepositoryExplorer.this.jTreeRepository.updateUI();
/* 1806 */               RepositoryExplorer.this.jTreeRepository.setCursor(new Cursor(3));
/*      */             }
/*      */           };
/*      */           
/* 1810 */           if (SwingUtilities.isEventDispatchThread())
/*      */           {
/* 1812 */             r.run();
/*      */           }
/*      */           else {
/*      */             try
/*      */             {
/* 1817 */               SwingUtilities.invokeLater(r);
/*      */             }
/*      */             catch (Exception ex) {}
/*      */           }
/*      */           
/*      */ 
/*      */ 
/* 1824 */           System.out.println("Getting ws client...." + new Date());
/* 1825 */           System.out.flush();
/* 1826 */           WSClient wsclient = server.getWSClient();
/*      */           
/* 1828 */           System.out.println("Getting version...." + new Date());
/* 1829 */           System.out.flush();
/* 1830 */           String v = wsclient.getVersion();
/*      */           
/* 1832 */           if ((v == null) || (v.compareTo(IRPlugin.REQUIRED_VERSION) < 0))
/*      */           {
/* 1834 */             showMessageFromWorker(IRPlugin.getFormattedString("repositoryExplorer.message.notSupportedServer", "Server not supported.\nMinimum version required: {0}\nFound version: {1}", new Object[] { IRPlugin.REQUIRED_VERSION, v }));
/*      */             
/*      */             Runnable r;
/*      */             
/*      */             return;
/*      */           }
/*      */           
/* 1841 */           ResourceDescriptor descriptor = new ResourceDescriptor();
/* 1842 */           descriptor.setWsType("folder");
/* 1843 */           descriptor.setUriString("/");
/*      */           
/*      */ 
/* 1846 */           List list = wsclient.list(descriptor);
/*      */           
/* 1848 */           JTree jTree = this.jTreeRepository;
/* 1849 */           r = new Runnable() {
/*      */             private final DefaultMutableTreeNode val$selectedNode;
/*      */             private final JServer val$server;
/*      */             
/* 1853 */             public void run() { RepositoryExplorer.this.addChilds(this.val$selectedNode, this.val$server, this.val$list);
/* 1854 */               if (this.val$list.size() > 0)
/*      */               {
/* 1856 */                 if (!this.val$jTree.isExpanded(this.val$path))
/*      */                 {
/* 1858 */                   this.val$jTree.expandPath(this.val$path);
/*      */                 }
/* 1860 */                 this.val$jTree.updateUI();
/*      */               }
/* 1862 */               this.val$server.setLoaded(true);
/*      */             }
/*      */           };
/*      */           
/* 1866 */           if (SwingUtilities.isEventDispatchThread())
/*      */           {
/* 1868 */             r.run();
/*      */           }
/*      */           else {
/*      */             try
/*      */             {
/* 1873 */               SwingUtilities.invokeLater(r);
/*      */             }
/*      */             catch (Exception ex) {}
/*      */           }
/*      */         }
/*      */         catch (Exception ex) {
/*      */           Runnable r;
/* 1880 */           showMessageFromWorker(IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1881 */           ex.printStackTrace();
/*      */         }
/*      */         finally {
/*      */           Runnable r;
/* 1885 */           Runnable r = new Runnable() {
/*      */             private final List val$list;
/*      */             private final JTree val$jTree;
/*      */             
/* 1889 */             public void run() { this.val$server.setLoading(false);
/* 1890 */               RepositoryExplorer.this.jTreeRepository.updateUI();
/* 1891 */               RepositoryExplorer.this.jTreeRepository.setCursor(null);
/*      */             }
/*      */           };
/*      */           
/* 1895 */           if (SwingUtilities.isEventDispatchThread())
/*      */           {
/* 1897 */             r.run();
/*      */           }
/*      */           else {
/*      */             try
/*      */             {
/* 1902 */               SwingUtilities.invokeLater(r);
/*      */             } catch (Exception ex) {}
/*      */           }
/* 1905 */           setTreeEnabled(true);
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1914 */     if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */     {
/* 1916 */       RepositoryReportUnit reportUnit = (RepositoryReportUnit)selectedNode.getUserObject();
/* 1917 */       if (!reportUnit.isLoaded())
/*      */       {
/*      */ 
/* 1920 */         SwingUtilities.invokeLater(new Runnable()
/*      */         {
/*      */           public void run() {
/*      */             try {
/* 1924 */               Thread.currentThread().setContextClassLoader(MainFrame.getMainInstance().getReportClassLoader());
/* 1925 */               RepositoryExplorer.this.jTreeRepository.setCursor(new Cursor(3));
/*      */               
/* 1927 */               TreePath path = RepositoryExplorer.this.jTreeRepository.getSelectionPath();
/* 1928 */               DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/* 1929 */               RepositoryReportUnit reportUnit = (RepositoryReportUnit)selectedNode.getUserObject();
/* 1930 */               JServer server = reportUnit.getServer();
/*      */               
/* 1932 */               WSClient wsclient = server.getWSClient();
/* 1933 */               ResourceDescriptor descriptor = new ResourceDescriptor();
/* 1934 */               descriptor.setWsType("reportUnit");
/* 1935 */               descriptor.setUriString(reportUnit.getDescriptor().getUriString());
/* 1936 */               Request req = new Request();
/* 1937 */               req.setOperationName("list");
/* 1938 */               req.setResourceDescriptor(descriptor);
/*      */               
/* 1940 */               StringWriter xmlStringWriter = new StringWriter();
/* 1941 */               Marshaller.marshal(req, xmlStringWriter);
/*      */               
/* 1943 */               List list = wsclient.list(xmlStringWriter.toString());
/*      */               
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1949 */               RepositoryExplorer.this.updateReportUnitNodeContent(selectedNode, list);
/*      */               
/*      */ 
/*      */ 
/*      */ 
/* 1954 */               if (list.size() > 0)
/*      */               {
/* 1956 */                 if (!RepositoryExplorer.this.jTreeRepository.isExpanded(path))
/*      */                 {
/* 1958 */                   RepositoryExplorer.this.jTreeRepository.expandPath(path);
/*      */                 }
/* 1960 */                 RepositoryExplorer.this.jTreeRepository.updateUI();
/*      */               }
/*      */               
/* 1963 */               reportUnit.setLoaded(true);
/*      */             }
/*      */             catch (Exception ex) {
/* 1966 */               JOptionPane.showMessageDialog(RepositoryExplorer.this.getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1967 */               ex.printStackTrace();
/*      */             }
/*      */             finally
/*      */             {
/* 1971 */               RepositoryExplorer.this.jTreeRepository.setCursor(null);
/*      */             }
/*      */             
/*      */           }
/*      */         });
/*      */       }
/*      */     }
/* 1978 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/*      */ 
/* 1981 */       RepositoryFolder folder = (RepositoryFolder)selectedNode.getUserObject();
/* 1982 */       if (!folder.isLoaded())
/*      */       {
/* 1984 */         SwingUtilities.invokeLater(new Runnable()
/*      */         {
/*      */           public void run() {
/*      */             try {
/* 1988 */               Thread.currentThread().setContextClassLoader(MainFrame.getMainInstance().getReportClassLoader());
/* 1989 */               RepositoryExplorer.this.jTreeRepository.setCursor(new Cursor(3));
/*      */               
/* 1991 */               TreePath path = RepositoryExplorer.this.jTreeRepository.getSelectionPath();
/* 1992 */               DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/* 1993 */               RepositoryFolder folder = (RepositoryFolder)selectedNode.getUserObject();
/*      */               
/* 1995 */               JServer server = folder.getServer();
/*      */               
/* 1997 */               WSClient wsclient = server.getWSClient();
/* 1998 */               ResourceDescriptor descriptor = new ResourceDescriptor();
/* 1999 */               descriptor.setWsType("folder");
/* 2000 */               descriptor.setUriString(folder.getDescriptor().getUriString());
/* 2001 */               Request req = new Request();
/* 2002 */               req.setOperationName("list");
/* 2003 */               req.setResourceDescriptor(descriptor);
/*      */               
/* 2005 */               StringWriter xmlStringWriter = new StringWriter();
/* 2006 */               Marshaller.marshal(req, xmlStringWriter);
/*      */               
/* 2008 */               List list = wsclient.list(xmlStringWriter.toString());
/*      */               
/* 2010 */               RepositoryExplorer.this.addChilds(selectedNode, server, list);
/*      */               
/* 2012 */               if (list.size() > 0)
/*      */               {
/* 2014 */                 if (!RepositoryExplorer.this.jTreeRepository.isExpanded(path))
/*      */                 {
/* 2016 */                   RepositoryExplorer.this.jTreeRepository.expandPath(path);
/*      */                 }
/* 2018 */                 RepositoryExplorer.this.jTreeRepository.updateUI();
/*      */               }
/*      */               
/* 2021 */               folder.setLoaded(true);
/*      */             }
/*      */             catch (Exception ex) {
/* 2024 */               JOptionPane.showMessageDialog(RepositoryExplorer.this.getPlugin().getMainFrame(), IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 2025 */               ex.printStackTrace();
/*      */             }
/*      */             finally
/*      */             {
/* 2029 */               RepositoryExplorer.this.jTreeRepository.setCursor(null);
/*      */             }
/*      */           }
/*      */         });
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void jMenuItemExploreActionPerformed(ActionEvent evt)
/*      */   {
/* 2039 */     if (!isTreeEnabled()) return;
/* 2040 */     Runnable r = new Runnable()
/*      */     {
/*      */       public void run()
/*      */       {
/* 2044 */         RepositoryExplorer.this.exploreSelectedNode();
/*      */       }
/*      */       
/*      */ 
/* 2048 */     };
/* 2049 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 2050 */     if (path == null) return;
/* 2051 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/* 2053 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 2055 */       Thread t = new Thread(r);
/* 2056 */       t.start();
/*      */     }
/*      */     else
/*      */     {
/* 2060 */       r.run();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemNewServerActionPerformed(ActionEvent evt)
/*      */   {
/* 2068 */     jButtonAddServerActionPerformed(null);
/*      */   }
/*      */   
/*      */ 
/*      */   private void jMenuItemServerDeleteActionPerformed(ActionEvent evt)
/*      */   {
/* 2074 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 2075 */     if (path == null) return;
/* 2076 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/* 2077 */     JServer server = null;
/*      */     
/* 2079 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 2081 */       server = (JServer)selectedNode.getUserObject();
/*      */     }
/* 2083 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 2085 */       server = ((RepositoryFolder)selectedNode.getUserObject()).getServer();
/*      */     }
/*      */     
/* 2088 */     if (server == null) { return;
/*      */     }
/* 2090 */     if (JOptionPane.showConfirmDialog(getPlugin().getMainFrame(), "Are you sure you want to delete the server '" + server + "' ?", "Deleting server", 1, 2) == 0)
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 2097 */       getPlugin().getJServers().remove(selectedNode.getUserObject());
/* 2098 */       getPlugin().saveConfiguration();
/* 2099 */       ((DefaultMutableTreeNode)this.jTreeRepository.getModel().getRoot()).remove(selectedNode);
/* 2100 */       this.jTreeRepository.updateUI();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jMenuItemServerSettingsActionPerformed(ActionEvent evt)
/*      */   {
/* 2108 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 2109 */     if (path == null) return;
/* 2110 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/* 2111 */     JServer server = null;
/*      */     
/* 2113 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 2115 */       server = (JServer)selectedNode.getUserObject();
/*      */     }
/* 2117 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 2119 */       server = ((RepositoryFolder)selectedNode.getUserObject()).getServer();
/*      */     }
/*      */     
/* 2122 */     if (server == null) { return;
/*      */     }
/* 2124 */     ServerDialog sd = new ServerDialog(getPlugin().getMainFrame(), true);
/* 2125 */     sd.setJServer(server);
/* 2126 */     sd.setVisible(true);
/* 2127 */     if (sd.getDialogResult() == 0)
/*      */     {
/* 2129 */       server.setName(sd.getJServer().getName());
/* 2130 */       server.setUsername(sd.getJServer().getUsername());
/* 2131 */       server.setPassword(sd.getJServer().getPassword());
/* 2132 */       server.setUrl(sd.getJServer().getUrl());
/*      */       
/* 2134 */       getPlugin().saveConfiguration();
/* 2135 */       this.jTreeRepository.updateUI();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jTreeRepositoryMouseClicked(MouseEvent evt)
/*      */   {
/* 2142 */     if (!isTreeEnabled()) return;
/* 2143 */     if ((evt.getClickCount() == 1) && (evt.getButton() == 3))
/*      */     {
/* 2145 */       this.jTreeRepository.setSelectionPath(this.jTreeRepository.getPathForLocation(evt.getX(), evt.getY()));
/* 2146 */       TreePath path = this.jTreeRepository.getSelectionPath();
/*      */       
/*      */ 
/*      */ 
/* 2150 */       if (!IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true"))
/*      */       {
/* 2152 */         this.jMenuItemDatasource.setVisible(false);
/* 2153 */         this.jMenuItemXMLADatasource.setVisible(false);
/* 2154 */         this.jSeparator7.setVisible(false);
/*      */       }
/*      */       
/*      */ 
/* 2158 */       if (path == null)
/*      */       {
/* 2160 */         this.jMenuItemEditJRXML.setVisible(false);
/* 2161 */         this.jMenuItemExplore.setVisible(false);
/* 2162 */         this.jMenuItemGet.setVisible(false);
/* 2163 */         this.jMenuItemServerDelete.setEnabled(false);
/* 2164 */         this.jMenuItemServerSettings.setEnabled(false);
/* 2165 */         this.jMenuItemProperties.setEnabled(false);
/* 2166 */         this.jMenuItemRefresh.setVisible(false);
/* 2167 */         this.jMenuItemRefreshContent.setVisible(false);
/* 2168 */         this.jMenuAdd.setVisible(false);
/* 2169 */         this.jMenuItemConnection.setVisible(false);
/* 2170 */         this.jMenuItemImportFont.setVisible(false);
/* 2171 */         this.jMenuItemRunRU.setVisible(false);
/*      */         
/* 2173 */         this.jPopupMenuServer.show(this.jTreeRepository, evt.getX(), evt.getY());
/* 2174 */         return;
/*      */       }
/*      */       
/* 2177 */       this.jMenuItemServerDelete.setEnabled(true);
/* 2178 */       this.jMenuItemServerSettings.setEnabled(true);
/* 2179 */       this.jMenuItemProperties.setEnabled(true);
/* 2180 */       this.jMenuItemRefresh.setVisible(true);
/* 2181 */       this.jMenuItemRefreshContent.setVisible(true);
/* 2182 */       this.jMenuItemFolder.setEnabled(true);
/* 2183 */       this.jMenuItemReportUnit.setEnabled(true);
/* 2184 */       this.jMenuAdd.setVisible(true);
/* 2185 */       this.jMenuItemConnection.setVisible(false);
/* 2186 */       this.jMenuItemImportFont.setVisible(false);
/* 2187 */       this.jMenuItemReference.setEnabled(false);
/* 2188 */       this.jMenuItemDataType.setEnabled(true);
/* 2189 */       this.jMenuItemListOfValues.setEnabled(true);
/* 2190 */       this.jMenuItemRunRU.setVisible(false);
/*      */       
/* 2192 */       DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */       
/*      */ 
/* 2195 */       if ((selectedNode.getUserObject() instanceof JServer))
/*      */       {
/* 2197 */         this.jMenuItemEditJRXML.setVisible(false);
/* 2198 */         this.jMenuItemExplore.setVisible(true);
/* 2199 */         this.jMenuItemGet.setVisible(false);
/* 2200 */         this.jMenuAdd.setEnabled(true);
/* 2201 */         this.jMenuItemDelete.setVisible(false);
/*      */       }
/* 2203 */       else if ((selectedNode.getUserObject() instanceof RepositoryJrxmlFile))
/*      */       {
/* 2205 */         this.jMenuItemEditJRXML.setVisible(true);
/* 2206 */         this.jMenuItemExplore.setVisible(false);
/* 2207 */         this.jMenuItemGet.setVisible(false);
/* 2208 */         this.jMenuAdd.setEnabled(false);
/* 2209 */         this.jMenuItemDelete.setVisible(true);
/*      */       }
/* 2211 */       else if ((selectedNode.getUserObject() instanceof RepositoryFile))
/*      */       {
/* 2213 */         this.jMenuItemEditJRXML.setVisible(false);
/* 2214 */         this.jMenuItemExplore.setVisible(false);
/* 2215 */         this.jMenuItemGet.setVisible(false);
/* 2216 */         this.jMenuAdd.setEnabled(false);
/* 2217 */         this.jMenuItemDelete.setVisible(true);
/*      */         
/* 2219 */         String resType = ((RepositoryFile)selectedNode.getUserObject()).getDescriptor().getWsType();
/*      */         
/* 2221 */         if (resType.equals("jdbc"))
/*      */         {
/* 2223 */           this.jMenuItemConnection.setVisible(true);
/*      */ 
/*      */         }
/* 2226 */         else if ((resType.equals("jar")) || (resType.equals("font")) || (resType.equals("img")) || (resType.equals("jrxml")) || (resType.equals("prop")))
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 2232 */           this.jMenuItemGet.setVisible(true);
/*      */         }
/*      */         
/* 2235 */         if (resType.equals("font"))
/*      */         {
/* 2237 */           this.jMenuItemImportFont.setVisible(true);
/*      */         }
/*      */         
/* 2240 */         if (((RepositoryFolder)selectedNode.getUserObject()).getDescriptor().getWsType().equals("ReportOptionsResource"))
/*      */         {
/* 2242 */           this.jMenuItemRunRU.setVisible(true);
/*      */         }
/*      */       }
/* 2245 */       else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */       {
/* 2247 */         this.jMenuItemEditJRXML.setVisible(false);
/* 2248 */         this.jMenuItemExplore.setVisible(true);
/* 2249 */         this.jMenuItemGet.setVisible(false);
/* 2250 */         this.jMenuAdd.setEnabled(true);
/* 2251 */         this.jMenuItemDatasource.setEnabled(true);
/* 2252 */         this.jMenuItemXMLADatasource.setEnabled(true);
/* 2253 */         this.jMenuItemDelete.setVisible(true);
/*      */         
/* 2255 */         if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */         {
/* 2257 */           this.jMenuItemFolder.setEnabled(false);
/* 2258 */           this.jMenuItemReference.setEnabled(true);
/* 2259 */           this.jMenuItemReportUnit.setEnabled(false);
/* 2260 */           this.jMenuItemDataType.setEnabled(false);
/* 2261 */           this.jMenuItemListOfValues.setEnabled(false);
/* 2262 */           this.jMenuItemRunRU.setVisible(true);
/* 2263 */           this.jMenuItemDatasource.setEnabled(false);
/* 2264 */           this.jMenuItemXMLADatasource.setEnabled(false);
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/* 2269 */         if ((selectedNode.getUserObject() instanceof ControlsSet))
/*      */         {
/* 2271 */           this.jPopupMenuRUInputControls.show(this.jTreeRepository, evt.getX(), evt.getY());
/* 2272 */           return;
/*      */         }
/* 2274 */         if ((selectedNode.getUserObject() instanceof ResourcesSet))
/*      */         {
/* 2276 */           this.jMenuItemEditJRXML.setVisible(false);
/* 2277 */           this.jMenuItemExplore.setVisible(false);
/* 2278 */           this.jMenuItemGet.setVisible(false);
/* 2279 */           this.jMenuAdd.setEnabled(true);
/* 2280 */           this.jMenuItemFolder.setEnabled(false);
/* 2281 */           this.jMenuItemReference.setEnabled(true);
/* 2282 */           this.jMenuItemReportUnit.setEnabled(false);
/* 2283 */           this.jMenuItemDataType.setEnabled(false);
/* 2284 */           this.jMenuItemListOfValues.setEnabled(false);
/* 2285 */           this.jMenuItemDatasource.setEnabled(false);
/* 2286 */           this.jMenuItemXMLADatasource.setEnabled(false);
/* 2287 */           this.jMenuItemDelete.setVisible(false);
/*      */         }
/*      */       }
/* 2290 */       this.jMenuItemExplore.setEnabled(true);
/* 2291 */       this.jMenuItemServerDelete.setEnabled(true);
/* 2292 */       this.jMenuItemServerSettings.setEnabled(true);
/* 2293 */       this.jPopupMenuServer.show(this.jTreeRepository, evt.getX(), evt.getY());
/* 2294 */       return;
/*      */     }
/* 2296 */     if ((evt.getClickCount() == 2) && (evt.getButton() == 1))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/* 2301 */       TreePath path = this.jTreeRepository.getSelectionPath();
/* 2302 */       DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */       
/* 2304 */       if ((selectedNode.getUserObject() instanceof JServer))
/*      */       {
/* 2306 */         jMenuItemExploreActionPerformed(null);
/*      */       }
/* 2308 */       else if ((selectedNode.getUserObject() instanceof RepositoryJrxmlFile))
/*      */       {
/* 2310 */         jMenuItemEditJRXMLActionPerformed(null);
/*      */       }
/* 2312 */       else if ((selectedNode.getUserObject() instanceof RepositoryFile))
/*      */       {
/* 2314 */         jMenuItemPropertiesActionPerformed(null);
/*      */       }
/* 2316 */       else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */       {
/* 2318 */         jMenuItemExploreActionPerformed(null);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private final TreePath val$path;
/*      */   
/*      */   private final JServer val$server;
/*      */   
/*      */   private void jPopupMenuServerMouseClicked(MouseEvent evt) {}
/*      */   
/*      */   private void jButtonAddServerActionPerformed(ActionEvent evt)
/*      */   {
/* 2332 */     ServerDialog sd = new ServerDialog(getPlugin().getMainFrame(), true);
/* 2333 */     sd.setVisible(true);
/* 2334 */     if (sd.getDialogResult() == 0)
/*      */     {
/* 2336 */       IRPlugin.getMainInstance().getJServers().add(sd.getJServer());
/* 2337 */       IRPlugin.getMainInstance().saveConfiguration();
/* 2338 */       ((DefaultMutableTreeNode)this.jTreeRepository.getModel().getRoot()).add(new DefaultMutableTreeNode(sd.getJServer()));
/* 2339 */       this.jTreeRepository.updateUI();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private JButton jButtonRunReport;
/*      */   
/*      */   private JButton jButtonSaveJrxml;
/*      */   
/*      */   private JMenu jMenuAdd;
/*      */   
/*      */   private JMenuItem jMenuItemBundle;
/*      */   
/*      */   private JMenuItem jMenuItemConnection;
/*      */   
/*      */   private JMenuItem jMenuItemDataType;
/*      */   
/*      */   private JMenuItem jMenuItemDatasource;
/*      */   
/*      */   private JMenuItem jMenuItemDelete;
/*      */   
/*      */   private JMenuItem jMenuItemEditJRXML;
/*      */   
/*      */   private JMenuItem jMenuItemExplore;
/*      */   
/*      */   private JMenuItem jMenuItemFolder;
/*      */   
/*      */   private JMenuItem jMenuItemFont;
/*      */   private JMenuItem jMenuItemGet;
/*      */   private JMenuItem jMenuItemImage;
/*      */   private JMenuItem jMenuItemImportFont;
/*      */   private JMenuItem jMenuItemInputControl;
/*      */   private JMenuItem jMenuItemJar;
/*      */   private JMenuItem jMenuItemJrxml;
/*      */   private JMenuItem jMenuItemLinkInputControl;
/*      */   private JMenuItem jMenuItemListOfValues;
/*      */   private JMenuItem jMenuItemLocalInputControl;
/*      */   private JMenuItem jMenuItemLogin;
/*      */   private JMenuItem jMenuItemNewServer;
/*      */   private JMenuItem jMenuItemProperties;
/*      */   private JMenuItem jMenuItemQuery;
/*      */   private JMenuItem jMenuItemReference;
/*      */   private JMenuItem jMenuItemRefresh;
/*      */   private JMenuItem jMenuItemRefreshContent;
/*      */   private JMenuItem jMenuItemReportUnit;
/*      */   private JMenuItem jMenuItemRunRU;
/*      */   private JMenuItem jMenuItemServerDelete;
/*      */   private JMenuItem jMenuItemServerSettings;
/*      */   private JMenuItem jMenuItemXMLADatasource;
/*      */   private JPopupMenu jPopupMenuRUInputControls;
/*      */   private JPopupMenu jPopupMenuServer;
/*      */   private JScrollPane jScrollPane1;
/*      */   private JSeparator jSeparator1;
/*      */   private JSeparator jSeparator2;
/*      */   private JSeparator jSeparator3;
/*      */   private JSeparator jSeparator4;
/*      */   private JSeparator jSeparator5;
/*      */   private JSeparator jSeparator6;
/*      */   private JSeparator jSeparator7;
/*      */   private JToolBar jToolBar1;
/*      */   private JTree jTreeRepository;
/*      */   private void addChilds(DefaultMutableTreeNode selectedNode, JServer server, List resourceDescriptors)
/*      */   {
/* 2402 */     for (int i = 0; i < resourceDescriptors.size(); i++)
/*      */     {
/* 2404 */       ResourceDescriptor rd = (ResourceDescriptor)resourceDescriptors.get(i);
/* 2405 */       addChild(selectedNode, server, rd);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private DefaultMutableTreeNode addChild(DefaultMutableTreeNode selectedNode, JServer server, ResourceDescriptor rd)
/*      */   {
/* 2416 */     if ((isDataSource(rd)) && (!IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true")))
/*      */     {
/* 2418 */       return null;
/*      */     }
/*      */     
/* 2421 */     DefaultMutableTreeNode newNode = null;
/*      */     
/* 2423 */     RepositoryFolder obj = createRepositoryObject(server, rd);
/* 2424 */     if (obj != null)
/*      */     {
/* 2426 */       newNode = new DefaultMutableTreeNode(obj);
/* 2427 */       selectedNode.add(newNode);
/*      */     }
/* 2429 */     return newNode;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static RepositoryFolder createRepositoryObject(JServer server, ResourceDescriptor rd)
/*      */   {
/* 2447 */     if (rd.getWsType() == null)
/*      */     {
/* 2449 */       rd.setWsType("unknow");
/*      */     }
/*      */     
/* 2452 */     if (rd.getWsType().equals("reportUnit"))
/*      */     {
/* 2454 */       return new RepositoryReportUnit(server, rd);
/*      */     }
/* 2456 */     if (rd.getWsType().equals("folder"))
/*      */     {
/* 2458 */       return new RepositoryFolder(server, rd);
/*      */     }
/* 2460 */     if (rd.getWsType().equals("jrxml"))
/*      */     {
/* 2462 */       return new RepositoryJrxmlFile(server, rd);
/*      */     }
/*      */     
/*      */ 
/* 2466 */     return new RepositoryFile(server, rd);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void newResource(String resourceType)
/*      */   {
/* 2473 */     TreePath path = this.jTreeRepository.getSelectionPath();
/* 2474 */     if (path == null) return;
/* 2475 */     DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)path.getLastPathComponent();
/*      */     
/*      */ 
/* 2478 */     JServer server = null;
/*      */     
/* 2480 */     String currentUri = "/";
/* 2481 */     String reportUnitUri = null;
/*      */     
/* 2483 */     boolean parentLoaded = false;
/* 2484 */     if ((selectedNode.getUserObject() instanceof JServer))
/*      */     {
/* 2486 */       server = (JServer)selectedNode.getUserObject();
/* 2487 */       parentLoaded = server.isLoaded();
/*      */     }
/* 2489 */     else if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */     {
/* 2491 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/* 2492 */       server = rf.getServer();
/* 2493 */       currentUri = rf.getDescriptor().getUriString();
/* 2494 */       reportUnitUri = currentUri;
/* 2495 */       parentLoaded = rf.isLoaded();
/*      */     }
/* 2497 */     else if ((selectedNode.getUserObject() instanceof RepositoryFolder))
/*      */     {
/* 2499 */       RepositoryFolder rf = (RepositoryFolder)selectedNode.getUserObject();
/* 2500 */       server = rf.getServer();
/* 2501 */       currentUri = rf.getDescriptor().getUriString();
/* 2502 */       parentLoaded = rf.isLoaded();
/*      */     }
/* 2504 */     else if ((selectedNode.getUserObject() instanceof ControlsSet))
/*      */     {
/* 2506 */       RepositoryFolder rf = ((ControlsSet)selectedNode.getUserObject()).getReportUnit();
/* 2507 */       server = rf.getServer();
/* 2508 */       currentUri = rf.getDescriptor().getUriString();
/* 2509 */       reportUnitUri = currentUri;
/* 2510 */       parentLoaded = rf.isLoaded();
/*      */     }
/* 2512 */     else if ((selectedNode.getUserObject() instanceof ResourcesSet))
/*      */     {
/* 2514 */       RepositoryFolder rf = ((ResourcesSet)selectedNode.getUserObject()).getReportUnit();
/* 2515 */       server = rf.getServer();
/* 2516 */       currentUri = rf.getDescriptor().getUriString();
/* 2517 */       reportUnitUri = currentUri;
/* 2518 */       parentLoaded = rf.isLoaded();
/*      */     }
/*      */     
/* 2521 */     if (resourceType.equals("datasource"))
/*      */     {
/* 2523 */       DataSourceDialog nrd = new DataSourceDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2525 */       nrd.setParentFolder(currentUri);
/* 2526 */       nrd.setServer(server);
/*      */       
/*      */ 
/*      */ 
/* 2530 */       nrd.setVisible(true);
/*      */       
/* 2532 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2534 */         if (parentLoaded)
/*      */         {
/* 2536 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2537 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2541 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2545 */     else if (resourceType.equals("olapXmlaCon"))
/*      */     {
/* 2547 */       XMLAConnectionDialog nrd = new XMLAConnectionDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2549 */       nrd.setParentFolder(currentUri);
/* 2550 */       nrd.setServer(server);
/*      */       
/*      */ 
/*      */ 
/* 2554 */       nrd.setVisible(true);
/*      */       
/* 2556 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2558 */         if (parentLoaded)
/*      */         {
/* 2560 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2561 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2565 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2569 */     else if (resourceType.equals("reference"))
/*      */     {
/* 2571 */       ResourceReferenceDialog rrd = new ResourceReferenceDialog(MainFrame.getMainInstance(), true);
/* 2572 */       rrd.setServer(server);
/* 2573 */       rrd.setParentFolder(currentUri);
/*      */       
/*      */ 
/*      */ 
/* 2577 */       rrd.setVisible(true);
/*      */       
/* 2579 */       if (rrd.getDialogResult() == 0)
/*      */       {
/* 2581 */         if (parentLoaded)
/*      */         {
/* 2583 */           addChild(selectedNode, server, rrd.getNewResourceDescriptor());
/* 2584 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2588 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2592 */     else if (resourceType.equals("dataType"))
/*      */     {
/* 2594 */       DataTypeDialog nrd = new DataTypeDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2596 */       nrd.setParentFolder(currentUri);
/* 2597 */       nrd.setServer(server);
/*      */       
/* 2599 */       nrd.setVisible(true);
/*      */       
/* 2601 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2603 */         if (parentLoaded)
/*      */         {
/* 2605 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2606 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2610 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2614 */     else if (resourceType.equals("lov"))
/*      */     {
/* 2616 */       ListOfValuesDialog nrd = new ListOfValuesDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2618 */       nrd.setParentFolder(currentUri);
/* 2619 */       nrd.setServer(server);
/*      */       
/* 2621 */       nrd.setVisible(true);
/*      */       
/* 2623 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2625 */         if (parentLoaded)
/*      */         {
/* 2627 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2628 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2632 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2636 */     else if (resourceType.equals("query"))
/*      */     {
/* 2638 */       QueryDialog nrd = new QueryDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2640 */       nrd.setParentFolder(currentUri);
/* 2641 */       nrd.setServer(server);
/*      */       
/* 2643 */       if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true"))
/*      */       {
/* 2645 */         List datasources = null;
/*      */         try {
/* 2647 */           datasources = server.getWSClient().listDatasources();
/* 2648 */           nrd.setDatasources(datasources);
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/* 2652 */           JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getFormattedString("repositoryExplorer.message.errorListingDatasources", "Error getting the list of available datasources:\n{0}", new Object[] { ex.getMessage() }));
/*      */           
/* 2654 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */       
/* 2658 */       nrd.setVisible(true);
/*      */       
/* 2660 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2662 */         if (parentLoaded)
/*      */         {
/* 2664 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2665 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2669 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/* 2673 */     else if (resourceType.equals("inputControl"))
/*      */     {
/* 2675 */       InputControlDialog nrd = new InputControlDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2677 */       nrd.setParentFolder(currentUri);
/* 2678 */       nrd.setServer(server);
/* 2679 */       nrd.setReportUnitUri(reportUnitUri);
/*      */       
/* 2681 */       nrd.setVisible(true);
/*      */       
/* 2683 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2685 */         if (parentLoaded)
/*      */         {
/* 2687 */           if (reportUnitUri != null)
/*      */           {
/* 2689 */             if ((selectedNode.getUserObject() instanceof ControlsSet))
/*      */             {
/* 2691 */               addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/*      */             }
/* 2693 */             else if ((selectedNode.getUserObject() instanceof RepositoryReportUnit))
/*      */             {
/* 2695 */               for (int i = 0; i < selectedNode.getChildCount(); i++)
/*      */               {
/* 2697 */                 DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode)selectedNode.getChildAt(i);
/* 2698 */                 if ((dmtn.getUserObject() instanceof ControlsSet))
/*      */                 {
/* 2700 */                   addChild(dmtn, server, nrd.getNewResourceDescriptor());
/* 2701 */                   break;
/*      */                 }
/*      */                 
/*      */               }
/*      */             }
/*      */           }
/*      */           else {
/* 2708 */             addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/*      */           }
/* 2710 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2714 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/*      */     else
/*      */     {
/* 2720 */       NewResourceDialog nrd = new NewResourceDialog(MainFrame.getMainInstance(), true);
/*      */       
/* 2722 */       nrd.setParentUri(currentUri);
/* 2723 */       nrd.setServer(server);
/* 2724 */       nrd.setReportUnitUri(reportUnitUri);
/* 2725 */       nrd.setResourceType(resourceType);
/*      */       
/* 2727 */       nrd.setVisible(true);
/*      */       
/* 2729 */       if (nrd.getDialogResult() == 0)
/*      */       {
/* 2731 */         if (parentLoaded)
/*      */         {
/* 2733 */           addChild(selectedNode, server, nrd.getNewResourceDescriptor());
/* 2734 */           this.jTreeRepository.updateUI();
/*      */         }
/*      */         else
/*      */         {
/* 2738 */           jMenuItemExploreActionPerformed(null);
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public JTree getTreeRepository()
/*      */   {
/* 2750 */     return this.jTreeRepository;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public List getOpenedReportSources(JServer server)
/*      */   {
/* 2758 */     ArrayList list = new ArrayList();
/*      */     
/* 2760 */     DefaultMutableTreeNode root = (DefaultMutableTreeNode)this.jTreeRepository.getModel().getRoot();
/*      */     
/* 2762 */     for (int i = 0; i < root.getChildCount(); i++)
/*      */     {
/* 2764 */       DefaultMutableTreeNode dmn = (DefaultMutableTreeNode)root.getChildAt(i);
/* 2765 */       if (dmn.getUserObject() == server)
/*      */       {
/*      */ 
/* 2768 */         return getOpenedReportSources(dmn, list);
/*      */       }
/*      */     }
/* 2771 */     return list;
/*      */   }
/*      */   
/*      */   private List getOpenedReportSources(DefaultMutableTreeNode dmn, List list)
/*      */   {
/* 2776 */     if ((dmn.getUserObject() instanceof RepositoryJrxmlFile))
/*      */     {
/* 2778 */       RepositoryJrxmlFile rf = (RepositoryJrxmlFile)dmn.getUserObject();
/* 2779 */       if (rf.getReportFrame() != null)
/*      */       {
/* 2781 */         list.add(rf);
/*      */       }
/* 2783 */       return list;
/*      */     }
/*      */     
/* 2786 */     for (int i = 0; i < dmn.getChildCount(); i++)
/*      */     {
/* 2788 */       list = getOpenedReportSources((DefaultMutableTreeNode)dmn.getChildAt(i), list);
/*      */     }
/*      */     
/* 2791 */     return list;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   private void updateReportUnitNodeContent(DefaultMutableTreeNode selectedNode, List list)
/*      */   {
/* 2809 */     RepositoryReportUnit reportUnit = (RepositoryReportUnit)selectedNode.getUserObject();
/*      */     
/* 2811 */     Vector existingNodes = new Vector();
/*      */     
/*      */ 
/* 2814 */     for (int k = 0; k < selectedNode.getChildCount(); k++)
/*      */     {
/* 2816 */       Object obj = ((DefaultMutableTreeNode)selectedNode.getChildAt(k)).getUserObject();
/* 2817 */       if ((obj instanceof RepositoryFolder))
/*      */       {
/* 2819 */         existingNodes.add(obj);
/* 2820 */         selectedNode.remove(k);
/* 2821 */         k--;
/*      */       }
/*      */     }
/*      */     
/*      */ 
/* 2826 */     for (int i = 0; i < list.size(); i++)
/*      */     {
/* 2828 */       ResourceDescriptor rd = (ResourceDescriptor)list.get(i);
/* 2829 */       if (isDataSource(rd))
/*      */       {
/* 2831 */         list.remove(i);
/* 2832 */         if (!rd.getIsReference())
/*      */         {
/* 2834 */           boolean found = false;
/*      */           
/* 2836 */           for (int k = 0; k < existingNodes.size(); k++)
/*      */           {
/* 2838 */             if ((existingNodes.elementAt(k) instanceof RepositoryFolder))
/*      */             {
/* 2840 */               RepositoryFolder repoFolder = (RepositoryFolder)existingNodes.elementAt(k);
/* 2841 */               if (repoFolder.getDescriptor().getUriString().equals(rd.getUriString()))
/*      */               {
/* 2843 */                 repoFolder.setDescriptor(rd);
/* 2844 */                 found = true;
/* 2845 */                 existingNodes.remove(k);
/* 2846 */                 selectedNode.add(new DefaultMutableTreeNode(repoFolder));
/* 2847 */                 break;
/*      */               }
/*      */             }
/*      */           }
/*      */           
/* 2852 */           if (!found)
/*      */           {
/* 2854 */             RepositoryFolder rf = createRepositoryObject(reportUnit.getServer(), rd);
/* 2855 */             selectedNode.add(new DefaultMutableTreeNode(rf));
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/* 2862 */     for (int i = 0; i < list.size(); i++)
/*      */     {
/* 2864 */       ResourceDescriptor rd = (ResourceDescriptor)list.get(i);
/* 2865 */       if ((rd.getWsType().equals("jrxml")) && (rd.isMainReport()))
/*      */       {
/* 2867 */         list.remove(i);
/*      */         
/* 2869 */         boolean found = false;
/*      */         
/* 2871 */         for (int k = 0; k < existingNodes.size(); k++)
/*      */         {
/* 2873 */           if ((existingNodes.elementAt(k) instanceof RepositoryFolder))
/*      */           {
/* 2875 */             RepositoryFolder repoFolder = (RepositoryFolder)existingNodes.elementAt(k);
/* 2876 */             if (repoFolder.getDescriptor().getUriString().equals(rd.getUriString()))
/*      */             {
/* 2878 */               repoFolder.setDescriptor(rd);
/* 2879 */               found = true;
/* 2880 */               existingNodes.remove(k);
/* 2881 */               selectedNode.add(new DefaultMutableTreeNode(repoFolder));
/* 2882 */               break;
/*      */             }
/*      */           }
/*      */         }
/*      */         
/* 2887 */         if (found)
/*      */           break;
/* 2889 */         RepositoryFolder rf = createRepositoryObject(reportUnit.getServer(), rd);
/* 2890 */         selectedNode.add(new DefaultMutableTreeNode(rf));
/* 2891 */         break;
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 2900 */     DefaultMutableTreeNode controlSet = null;
/*      */     
/*      */ 
/* 2903 */     for (int i = 0; i < selectedNode.getChildCount(); i++)
/*      */     {
/* 2905 */       Object obj = ((DefaultMutableTreeNode)selectedNode.getChildAt(i)).getUserObject();
/* 2906 */       if ((obj instanceof ControlsSet))
/*      */       {
/* 2908 */         controlSet = (DefaultMutableTreeNode)selectedNode.getChildAt(i);
/*      */       }
/*      */     }
/*      */     
/* 2912 */     if (controlSet == null)
/*      */     {
/* 2914 */       ControlsSet cs = new ControlsSet();
/* 2915 */       cs.setReportUnit(reportUnit);
/* 2916 */       controlSet = new DefaultMutableTreeNode(cs);
/* 2917 */       selectedNode.add(controlSet);
/*      */     }
/*      */     
/* 2920 */     controlSet.removeAllChildren();
/*      */     
/* 2922 */     for (int i = 0; i < list.size(); i++)
/*      */     {
/* 2924 */       ResourceDescriptor rd = (ResourceDescriptor)list.get(i);
/* 2925 */       if (rd.getWsType().equals("inputControl"))
/*      */       {
/* 2927 */         RepositoryFolder rf = createRepositoryObject(reportUnit.getServer(), rd);
/* 2928 */         controlSet.add(new DefaultMutableTreeNode(rf));
/*      */       }
/*      */     }
/*      */     
/*      */ 
/* 2933 */     DefaultMutableTreeNode resourcesSet = null;
/* 2934 */     for (int i = 0; i < selectedNode.getChildCount(); i++)
/*      */     {
/* 2936 */       Object obj = ((DefaultMutableTreeNode)selectedNode.getChildAt(i)).getUserObject();
/* 2937 */       if ((obj instanceof ResourcesSet))
/*      */       {
/* 2939 */         resourcesSet = (DefaultMutableTreeNode)selectedNode.getChildAt(i);
/*      */       }
/*      */     }
/*      */     
/* 2943 */     if (resourcesSet == null)
/*      */     {
/* 2945 */       ResourcesSet cs = new ResourcesSet();
/* 2946 */       cs.setReportUnit(reportUnit);
/* 2947 */       resourcesSet = new DefaultMutableTreeNode(cs);
/* 2948 */       selectedNode.add(resourcesSet);
/*      */     }
/* 2950 */     existingNodes = new Vector();
/* 2951 */     for (int i = 0; i < resourcesSet.getChildCount(); i++)
/*      */     {
/* 2953 */       existingNodes.add(((DefaultMutableTreeNode)resourcesSet.getChildAt(i)).getUserObject());
/*      */     }
/*      */     
/* 2956 */     resourcesSet.removeAllChildren();
/*      */     
/* 2958 */     for (int i = 0; i < list.size(); i++)
/*      */     {
/* 2960 */       ResourceDescriptor rd = (ResourceDescriptor)list.get(i);
/* 2961 */       if ((!rd.getWsType().equals("inputControl")) && (!rd.isMainReport()))
/*      */       {
/* 2963 */         if ((!rd.getIsReference()) || (!isDataSource(rd)))
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 2969 */           boolean found = false;
/*      */           
/* 2971 */           for (int k = 0; k < existingNodes.size(); k++)
/*      */           {
/* 2973 */             if ((existingNodes.elementAt(k) instanceof RepositoryFile))
/*      */             {
/* 2975 */               RepositoryFile repoFile = (RepositoryFile)existingNodes.elementAt(k);
/* 2976 */               if (repoFile.getDescriptor().getUriString().equals(rd.getUriString()))
/*      */               {
/* 2978 */                 repoFile.setDescriptor(rd);
/* 2979 */                 found = true;
/* 2980 */                 existingNodes.remove(k);
/* 2981 */                 resourcesSet.add(new DefaultMutableTreeNode(repoFile));
/* 2982 */                 break;
/*      */               }
/*      */             }
/*      */           }
/*      */           
/* 2987 */           if (!found)
/*      */           {
/* 2989 */             RepositoryFolder rf = createRepositoryObject(reportUnit.getServer(), rd);
/* 2990 */             resourcesSet.add(new DefaultMutableTreeNode(rf));
/*      */           }
/*      */         }
/*      */       }
/*      */     }
/*      */     
/* 2996 */     selectedNode.remove(controlSet);
/* 2997 */     selectedNode.add(controlSet);
/*      */     
/* 2999 */     selectedNode.remove(resourcesSet);
/* 3000 */     selectedNode.add(resourcesSet);
/*      */   }
/*      */   
/*      */   public static boolean isDataSource(ResourceDescriptor rd)
/*      */   {
/* 3005 */     if (rd == null) return false;
/* 3006 */     if (rd.getWsType() == null) return false;
/* 3007 */     if ((rd.getWsType().equals("datasource")) || (rd.getWsType().equals("jdbc")) || (rd.getWsType().equals("jndi")) || (rd.getWsType().equals("bean")))
/*      */     {
/*      */ 
/* 3010 */       return true; }
/* 3011 */     return false;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public static RepositoryReportUnit getParentReportUnit(DefaultMutableTreeNode node)
/*      */   {
/* 3020 */     if ((node.getUserObject() instanceof RepositoryReportUnit)) { return (RepositoryReportUnit)node.getUserObject();
/*      */     }
/* 3022 */     Object[] parents = node.getUserObjectPath();
/*      */     
/* 3024 */     for (int i = parents.length - 1; i >= 0; i--)
/*      */     {
/* 3026 */       if ((parents[i] != null) && ((parents[i] instanceof RepositoryReportUnit)))
/*      */       {
/* 3028 */         return (RepositoryReportUnit)parents[i];
/*      */       }
/*      */     }
/*      */     
/* 3032 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   public void showMessageFromWorker(String message)
/*      */   {
/* 3038 */     Runnable r = new Runnable() {
/*      */       private final String val$message;
/*      */       
/* 3041 */       public void run() { JOptionPane.showMessageDialog(MainFrame.getMainInstance(), this.val$message); }
/*      */     };
/*      */     
/*      */ 
/* 3045 */     if (SwingUtilities.isEventDispatchThread())
/*      */     {
/* 3047 */       r.run();
/*      */     }
/*      */     else {
/*      */       try
/*      */       {
/* 3052 */         SwingUtilities.invokeLater(r);
/*      */       }
/*      */       catch (Exception ex) {}
/*      */     }
/*      */   }
/*      */   
/*      */   public boolean isTreeEnabled() {
/* 3059 */     return this.treeEnabled;
/*      */   }
/*      */   
/*      */   public void setTreeEnabled(boolean enabled) {
/* 3063 */     this.treeEnabled = enabled;
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\RepositoryExplorer.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */