/*     */ package com.jaspersoft.jasperserver.irplugin.gui.inputcontrols;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.InputControlQueryDataRow;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ListItem;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.inputcontrols.ui.CheckboxListInputControlUI;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.inputcontrols.ui.InputControlUI;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.inputcontrols.ui.TableListInputControlUI;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MultiSelectInputControl
/*     */   extends BasicInputControl
/*     */ {
/*  43 */   List wrappedItems = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setInputControl(ResourceDescriptor inputControl, List items)
/*     */   {
/*  52 */     this.inputControl = inputControl;
/*     */     
/*  54 */     boolean useCheckboxes = false;
/*     */     
/*  56 */     if ((inputControl.getControlType() == 6) || (inputControl.getControlType() == 7))
/*     */     {
/*     */ 
/*  59 */       useCheckboxes = false;
/*  60 */       setInputControlUI(new TableListInputControlUI());
/*     */     }
/*  62 */     else if ((inputControl.getControlType() == 10) || (inputControl.getControlType() == 11))
/*     */     {
/*     */ 
/*  65 */       useCheckboxes = true;
/*  66 */       setInputControlUI(new CheckboxListInputControlUI());
/*     */     }
/*     */     
/*  69 */     String label = inputControl.getLabel() + (inputControl.isMandatory() ? "*" : "");
/*  70 */     getInputControlUI().setLabel(label);
/*     */     
/*     */ 
/*  73 */     this.wrappedItems = new ArrayList();
/*     */     
/*  75 */     for (int i = 0; (items != null) && (items.size() > i); i++)
/*     */     {
/*  77 */       Object itemObject = items.get(i);
/*  78 */       if ((itemObject instanceof ListItem))
/*     */       {
/*  80 */         ListItem item = (ListItem)itemObject;
/*  81 */         if (useCheckboxes)
/*     */         {
/*  83 */           this.wrappedItems.add(new ListItemWrapper(item));
/*     */         }
/*     */         else
/*     */         {
/*  87 */           InputControlQueryDataRow icqd = new InputControlQueryDataRow();
/*  88 */           icqd.setValue(item.getValue());
/*  89 */           List cols = new ArrayList();
/*  90 */           cols.add(item.getLabel());
/*  91 */           icqd.setColumnValues(cols);
/*  92 */           this.wrappedItems.add(icqd);
/*     */         }
/*     */       }
/*  95 */       else if ((itemObject instanceof InputControlQueryDataRow))
/*     */       {
/*  97 */         InputControlQueryDataRow qd = (InputControlQueryDataRow)itemObject;
/*     */         
/*  99 */         if (useCheckboxes)
/*     */         {
/* 101 */           List itemColumnValues = qd.getColumnValues();
/* 102 */           String text = "";
/*     */           
/* 104 */           for (int k = 0; k < itemColumnValues.size(); k++)
/*     */           {
/* 106 */             if (k > 0) text = text + " | ";
/* 107 */             text = text + itemColumnValues.get(k);
/*     */           }
/* 109 */           this.wrappedItems.add(new ListItemWrapper(new ListItem(text, qd.getValue())));
/*     */         }
/*     */         else
/*     */         {
/* 113 */           this.wrappedItems.add(qd);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 119 */     getInputControlUI().setHistory(this.wrappedItems);
/* 120 */     getInputControlUI().setReadOnly(inputControl.isReadOnly());
/*     */     
/* 122 */     List history = getHistory(inputControl.getUriString());
/*     */     
/* 124 */     if ((history != null) && (history.size() > 0))
/*     */     {
/* 126 */       getInputControlUI().setValue(history.get(0));
/*     */     }
/*     */   }
/*     */   
/*     */   public Object validate() throws InputValidationException
/*     */   {
/* 132 */     return getInputControlUI().getValue();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\inputcontrols\MultiSelectInputControl.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */