/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.jobs;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.MimeType;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RestClientConfiguration;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.Job;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.JobIdListWrapper;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.jaxb.wrappers.JobSummaryListWrapper;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.reportjobmodel.ReportJobModel;
/*     */ import java.io.IOException;
/*     */ import java.io.StringWriter;
/*     */ import java.net.URLEncoder;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import javax.ws.rs.core.MultivaluedHashMap;
/*     */ import javax.ws.rs.core.MultivaluedMap;
/*     */ import javax.xml.bind.JAXBContext;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.codehaus.jackson.map.AnnotationIntrospector;
/*     */ import org.codehaus.jackson.map.ObjectMapper;
/*     */ import org.codehaus.jackson.map.SerializationConfig;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;
/*     */ import org.codehaus.jackson.xc.JaxbAnnotationIntrospector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BatchJobsOperationsAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*  53 */   private static final Log log = LogFactory.getLog(BatchJobsOperationsAdapter.class);
/*     */   private final MultivaluedMap<String, String> params;
/*     */   
/*     */   public BatchJobsOperationsAdapter(SessionStorage sessionStorage)
/*     */   {
/*  58 */     super(sessionStorage);
/*  59 */     this.params = new MultivaluedHashMap();
/*     */   }
/*     */   
/*     */   public BatchJobsOperationsAdapter parameter(JobsParameter parameter, String value) {
/*  63 */     this.params.add(parameter.getName(), value);
/*  64 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<JobSummaryListWrapper> search() {
/*  68 */     return search(null);
/*     */   }
/*     */   
/*     */   public OperationResult<JobSummaryListWrapper> search(Job searchCriteria) {
/*  72 */     JerseyRequest<JobSummaryListWrapper> request = prepareSearchRequest(searchCriteria);
/*  73 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncSearch(Job searchCriteria, final Callback<OperationResult<JobSummaryListWrapper>, R> callback) {
/*  77 */     final JerseyRequest<JobSummaryListWrapper> request = prepareSearchRequest(searchCriteria);
/*  78 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  81 */         callback.execute(request.get());
/*     */       }
/*  83 */     });
/*  84 */     ThreadPoolUtil.runAsynchronously(task);
/*  85 */     return task;
/*     */   }
/*     */   
/*     */   private JerseyRequest<JobSummaryListWrapper> prepareSearchRequest(Job searchCriteria) {
/*  89 */     JerseyRequest<JobSummaryListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobSummaryListWrapper.class, new String[] { "/jobs" });
/*  90 */     request.addParams(this.params);
/*  91 */     if (searchCriteria != null) {
/*  92 */       String criteriaJson = buildJson(searchCriteria);
/*  93 */       request.addParam("example", new String[] { URLEncoder.encode(criteriaJson), "UTF-8" });
/*     */     }
/*  95 */     return request;
/*     */   }
/*     */   
/*     */   private String buildJson(Object object) {
/*  99 */     ObjectMapper mapper = new ObjectMapper();
/* 100 */     SerializationConfig serializationConfig = mapper.getSerializationConfig();
/* 101 */     serializationConfig = serializationConfig.withSerializationInclusion(JsonSerialize.Inclusion.NON_NULL);
/* 102 */     AnnotationIntrospector introspector = new JaxbAnnotationIntrospector();
/* 103 */     mapper.setSerializationConfig(serializationConfig);
/* 104 */     mapper.setAnnotationIntrospector(introspector);
/*     */     try
/*     */     {
/* 107 */       return mapper.writeValueAsString(object);
/*     */     } catch (IOException e) {
/* 109 */       log.warn("Can't marshal search criteria.");
/* 110 */       throw new RuntimeException("Failed inFolder build criteria json.", e);
/*     */     }
/*     */   }
/*     */   
/*     */   private String buildXml(ReportJobModel reportJobModel) {
/*     */     try {
/* 116 */       StringWriter writer = new StringWriter();
/* 117 */       JAXBContext jaxbContext = JAXBContext.newInstance(new Class[] { ReportJobModel.class });
/* 118 */       Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
/* 119 */       jaxbMarshaller.setProperty("jaxb.formatted.output", Boolean.valueOf(true));
/* 120 */       jaxbMarshaller.marshal(reportJobModel, writer);
/* 121 */       return writer.toString();
/*     */     } catch (JAXBException e) {
/* 123 */       log.warn("Can't marshal thumbnail job model.");
/* 124 */       throw new RuntimeException("Failed inFolder build thumbnail job model xml.", e);
/*     */     }
/*     */   }
/*     */   
/*     */   @Deprecated
/*     */   public OperationResult<JobIdListWrapper> updateWithProcessedParameters(ReportJobModel jobModel) {
/* 130 */     throw new UnsupportedOperationException("Operation is not supported yet");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public OperationResult<JobIdListWrapper> update(ReportJobModel jobModel)
/*     */   {
/* 137 */     JerseyRequest<JobIdListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs" });
/* 138 */     request.addParams(this.params);
/*     */     String content;
/*     */     String content;
/* 141 */     if (this.sessionStorage.getConfiguration().getContentMimeType() == MimeType.JSON) {
/* 142 */       content = buildJson(jobModel);
/*     */     } else {
/* 144 */       content = buildXml(jobModel);
/*     */     }
/* 146 */     return request.post(content);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncUpdate(ReportJobModel jobModel, final Callback<OperationResult<JobIdListWrapper>, R> callback) {
/* 150 */     final JerseyRequest<JobIdListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs" });
/* 151 */     request.addParams(this.params);
/* 152 */     final String jobJson = buildJson(jobModel);
/* 153 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 156 */         callback.execute(request.post(jobJson));
/*     */       }
/* 158 */     });
/* 159 */     ThreadPoolUtil.runAsynchronously(task);
/* 160 */     return task;
/*     */   }
/*     */   
/*     */   private List<Long> getIds() {
/* 164 */     List<Long> ids = new ArrayList();
/* 165 */     List<String> idsTemp = (List)this.params.get(JobsParameter.JOB_ID.getName());
/*     */     
/* 167 */     if (idsTemp != null) {
/* 168 */       for (String id : idsTemp) {
/* 169 */         ids.add(Long.valueOf(Long.parseLong(id)));
/*     */       }
/*     */     }
/* 172 */     return ids;
/*     */   }
/*     */   
/*     */   public OperationResult<JobIdListWrapper> pause() {
/* 176 */     JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 177 */     return JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/pause" }).post(jobIdListWrapper);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncPause(final Callback<OperationResult<JobIdListWrapper>, R> callback) {
/* 181 */     final JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 182 */     final JerseyRequest<JobIdListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/pause" });
/* 183 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 186 */         callback.execute(request.post(jobIdListWrapper));
/*     */       }
/* 188 */     });
/* 189 */     ThreadPoolUtil.runAsynchronously(task);
/* 190 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<JobIdListWrapper> resume() {
/* 194 */     JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 195 */     return JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/resume" }).post(jobIdListWrapper);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncResume(final Callback<OperationResult<JobIdListWrapper>, R> callback) {
/* 199 */     final JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 200 */     final JerseyRequest<JobIdListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/resume" });
/* 201 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 204 */         callback.execute(request.post(jobIdListWrapper));
/*     */       }
/* 206 */     });
/* 207 */     ThreadPoolUtil.runAsynchronously(task);
/* 208 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<JobIdListWrapper> restart() {
/* 212 */     JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 213 */     return JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/restart" }).post(jobIdListWrapper);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncRestart(final Callback<OperationResult<JobIdListWrapper>, R> callback) {
/* 217 */     final JobIdListWrapper jobIdListWrapper = new JobIdListWrapper(getIds());
/* 218 */     final JerseyRequest<JobIdListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, JobIdListWrapper.class, new String[] { "/jobs", "/restart" });
/* 219 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 222 */         callback.execute(request.post(jobIdListWrapper));
/*     */       }
/* 224 */     });
/* 225 */     ThreadPoolUtil.runAsynchronously(task);
/* 226 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\jobs\BatchJobsOperationsAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */