/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.permissions;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.permissions.RepositoryPermissionListWrapper;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.MimeTypeUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import javax.ws.rs.core.MultivaluedHashMap;
/*     */ import javax.ws.rs.core.MultivaluedMap;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class PermissionResourceRequestAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final String resourceUri;
/*     */   private final MultivaluedMap<String, String> params;
/*     */   
/*     */   public PermissionResourceRequestAdapter(SessionStorage sessionStorage, String resourceUri)
/*     */   {
/*  39 */     super(sessionStorage);
/*  40 */     this.resourceUri = resourceUri;
/*  41 */     this.params = new MultivaluedHashMap();
/*     */   }
/*     */   
/*     */   public SinglePermissionRecipientRequestAdapter permissionRecipient(PermissionRecipient recipient, String name) {
/*  45 */     String protocol = recipient.getProtocol();
/*  46 */     String uri = protocol + ":%2F" + name;
/*  47 */     return new SinglePermissionRecipientRequestAdapter(this.sessionStorage, this.resourceUri, uri);
/*     */   }
/*     */   
/*     */   public OperationResult<RepositoryPermissionListWrapper> createOrUpdate(RepositoryPermissionListWrapper permissions) {
/*  51 */     JerseyRequest<RepositoryPermissionListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri });
/*  52 */     request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/collection+{mime}"));
/*  53 */     return request.put(permissions);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateOrUpdate(final RepositoryPermissionListWrapper permissions, final Callback<OperationResult<RepositoryPermissionListWrapper>, R> callback) {
/*  57 */     final JerseyRequest<RepositoryPermissionListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri });
/*  58 */     request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/collection+{mime}"));
/*  59 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  62 */         callback.execute(request.put(permissions));
/*     */       }
/*  64 */     });
/*  65 */     ThreadPoolUtil.runAsynchronously(task);
/*  66 */     return task;
/*     */   }
/*     */   
/*     */   public PermissionResourceRequestAdapter param(PermissionResourceParameter resourceParam, String value) {
/*  70 */     this.params.add(resourceParam.getParamName(), value);
/*  71 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<RepositoryPermissionListWrapper> get() {
/*  75 */     JerseyRequest<RepositoryPermissionListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri });
/*  76 */     request.addParams(this.params);
/*  77 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<RepositoryPermissionListWrapper>, R> callback) {
/*  81 */     final JerseyRequest<RepositoryPermissionListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri });
/*  82 */     request.addParams(this.params);
/*  83 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  86 */         callback.execute(request.get());
/*     */       }
/*  88 */     });
/*  89 */     ThreadPoolUtil.runAsynchronously(task);
/*  90 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/*  94 */     return JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri }).delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<RepositoryPermissionListWrapper>, R> callback) {
/*  98 */     final JerseyRequest<RepositoryPermissionListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RepositoryPermissionListWrapper.class, new String[] { "/permissions", this.resourceUri });
/*  99 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 102 */         callback.execute(request.delete());
/*     */       }
/* 104 */     });
/* 105 */     ThreadPoolUtil.runAsynchronously(task);
/* 106 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\permissions\PermissionResourceRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */