/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.reportparameters;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.reports.ReportParameters;
/*    */ import com.jaspersoft.jasperserver.dto.reports.inputcontrols.ReportInputControlsListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ReportParametersAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   protected final String reportUnitUri;
/*    */   protected final MultivaluedMap<String, String> params;
/*    */   private String idsPathSegment;
/*    */   
/*    */   public ReportParametersAdapter(SessionStorage sessionStorage, String reportUnitUri)
/*    */   {
/* 44 */     super(sessionStorage);
/* 45 */     this.params = new MultivaluedHashMap();
/* 46 */     this.reportUnitUri = reportUnitUri;
/*    */   }
/*    */   
/*    */   public ReportParametersAdapter(SessionStorage sessionStorage, String reportUnitUri, String idsPathSegment) {
/* 50 */     this(sessionStorage, reportUnitUri);
/* 51 */     this.idsPathSegment = idsPathSegment;
/*    */   }
/*    */   
/*    */   public ReportParametersAdapter parameter(String name, String value) {
/* 55 */     this.params.add(name, value);
/* 56 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<ReportInputControlsListWrapper> get() {
/* 60 */     JerseyRequest<ReportInputControlsListWrapper> request = prepareRequest();
/* 61 */     return request.post(ReportParametersUtils.toReportParameters(this.params));
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<ReportInputControlsListWrapper>, R> callback) {
/* 65 */     final JerseyRequest<ReportInputControlsListWrapper> request = prepareRequest();
/* 66 */     final ReportParameters reportParameters = ReportParametersUtils.toReportParameters(this.params);
/*    */     
/* 68 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 71 */         callback.execute(request.post(reportParameters));
/*    */       }
/*    */       
/* 74 */     });
/* 75 */     ThreadPoolUtil.runAsynchronously(task);
/* 76 */     return task;
/*    */   }
/*    */   
/*    */   private JerseyRequest<ReportInputControlsListWrapper> prepareRequest() {
/* 80 */     JerseyRequest<ReportInputControlsListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, ReportInputControlsListWrapper.class, new String[] { "/reports", this.reportUnitUri, "/inputControls" }, new DefaultErrorHandler());
/*    */     
/*    */ 
/* 83 */     request.setContentType("application/xml");
/* 84 */     request.setAccept("application/xml");
/* 85 */     if (this.idsPathSegment != null) {
/* 86 */       request.setPath(this.idsPathSegment);
/*    */     }
/* 88 */     return request;
/*    */   }
/*    */   
/*    */   public ReportParametersValuesAdapter values() {
/* 92 */     return new ReportParametersValuesAdapter(this.sessionStorage, this.reportUnitUri, this.idsPathSegment, this.params);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\reportparameters\ReportParametersAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */