/*     */ package com.netapp.asup.data.store;
/*     */ 
/*     */ import com.netapp.asup.adapter.Adapter;
/*     */ import com.netapp.asup.avro.AvroReader;
/*     */ import com.netapp.asup.cache.server.AsupGenericCache;
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.config.ARMAConfiguration;
/*     */ import com.netapp.asup.data.function.FunctionRegistry;
/*     */ import com.netapp.asup.data.function.FunctionRegistryImpl;
/*     */ import com.netapp.asup.data.pojo.ARMAPOJORegistry;
/*     */ import com.netapp.asup.data.pojo.ARMAPOJORegistryImpl;
/*     */ import com.netapp.asup.data.schema.SchemaHelper;
/*     */ import com.netapp.asup.exception.ARMAConfigurationException;
/*     */ import com.netapp.asup.metamodel.MetaModelFactory;
/*     */ import com.netapp.asupdata.client.ARMA.ResultInitializer;
/*     */ import java.lang.reflect.Constructor;
/*     */ import org.apache.avro.Schema;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BaseContainer
/*     */   implements StoreContainer
/*     */ {
/*  24 */   private boolean isInitialized = false;
/*     */   
/*  26 */   private static final BaseContainer container = new BaseContainer();
/*     */   
/*  28 */   private StoreContainer storeContainer = null;
/*     */   
/*     */   private AvroReader avroReader;
/*     */   
/*     */   private FunctionRegistry functionRegistry;
/*     */   
/*     */   private ARMAPOJORegistry pojoRegistry;
/*     */   
/*  36 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(BaseContainer.class);
/*     */   
/*     */   public static BaseContainer getInstance() {
/*  39 */     return container;
/*     */   }
/*     */   
/*     */   public void removeServer(String serverConnection) throws Exception {
/*  43 */     this.storeContainer.removeServer(serverConnection);
/*     */   }
/*     */   
/*     */   public StoreContainer getStoreContainer() {
/*  47 */     return this.storeContainer;
/*     */   }
/*     */   
/*     */   public String getCacheStats() {
/*  51 */     return this.storeContainer.getCacheStats();
/*     */   }
/*     */   
/*     */   public StoreContainer initializeContainer() throws ARMAConfigurationException
/*     */   {
/*  56 */     if (!this.isInitialized) {
/*  57 */       synchronized (this) {
/*  58 */         if (!this.isInitialized)
/*     */         {
/*  60 */           ARMAConfiguration config = new ARMAConfiguration();
/*     */           
/*  62 */           this.avroReader = new AvroReader();
/*     */           
/*     */ 
/*  65 */           this.pojoRegistry = new ARMAPOJORegistryImpl(config);
/*     */           
/*  67 */           Class<?> containerClass = config.getClass("arma.container.class.name", null);
/*  68 */           StoreContainer newInstance = null;
/*     */           try {
/*  70 */             Constructor<?> constructor = containerClass.getConstructor(new Class[] { BaseContainer.class, ARMAConfiguration.class });
/*  71 */             newInstance = (StoreContainer)constructor.newInstance(new Object[] { this, config });
/*  72 */             this.storeContainer = newInstance.initializeContainer();
/*     */           } catch (Exception e) {
/*  74 */             this.storeContainer = null;
/*  75 */             throw new ARMAConfigurationException(LOGGER, "Container initialization failed:" + containerClass.getCanonicalName(), e);
/*     */           }
/*     */           
/*  78 */           this.functionRegistry = new FunctionRegistryImpl();
/*  79 */           this.isInitialized = true;
/*  80 */           return this.storeContainer;
/*     */         }
/*     */       }
/*     */     }
/*  84 */     if (null != this.storeContainer) {
/*  85 */       return this.storeContainer;
/*     */     }
/*  87 */     throw new ARMAConfigurationException(LOGGER, "Base Container initialization failed");
/*     */   }
/*     */   
/*     */ 
/*     */   public void destroyContainer()
/*     */   {
/*  93 */     this.storeContainer.destroyContainer();
/*     */   }
/*     */   
/*     */   public void clearCache()
/*     */   {
/*  98 */     this.storeContainer.clearCache();
/*     */   }
/*     */   
/*     */   public DataStore getStore()
/*     */   {
/* 103 */     throw new UnsupportedOperationException("Method is not supported");
/*     */   }
/*     */   
/*     */   public Adapter getAdapter()
/*     */   {
/* 108 */     throw new UnsupportedOperationException("Method is not supported");
/*     */   }
/*     */   
/*     */   public AsupGenericCache<String, Object> getCache()
/*     */   {
/* 113 */     throw new UnsupportedOperationException("Method is not supported");
/*     */   }
/*     */   
/*     */   public MetaModelFactory getMetaModelprovider()
/*     */   {
/* 118 */     throw new UnsupportedOperationException("Method is not supported");
/*     */   }
/*     */   
/*     */   public SchemaHelper getSchemaHelper()
/*     */   {
/* 123 */     return getStoreContainer().getSchemaHelper();
/*     */   }
/*     */   
/*     */   public AvroReader getAvroReader()
/*     */   {
/* 128 */     return this.avroReader;
/*     */   }
/*     */   
/*     */   public FunctionRegistry getFunctionRegistry()
/*     */   {
/* 133 */     return this.functionRegistry;
/*     */   }
/*     */   
/*     */   public ARMAPOJORegistry getPOJORegistry()
/*     */   {
/* 138 */     return this.pojoRegistry;
/*     */   }
/*     */   
/*     */   public ResultInitializer getResultInitializer()
/*     */   {
/* 143 */     return getStoreContainer().getResultInitializer();
/*     */   }
/*     */   
/*     */   public String getMode()
/*     */   {
/* 148 */     return getStoreContainer().getMode();
/*     */   }
/*     */   
/*     */   public Schema getSchemaFromHDFS(String absolutePath)
/*     */   {
/* 153 */     throw new UnsupportedOperationException("Method is not supported");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\store\BaseContainer.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */