/*     */ package com.sun.xml.bind.api;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.istack.Nullable;
/*     */ import com.sun.istack.Pool;
/*     */ import com.sun.xml.bind.v2.runtime.BridgeContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.Unmarshaller;
/*     */ import javax.xml.bind.attachment.AttachmentMarshaller;
/*     */ import javax.xml.bind.attachment.AttachmentUnmarshaller;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import javax.xml.stream.XMLStreamReader;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.Source;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.ContentHandler;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Bridge<T>
/*     */ {
/*     */   protected final JAXBContextImpl context;
/*     */   
/*     */   protected Bridge(JAXBContextImpl context)
/*     */   {
/*  44 */     this.context = context;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  57 */   public final void marshal(T object, XMLStreamWriter output)
/*  57 */     throws JAXBException { marshal(object, output, null); }
/*     */   
/*     */   public final void marshal(T object, XMLStreamWriter output, AttachmentMarshaller am) throws JAXBException {
/*  60 */     Marshaller m = (Marshaller)this.context.marshallerPool.take();
/*  61 */     m.setAttachmentMarshaller(am);
/*  62 */     marshal(m, object, output);
/*  63 */     m.setAttachmentMarshaller(null);
/*  64 */     this.context.marshallerPool.recycle(m);
/*     */   }
/*     */   
/*     */   public final void marshal(@NotNull BridgeContext context, T object, XMLStreamWriter output) throws JAXBException {
/*  68 */     marshal(((BridgeContextImpl)context).marshaller, object, output);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public abstract void marshal(@NotNull Marshaller paramMarshaller, T paramT, XMLStreamWriter paramXMLStreamWriter)
/*     */     throws JAXBException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void marshal(T object, OutputStream output, NamespaceContext nsContext)
/*     */     throws JAXBException
/*     */   {
/*  88 */     marshal(object, output, nsContext, null);
/*     */   }
/*     */   
/*     */   public void marshal(T object, OutputStream output, NamespaceContext nsContext, AttachmentMarshaller am)
/*     */     throws JAXBException
/*     */   {
/*  94 */     Marshaller m = (Marshaller)this.context.marshallerPool.take();
/*  95 */     m.setAttachmentMarshaller(am);
/*  96 */     marshal(m, object, output, nsContext);
/*  97 */     m.setAttachmentMarshaller(null);
/*  98 */     this.context.marshallerPool.recycle(m);
/*     */   }
/*     */   
/*     */   public final void marshal(@NotNull BridgeContext context, T object, OutputStream output, NamespaceContext nsContext) throws JAXBException {
/* 102 */     marshal(((BridgeContextImpl)context).marshaller, object, output, nsContext);
/*     */   }
/*     */   
/*     */   public abstract void marshal(@NotNull Marshaller paramMarshaller, T paramT, OutputStream paramOutputStream, NamespaceContext paramNamespaceContext) throws JAXBException;
/*     */   
/*     */   public final void marshal(T object, Node output) throws JAXBException
/*     */   {
/* 109 */     Marshaller m = (Marshaller)this.context.marshallerPool.take();
/* 110 */     marshal(m, object, output);
/* 111 */     this.context.marshallerPool.recycle(m);
/*     */   }
/*     */   
/*     */   public final void marshal(@NotNull BridgeContext context, T object, Node output) throws JAXBException {
/* 115 */     marshal(((BridgeContextImpl)context).marshaller, object, output);
/*     */   }
/*     */   
/*     */ 
/*     */   public abstract void marshal(@NotNull Marshaller paramMarshaller, T paramT, Node paramNode)
/*     */     throws JAXBException;
/*     */   
/*     */   public final void marshal(T object, ContentHandler contentHandler)
/*     */     throws JAXBException
/*     */   {
/* 125 */     marshal(object, contentHandler, null);
/*     */   }
/*     */   
/*     */   public final void marshal(T object, ContentHandler contentHandler, AttachmentMarshaller am)
/*     */     throws JAXBException
/*     */   {
/* 131 */     Marshaller m = (Marshaller)this.context.marshallerPool.take();
/* 132 */     m.setAttachmentMarshaller(am);
/* 133 */     marshal(m, object, contentHandler);
/* 134 */     m.setAttachmentMarshaller(null);
/* 135 */     this.context.marshallerPool.recycle(m);
/*     */   }
/*     */   
/* 138 */   public final void marshal(@NotNull BridgeContext context, T object, ContentHandler contentHandler) throws JAXBException { marshal(((BridgeContextImpl)context).marshaller, object, contentHandler); }
/*     */   
/*     */   public abstract void marshal(@NotNull Marshaller paramMarshaller, T paramT, ContentHandler paramContentHandler)
/*     */     throws JAXBException;
/*     */   
/*     */   public final void marshal(T object, Result result)
/*     */     throws JAXBException
/*     */   {
/* 146 */     Marshaller m = (Marshaller)this.context.marshallerPool.take();
/* 147 */     marshal(m, object, result);
/* 148 */     this.context.marshallerPool.recycle(m);
/*     */   }
/*     */   
/* 151 */   public final void marshal(@NotNull BridgeContext context, T object, Result result) throws JAXBException { marshal(((BridgeContextImpl)context).marshaller, object, result); }
/*     */   
/*     */   public abstract void marshal(@NotNull Marshaller paramMarshaller, T paramT, Result paramResult)
/*     */     throws JAXBException;
/*     */   
/*     */   private T exit(T r, Unmarshaller u)
/*     */   {
/* 158 */     u.setAttachmentUnmarshaller(null);
/* 159 */     this.context.unmarshallerPool.recycle(u);
/* 160 */     return r;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull XMLStreamReader in)
/*     */     throws JAXBException
/*     */   {
/* 180 */     return (T)unmarshal(in, null);
/*     */   }
/*     */   
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull XMLStreamReader in, @Nullable AttachmentUnmarshaller au) throws JAXBException
/*     */   {
/* 186 */     Unmarshaller u = (Unmarshaller)this.context.unmarshallerPool.take();
/* 187 */     u.setAttachmentUnmarshaller(au);
/* 188 */     return (T)exit(unmarshal(u, in), u); }
/*     */   
/*     */   @NotNull
/* 191 */   public final T unmarshal(@NotNull BridgeContext context, @NotNull XMLStreamReader in) throws JAXBException { return (T)unmarshal(((BridgeContextImpl)context).unmarshaller, in); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public abstract T unmarshal(@NotNull Unmarshaller paramUnmarshaller, @NotNull XMLStreamReader paramXMLStreamReader)
/*     */     throws JAXBException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull Source in)
/*     */     throws JAXBException
/*     */   {
/* 212 */     return (T)unmarshal(in, null);
/*     */   }
/*     */   
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull Source in, @Nullable AttachmentUnmarshaller au) throws JAXBException
/*     */   {
/* 218 */     Unmarshaller u = (Unmarshaller)this.context.unmarshallerPool.take();
/* 219 */     u.setAttachmentUnmarshaller(au);
/* 220 */     return (T)exit(unmarshal(u, in), u); }
/*     */   
/*     */   @NotNull
/* 223 */   public final T unmarshal(@NotNull BridgeContext context, @NotNull Source in) throws JAXBException { return (T)unmarshal(((BridgeContextImpl)context).unmarshaller, in); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public abstract T unmarshal(@NotNull Unmarshaller paramUnmarshaller, @NotNull Source paramSource)
/*     */     throws JAXBException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull InputStream in)
/*     */     throws JAXBException
/*     */   {
/* 244 */     Unmarshaller u = (Unmarshaller)this.context.unmarshallerPool.take();
/* 245 */     return (T)exit(unmarshal(u, in), u); }
/*     */   
/*     */   @NotNull
/* 248 */   public final T unmarshal(@NotNull BridgeContext context, @NotNull InputStream in) throws JAXBException { return (T)unmarshal(((BridgeContextImpl)context).unmarshaller, in); }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public abstract T unmarshal(@NotNull Unmarshaller paramUnmarshaller, @NotNull InputStream paramInputStream)
/*     */     throws JAXBException;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull Node n)
/*     */     throws JAXBException
/*     */   {
/* 267 */     return (T)unmarshal(n, null);
/*     */   }
/*     */   
/*     */   @NotNull
/*     */   public final T unmarshal(@NotNull Node n, @Nullable AttachmentUnmarshaller au) throws JAXBException
/*     */   {
/* 273 */     Unmarshaller u = (Unmarshaller)this.context.unmarshallerPool.take();
/* 274 */     u.setAttachmentUnmarshaller(au);
/* 275 */     return (T)exit(unmarshal(u, n), u); }
/*     */   
/*     */   @NotNull
/* 278 */   public final T unmarshal(@NotNull BridgeContext context, @NotNull Node n) throws JAXBException { return (T)unmarshal(((BridgeContextImpl)context).unmarshaller, n); }
/*     */   
/*     */   @NotNull
/*     */   public abstract T unmarshal(@NotNull Unmarshaller paramUnmarshaller, @NotNull Node paramNode)
/*     */     throws JAXBException;
/*     */   
/*     */   public abstract TypeReference getTypeReference();
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\api\Bridge.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */