/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*     */ import com.sun.xml.bind.v2.model.core.Element;
/*     */ import com.sun.xml.bind.v2.model.core.EnumLeafInfo;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import java.util.Iterator;
/*     */ import javax.xml.bind.annotation.XmlEnum;
/*     */ import javax.xml.bind.annotation.XmlEnumValue;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class EnumLeafInfoImpl<T, C, F, M>
/*     */   extends TypeInfoImpl<T, C, F, M>
/*     */   implements EnumLeafInfo<T, C>, Element<T, C>, Iterable<EnumConstantImpl<T, C, F, M>>
/*     */ {
/*     */   final C clazz;
/*     */   NonElement<T, C> baseType;
/*     */   private final T type;
/*     */   private final QName typeName;
/*     */   private EnumConstantImpl<T, C, F, M> firstConstant;
/*     */   private QName elementName;
/*     */   
/*     */   public EnumLeafInfoImpl(ModelBuilder<T, C, F, M> builder, Locatable upstream, C clazz, T type)
/*     */   {
/*  60 */     super(builder, upstream);
/*  61 */     this.clazz = clazz;
/*  62 */     this.type = type;
/*     */     
/*  64 */     this.elementName = parseElementName(clazz);
/*     */     
/*     */ 
/*     */ 
/*  68 */     this.typeName = parseTypeName(clazz);
/*     */     
/*     */ 
/*     */ 
/*  72 */     XmlEnum xe = (XmlEnum)builder.reader.getClassAnnotation(XmlEnum.class, clazz, this);
/*  73 */     if (xe != null) {
/*  74 */       T base = builder.reader.getClassValue(xe, "value");
/*  75 */       this.baseType = builder.getTypeInfo(base, this);
/*     */     } else {
/*  77 */       this.baseType = builder.getTypeInfo(builder.nav.ref(String.class), this);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void calcConstants()
/*     */   {
/*  85 */     EnumConstantImpl<T, C, F, M> last = null;
/*  86 */     for (F constant : nav().getEnumConstants(this.clazz)) {
/*  87 */       String name = nav().getFieldName(constant);
/*  88 */       XmlEnumValue xev = (XmlEnumValue)this.builder.reader.getFieldAnnotation(XmlEnumValue.class, constant, this);
/*     */       String literal;
/*     */       String literal;
/*  91 */       if (xev == null) literal = name; else {
/*  92 */         literal = xev.value();
/*     */       }
/*  94 */       last = createEnumConstant(name, literal, constant, last);
/*     */     }
/*  96 */     this.firstConstant = last;
/*     */   }
/*     */   
/*     */   protected EnumConstantImpl<T, C, F, M> createEnumConstant(String name, String literal, F constant, EnumConstantImpl<T, C, F, M> last) {
/* 100 */     return new EnumConstantImpl(this, name, literal, last);
/*     */   }
/*     */   
/*     */   public T getType()
/*     */   {
/* 105 */     return (T)this.type;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public final boolean canBeReferencedByIDREF()
/*     */   {
/* 115 */     return false;
/*     */   }
/*     */   
/*     */   public QName getTypeName() {
/* 119 */     return this.typeName;
/*     */   }
/*     */   
/*     */   public C getClazz() {
/* 123 */     return (C)this.clazz;
/*     */   }
/*     */   
/*     */   public NonElement<T, C> getBaseType() {
/* 127 */     return this.baseType;
/*     */   }
/*     */   
/*     */   public boolean isSimpleType() {
/* 131 */     return true;
/*     */   }
/*     */   
/*     */   public Location getLocation() {
/* 135 */     return nav().getClassLocation(this.clazz);
/*     */   }
/*     */   
/*     */   public Iterable<? extends EnumConstantImpl<T, C, F, M>> getConstants() {
/* 139 */     if (this.firstConstant == null)
/* 140 */       calcConstants();
/* 141 */     return this;
/*     */   }
/*     */   
/*     */   public void link()
/*     */   {
/* 146 */     getConstants();
/* 147 */     super.link();
/*     */   }
/*     */   
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public Element<T, C> getSubstitutionHead()
/*     */   {
/* 156 */     return null;
/*     */   }
/*     */   
/*     */   public QName getElementName() {
/* 160 */     return this.elementName;
/*     */   }
/*     */   
/*     */   public boolean isElement() {
/* 164 */     return this.elementName != null;
/*     */   }
/*     */   
/*     */   public Element<T, C> asElement() {
/* 168 */     if (isElement()) {
/* 169 */       return this;
/*     */     }
/* 171 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public ClassInfo<T, C> getScope()
/*     */   {
/* 182 */     return null;
/*     */   }
/*     */   
/*     */   public Iterator<EnumConstantImpl<T, C, F, M>> iterator() {
/* 186 */     new Iterator() {
/* 187 */       private EnumConstantImpl<T, C, F, M> next = EnumLeafInfoImpl.this.firstConstant;
/*     */       
/* 189 */       public boolean hasNext() { return this.next != null; }
/*     */       
/*     */       public EnumConstantImpl<T, C, F, M> next()
/*     */       {
/* 193 */         EnumConstantImpl<T, C, F, M> r = this.next;
/* 194 */         this.next = this.next.next;
/* 195 */         return r;
/*     */       }
/*     */       
/*     */       public void remove() {
/* 199 */         throw new UnsupportedOperationException();
/*     */       }
/*     */     };
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\EnumLeafInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */