/*     */ package com.sun.xml.bind.v2.runtime.reflect;
/*     */ 
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.runtime.Transducer;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ListTransducedAccessorImpl<BeanT, ListT, ItemT, PackT>
/*     */   extends DefaultTransducedAccessor<BeanT>
/*     */ {
/*     */   private final Transducer<ItemT> xducer;
/*     */   private final Lister<BeanT, ListT, ItemT, PackT> lister;
/*     */   private final Accessor<BeanT, ListT> acc;
/*     */   
/*     */   public ListTransducedAccessorImpl(Transducer<ItemT> xducer, Accessor<BeanT, ListT> acc, Lister<BeanT, ListT, ItemT, PackT> lister)
/*     */   {
/*  32 */     this.xducer = xducer;
/*  33 */     this.lister = lister;
/*  34 */     this.acc = acc;
/*     */   }
/*     */   
/*     */   public boolean useNamespace() {
/*  38 */     return this.xducer.useNamespace();
/*     */   }
/*     */   
/*     */   public void declareNamespace(BeanT bean, XMLSerializer w) throws AccessorException, SAXException {
/*  42 */     ListT list = this.acc.get(bean);
/*     */     
/*  44 */     if (list != null) {
/*  45 */       ListIterator<ItemT> itr = this.lister.iterator(list, w);
/*     */       
/*  47 */       while (itr.hasNext()) {
/*     */         try {
/*  49 */           ItemT item = itr.next();
/*  50 */           if (item != null) {
/*  51 */             this.xducer.declareNamespace(item, w);
/*     */           }
/*     */         } catch (JAXBException e) {
/*  54 */           w.reportError(null, e);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public String print(BeanT o)
/*     */     throws AccessorException, SAXException
/*     */   {
/*  64 */     ListT list = this.acc.get(o);
/*     */     
/*  66 */     if (list == null) {
/*  67 */       return null;
/*     */     }
/*  69 */     StringBuilder buf = new StringBuilder();
/*  70 */     XMLSerializer w = XMLSerializer.getInstance();
/*  71 */     ListIterator<ItemT> itr = this.lister.iterator(list, w);
/*     */     
/*  73 */     while (itr.hasNext()) {
/*     */       try {
/*  75 */         ItemT item = itr.next();
/*  76 */         if (item != null) {
/*  77 */           if (buf.length() > 0) buf.append(' ');
/*  78 */           buf.append(this.xducer.print(item));
/*     */         }
/*     */       } catch (JAXBException e) {
/*  81 */         w.reportError(null, e);
/*     */       }
/*     */     }
/*  84 */     return buf.toString();
/*     */   }
/*     */   
/*     */   private void processValue(BeanT bean, CharSequence s) throws AccessorException, SAXException {
/*  88 */     PackT pack = this.lister.startPacking(bean, this.acc);
/*     */     
/*  90 */     int idx = 0;
/*  91 */     int len = s.length();
/*     */     for (;;)
/*     */     {
/*  94 */       int p = idx;
/*  95 */       while ((p < len) && (!WhiteSpaceProcessor.isWhiteSpace(s.charAt(p)))) {
/*  96 */         p++;
/*     */       }
/*  98 */       CharSequence token = s.subSequence(idx, p);
/*  99 */       if (!token.equals("")) {
/* 100 */         this.lister.addToPack(pack, this.xducer.parse(token));
/*     */       }
/* 102 */       if (p == len)
/*     */         break;
/* 104 */       while ((p < len) && (WhiteSpaceProcessor.isWhiteSpace(s.charAt(p))))
/* 105 */         p++;
/* 106 */       if (p == len)
/*     */         break;
/* 108 */       idx = p;
/*     */     }
/*     */     
/* 111 */     this.lister.endPacking(pack, bean, this.acc);
/*     */   }
/*     */   
/*     */   public void parse(BeanT bean, CharSequence lexical) throws AccessorException, SAXException {
/* 115 */     processValue(bean, lexical);
/*     */   }
/*     */   
/*     */   public boolean hasValue(BeanT bean) throws AccessorException {
/* 119 */     return this.acc.get(bean) != null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\ListTransducedAccessorImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */