/*     */ package com.sun.xml.bind.v2.runtime.reflect.opt;
/*     */ 
/*     */ import com.sun.xml.bind.Util;
/*     */ import java.lang.ref.WeakReference;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.security.AccessController;
/*     */ import java.security.PrivilegedAction;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.WeakHashMap;
/*     */ import java.util.logging.Level;
/*     */ import java.util.logging.Logger;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class Injector
/*     */ {
/*     */   private static final Map<ClassLoader, WeakReference<Injector>> injectors;
/*     */   private static final Logger logger;
/*     */   
/*     */   static Class inject(ClassLoader cl, String className, byte[] image)
/*     */   {
/*  46 */     Injector injector = get(cl);
/*  47 */     if (injector != null) {
/*  48 */       return injector.inject(className, image);
/*     */     }
/*  50 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   static Class find(ClassLoader cl, String className)
/*     */   {
/*  57 */     Injector injector = get(cl);
/*  58 */     if (injector != null) {
/*  59 */       return injector.find(className);
/*     */     }
/*  61 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static Injector get(ClassLoader cl)
/*     */   {
/*  71 */     Injector injector = null;
/*  72 */     WeakReference<Injector> wr = (WeakReference)injectors.get(cl);
/*  73 */     if (wr != null)
/*  74 */       injector = (Injector)wr.get();
/*  75 */     if (injector == null)
/*     */       try {
/*  77 */         injectors.put(cl, new WeakReference(injector = new Injector(cl)));
/*     */       } catch (SecurityException e) {
/*  79 */         logger.log(Level.FINE, "Unable to set up a back-door for the injector", e);
/*  80 */         return null;
/*     */       }
/*  82 */     return injector;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  88 */   private final Map<String, Class> classes = new HashMap();
/*     */   private final ClassLoader parent;
/*     */   private static final Method defineClass;
/*     */   private static final Method resolveClass;
/*     */   
/*     */   static
/*     */   {
/*  34 */     injectors = Collections.synchronizedMap(new WeakHashMap());
/*     */     
/*     */ 
/*  37 */     logger = Util.getClassLogger();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     try
/*     */     {
/*  97 */       defineClass = ClassLoader.class.getDeclaredMethod("defineClass", new Class[] { String.class, byte[].class, Integer.TYPE, Integer.TYPE });
/*  98 */       resolveClass = ClassLoader.class.getDeclaredMethod("resolveClass", new Class[] { Class.class });
/*     */     }
/*     */     catch (NoSuchMethodException e) {
/* 101 */       throw new NoSuchMethodError(e.getMessage());
/*     */     }
/* 103 */     AccessController.doPrivileged(new PrivilegedAction()
/*     */     {
/*     */       public Void run()
/*     */       {
/* 107 */         Injector.defineClass.setAccessible(true);
/* 108 */         Injector.resolveClass.setAccessible(true);
/* 109 */         return null;
/*     */       }
/*     */     });
/*     */   }
/*     */   
/*     */   private Injector(ClassLoader parent) {
/* 115 */     this.parent = parent;
/* 116 */     assert (parent != null);
/*     */   }
/*     */   
/*     */   private synchronized Class inject(String className, byte[] image)
/*     */   {
/* 121 */     Class c = (Class)this.classes.get(className);
/* 122 */     if (c == null)
/*     */     {
/*     */       try {
/* 125 */         c = (Class)defineClass.invoke(this.parent, new Object[] { className.replace('/', '.'), image, Integer.valueOf(0), Integer.valueOf(image.length) });
/* 126 */         resolveClass.invoke(this.parent, new Object[] { c });
/*     */       } catch (IllegalAccessException e) {
/* 128 */         logger.log(Level.FINE, "Unable to inject " + className, e);
/* 129 */         return null;
/*     */       } catch (InvocationTargetException e) {
/* 131 */         logger.log(Level.FINE, "Unable to inject " + className, e);
/* 132 */         return null;
/*     */       } catch (SecurityException e) {
/* 134 */         logger.log(Level.FINE, "Unable to inject " + className, e);
/* 135 */         return null;
/*     */       }
/* 137 */       this.classes.put(className, c);
/*     */     }
/* 139 */     return c;
/*     */   }
/*     */   
/*     */   private synchronized Class find(String className) {
/* 143 */     return (Class)this.classes.get(className);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\opt\Injector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */