/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import java.lang.reflect.Constructor;
/*     */ import javax.xml.stream.Location;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamReader;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class StAXStreamConnector
/*     */   extends StAXConnector
/*     */ {
/*     */   private final XMLStreamReader staxStreamReader;
/*     */   
/*     */   public static StAXConnector create(XMLStreamReader reader, XmlVisitor visitor)
/*     */   {
/*  65 */     if ((reader.getClass() == FI_STAX_READER_CLASS) && (FI_CONNECTOR_CTOR != null)) {
/*     */       try {
/*  67 */         return (StAXConnector)FI_CONNECTOR_CTOR.newInstance(new Object[] { reader, visitor });
/*     */       }
/*     */       catch (Exception t) {}
/*     */     }
/*  71 */     if ((STAX_EX_READER != null) && (STAX_EX_READER.isAssignableFrom(reader.getClass()))) {
/*     */       try {
/*  73 */         return (StAXConnector)STAX_EX_CONNECTOR_CTOR.newInstance(new Object[] { reader, visitor });
/*     */       }
/*     */       catch (Exception t) {}
/*     */     }
/*     */     
/*     */ 
/*  79 */     boolean isZephyr = reader.getClass().getName().equals("com.sun.xml.stream.XMLReaderImpl");
/*  80 */     if (!isZephyr)
/*  81 */       visitor = new InterningXmlVisitor(visitor);
/*  82 */     return new StAXStreamConnector(reader, visitor);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  94 */   protected final StringBuilder buffer = new StringBuilder();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 100 */   protected boolean textReported = false;
/*     */   
/*     */   protected StAXStreamConnector(XMLStreamReader staxStreamReader, XmlVisitor visitor) {
/* 103 */     super(visitor);
/* 104 */     this.staxStreamReader = staxStreamReader;
/*     */   }
/*     */   
/*     */   public void bridge() throws XMLStreamException
/*     */   {
/*     */     try
/*     */     {
/* 111 */       int depth = 0;
/*     */       
/*     */ 
/* 114 */       int event = this.staxStreamReader.getEventType();
/* 115 */       if (event == 7)
/*     */       {
/* 117 */         while (!this.staxStreamReader.isStartElement()) {
/* 118 */           event = this.staxStreamReader.next();
/*     */         }
/*     */       }
/*     */       
/* 122 */       if (event != 1) {
/* 123 */         throw new IllegalStateException("The current event is not START_ELEMENT\n but " + event);
/*     */       }
/* 125 */       handleStartDocument(this.staxStreamReader.getNamespaceContext());
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */       for (;;)
/*     */       {
/* 132 */         switch (event) {
/*     */         case 1: 
/* 134 */           handleStartElement();
/* 135 */           depth++;
/* 136 */           break;
/*     */         case 2: 
/* 138 */           depth--;
/* 139 */           handleEndElement();
/* 140 */           if (depth != 0) {
/*     */             break;
/*     */           }
/*     */           break;
/*     */         case 4: case 6: case 12: 
/* 145 */           handleCharacters();
/*     */         }
/*     */         
/*     */         
/*     */ 
/* 150 */         event = this.staxStreamReader.next();
/*     */       }
/*     */       
/* 153 */       this.staxStreamReader.next();
/*     */       
/* 155 */       handleEndDocument();
/*     */     } catch (SAXException e) {
/* 157 */       throw new XMLStreamException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   protected Location getCurrentLocation() {
/* 162 */     return this.staxStreamReader.getLocation();
/*     */   }
/*     */   
/*     */   protected String getCurrentQName() {
/* 166 */     return getQName(this.staxStreamReader.getPrefix(), this.staxStreamReader.getLocalName());
/*     */   }
/*     */   
/*     */   private void handleEndElement() throws SAXException {
/* 170 */     processText(false);
/*     */     
/*     */ 
/* 173 */     this.tagName.uri = fixNull(this.staxStreamReader.getNamespaceURI());
/* 174 */     this.tagName.local = this.staxStreamReader.getLocalName();
/* 175 */     this.visitor.endElement(this.tagName);
/*     */     
/*     */ 
/* 178 */     int nsCount = this.staxStreamReader.getNamespaceCount();
/* 179 */     for (int i = nsCount - 1; i >= 0; i--) {
/* 180 */       this.visitor.endPrefixMapping(fixNull(this.staxStreamReader.getNamespacePrefix(i)));
/*     */     }
/*     */   }
/*     */   
/*     */   private void handleStartElement() throws SAXException {
/* 185 */     processText(true);
/*     */     
/*     */ 
/* 188 */     int nsCount = this.staxStreamReader.getNamespaceCount();
/* 189 */     for (int i = 0; i < nsCount; i++) {
/* 190 */       this.visitor.startPrefixMapping(fixNull(this.staxStreamReader.getNamespacePrefix(i)), fixNull(this.staxStreamReader.getNamespaceURI(i)));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 196 */     this.tagName.uri = fixNull(this.staxStreamReader.getNamespaceURI());
/* 197 */     this.tagName.local = this.staxStreamReader.getLocalName();
/* 198 */     this.tagName.atts = this.attributes;
/*     */     
/* 200 */     this.visitor.startElement(this.tagName);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 206 */   private final Attributes attributes = new Attributes() {
/*     */     public int getLength() {
/* 208 */       return StAXStreamConnector.this.staxStreamReader.getAttributeCount();
/*     */     }
/*     */     
/*     */     public String getURI(int index) {
/* 212 */       String uri = StAXStreamConnector.this.staxStreamReader.getAttributeNamespace(index);
/* 213 */       if (uri == null) return "";
/* 214 */       return uri;
/*     */     }
/*     */     
/*     */     public String getLocalName(int index) {
/* 218 */       return StAXStreamConnector.this.staxStreamReader.getAttributeLocalName(index);
/*     */     }
/*     */     
/*     */     public String getQName(int index) {
/* 222 */       String prefix = StAXStreamConnector.this.staxStreamReader.getAttributePrefix(index);
/* 223 */       if ((prefix == null) || (prefix.length() == 0)) {
/* 224 */         return getLocalName(index);
/*     */       }
/* 226 */       return prefix + ':' + getLocalName(index);
/*     */     }
/*     */     
/*     */     public String getType(int index) {
/* 230 */       return StAXStreamConnector.this.staxStreamReader.getAttributeType(index);
/*     */     }
/*     */     
/*     */     public String getValue(int index) {
/* 234 */       return StAXStreamConnector.this.staxStreamReader.getAttributeValue(index);
/*     */     }
/*     */     
/*     */     public int getIndex(String uri, String localName) {
/* 238 */       for (int i = getLength() - 1; i >= 0; i--)
/* 239 */         if ((localName.equals(getLocalName(i))) && (uri.equals(getURI(i))))
/* 240 */           return i;
/* 241 */       return -1;
/*     */     }
/*     */     
/*     */ 
/*     */     public int getIndex(String qName)
/*     */     {
/* 247 */       for (int i = getLength() - 1; i >= 0; i--) {
/* 248 */         if (qName.equals(getQName(i)))
/* 249 */           return i;
/*     */       }
/* 251 */       return -1;
/*     */     }
/*     */     
/*     */     public String getType(String uri, String localName) {
/* 255 */       int index = getIndex(uri, localName);
/* 256 */       if (index < 0) return null;
/* 257 */       return getType(index);
/*     */     }
/*     */     
/*     */     public String getType(String qName) {
/* 261 */       int index = getIndex(qName);
/* 262 */       if (index < 0) return null;
/* 263 */       return getType(index);
/*     */     }
/*     */     
/*     */     public String getValue(String uri, String localName) {
/* 267 */       int index = getIndex(uri, localName);
/* 268 */       if (index < 0) return null;
/* 269 */       return getValue(index);
/*     */     }
/*     */     
/*     */     public String getValue(String qName) {
/* 273 */       int index = getIndex(qName);
/* 274 */       if (index < 0) return null;
/* 275 */       return getValue(index);
/*     */     }
/*     */   };
/*     */   
/*     */   protected void handleCharacters() throws XMLStreamException, SAXException {
/* 280 */     if (this.predictor.expectText()) {
/* 281 */       this.buffer.append(this.staxStreamReader.getTextCharacters(), this.staxStreamReader.getTextStart(), this.staxStreamReader.getTextLength());
/*     */     }
/*     */   }
/*     */   
/*     */   private void processText(boolean ignorable)
/*     */     throws SAXException
/*     */   {
/* 288 */     if ((this.predictor.expectText()) && ((!ignorable) || (!WhiteSpaceProcessor.isWhiteSpace(this.buffer)))) {
/* 289 */       if (this.textReported) {
/* 290 */         this.textReported = false;
/*     */       } else {
/* 292 */         this.visitor.text(this.buffer);
/*     */       }
/*     */     }
/* 295 */     this.buffer.setLength(0);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 303 */   private static final Class FI_STAX_READER_CLASS = ;
/* 304 */   private static final Constructor<? extends StAXConnector> FI_CONNECTOR_CTOR = initFastInfosetConnectorClass();
/*     */   
/*     */   private static Class initFIStAXReaderClass() {
/*     */     try {
/* 308 */       return UnmarshallerImpl.class.getClassLoader().loadClass("com.sun.xml.fastinfoset.stax.StAXDocumentParser");
/*     */     } catch (Throwable e) {}
/* 310 */     return null;
/*     */   }
/*     */   
/*     */   private static Constructor<? extends StAXConnector> initFastInfosetConnectorClass()
/*     */   {
/*     */     try {
/* 316 */       Class c = UnmarshallerImpl.class.getClassLoader().loadClass("com.sun.xml.bind.v2.runtime.unmarshaller.FastInfosetConnector");
/* 317 */       return c.getConstructor(new Class[] { FI_STAX_READER_CLASS, XmlVisitor.class });
/*     */     } catch (Throwable e) {}
/* 319 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 327 */   private static final Class STAX_EX_READER = initStAXExReader();
/* 328 */   private static final Constructor<? extends StAXConnector> STAX_EX_CONNECTOR_CTOR = initStAXExConnector();
/*     */   
/*     */   private static Class initStAXExReader() {
/*     */     try {
/* 332 */       return UnmarshallerImpl.class.getClassLoader().loadClass("org.jvnet.staxex.XMLStreamReaderEx");
/*     */     } catch (Throwable e) {}
/* 334 */     return null;
/*     */   }
/*     */   
/*     */   private static Constructor<? extends StAXConnector> initStAXExConnector()
/*     */   {
/*     */     try {
/* 340 */       Class c = UnmarshallerImpl.class.getClassLoader().loadClass("com.sun.xml.bind.v2.runtime.unmarshaller.StAXExConnector");
/* 341 */       return c.getConstructor(new Class[] { STAX_EX_READER, XmlVisitor.class });
/*     */     } catch (Throwable e) {}
/* 343 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\StAXStreamConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */