/*     */ package com.sun.xml.txw2;
/*     */ 
/*     */ import java.util.EmptyStackException;
/*     */ import java.util.Enumeration;
/*     */ import java.util.Hashtable;
/*     */ import java.util.Vector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class NamespaceSupport
/*     */ {
/*     */   public static final String XMLNS = "http://www.w3.org/XML/1998/namespace";
/*     */   public static final String NSDECL = "http://www.w3.org/xmlns/2000/";
/* 116 */   private static final Enumeration EMPTY_ENUMERATION = new Vector().elements();
/*     */   
/*     */ 
/*     */   private Context[] contexts;
/*     */   
/*     */   private Context currentContext;
/*     */   
/*     */   private int contextPos;
/*     */   
/*     */   private boolean namespaceDeclUris;
/*     */   
/*     */ 
/*     */   public NamespaceSupport()
/*     */   {
/* 130 */     reset();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void reset()
/*     */   {
/* 153 */     this.contexts = new Context[32];
/* 154 */     this.namespaceDeclUris = false;
/* 155 */     this.contextPos = 0;
/* 156 */     this.contexts[this.contextPos] = (this.currentContext = new Context());
/* 157 */     this.currentContext.declarePrefix("xml", "http://www.w3.org/XML/1998/namespace");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void pushContext()
/*     */   {
/* 199 */     int max = this.contexts.length;
/*     */     
/* 201 */     this.contextPos += 1;
/*     */     
/*     */ 
/* 204 */     if (this.contextPos >= max) {
/* 205 */       Context[] newContexts = new Context[max * 2];
/* 206 */       System.arraycopy(this.contexts, 0, newContexts, 0, max);
/* 207 */       max *= 2;
/* 208 */       this.contexts = newContexts;
/*     */     }
/*     */     
/*     */ 
/* 212 */     this.currentContext = this.contexts[this.contextPos];
/* 213 */     if (this.currentContext == null) {
/* 214 */       this.contexts[this.contextPos] = (this.currentContext = new Context());
/*     */     }
/*     */     
/*     */ 
/* 218 */     if (this.contextPos > 0) {
/* 219 */       this.currentContext.setParent(this.contexts[(this.contextPos - 1)]);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void popContext()
/*     */   {
/* 239 */     this.contexts[this.contextPos].clear();
/* 240 */     this.contextPos -= 1;
/* 241 */     if (this.contextPos < 0) {
/* 242 */       throw new EmptyStackException();
/*     */     }
/* 244 */     this.currentContext = this.contexts[this.contextPos];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean declarePrefix(String prefix, String uri)
/*     */   {
/* 289 */     if ((prefix.equals("xml")) || (prefix.equals("xmlns"))) {
/* 290 */       return false;
/*     */     }
/* 292 */     this.currentContext.declarePrefix(prefix, uri);
/* 293 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String[] processName(String qName, String[] parts, boolean isAttribute)
/*     */   {
/* 341 */     String[] myParts = this.currentContext.processName(qName, isAttribute);
/* 342 */     if (myParts == null) {
/* 343 */       return null;
/*     */     }
/* 345 */     parts[0] = myParts[0];
/* 346 */     parts[1] = myParts[1];
/* 347 */     parts[2] = myParts[2];
/* 348 */     return parts;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getURI(String prefix)
/*     */   {
/* 367 */     return this.currentContext.getURI(prefix);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Enumeration getPrefixes()
/*     */   {
/* 387 */     return this.currentContext.getPrefixes();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getPrefix(String uri)
/*     */   {
/* 412 */     return this.currentContext.getPrefix(uri);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Enumeration getPrefixes(String uri)
/*     */   {
/* 441 */     Vector prefixes = new Vector();
/* 442 */     Enumeration allPrefixes = getPrefixes();
/* 443 */     while (allPrefixes.hasMoreElements()) {
/* 444 */       String prefix = (String)allPrefixes.nextElement();
/* 445 */       if (uri.equals(getURI(prefix))) {
/* 446 */         prefixes.addElement(prefix);
/*     */       }
/*     */     }
/* 449 */     return prefixes.elements();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Enumeration getDeclaredPrefixes()
/*     */   {
/* 467 */     return this.currentContext.getDeclaredPrefixes();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setNamespaceDeclUris(boolean value)
/*     */   {
/* 483 */     if (this.contextPos != 0)
/* 484 */       throw new IllegalStateException();
/* 485 */     if (value == this.namespaceDeclUris)
/* 486 */       return;
/* 487 */     this.namespaceDeclUris = value;
/* 488 */     if (value) {
/* 489 */       this.currentContext.declarePrefix("xmlns", "http://www.w3.org/xmlns/2000/");
/*     */     } else {
/* 491 */       this.contexts[this.contextPos] = (this.currentContext = new Context());
/* 492 */       this.currentContext.declarePrefix("xml", "http://www.w3.org/XML/1998/namespace");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isNamespaceDeclUris()
/*     */   {
/* 503 */     return this.namespaceDeclUris;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   final class Context
/*     */   {
/*     */     Hashtable prefixTable;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Hashtable uriTable;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Hashtable elementNameTable;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Hashtable attributeNameTable;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Context()
/*     */     {
/* 540 */       copyTables();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     void setParent(Context parent)
/*     */     {
/* 553 */       this.parent = parent;
/* 554 */       this.declarations = null;
/* 555 */       this.prefixTable = parent.prefixTable;
/* 556 */       this.uriTable = parent.uriTable;
/* 557 */       this.elementNameTable = parent.elementNameTable;
/* 558 */       this.attributeNameTable = parent.attributeNameTable;
/* 559 */       this.defaultNS = parent.defaultNS;
/* 560 */       this.declSeen = false;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     void clear()
/*     */     {
/* 571 */       this.parent = null;
/* 572 */       this.prefixTable = null;
/* 573 */       this.uriTable = null;
/* 574 */       this.elementNameTable = null;
/* 575 */       this.attributeNameTable = null;
/* 576 */       this.defaultNS = "";
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     void declarePrefix(String prefix, String uri)
/*     */     {
/* 593 */       if (!this.declSeen) {
/* 594 */         copyTables();
/*     */       }
/* 596 */       if (this.declarations == null) {
/* 597 */         this.declarations = new Vector();
/*     */       }
/*     */       
/* 600 */       prefix = prefix.intern();
/* 601 */       uri = uri.intern();
/* 602 */       if ("".equals(prefix)) {
/* 603 */         this.defaultNS = uri;
/*     */       } else {
/* 605 */         this.prefixTable.put(prefix, uri);
/* 606 */         this.uriTable.put(uri, prefix);
/*     */       }
/* 608 */       this.declarations.addElement(prefix);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     String[] processName(String qName, boolean isAttribute)
/*     */     {
/*     */       Hashtable table;
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       Hashtable table;
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 629 */       if (isAttribute) {
/* 630 */         table = this.attributeNameTable;
/*     */       } else {
/* 632 */         table = this.elementNameTable;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 638 */       String[] name = (String[])table.get(qName);
/* 639 */       if (name != null) {
/* 640 */         return name;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 647 */       name = new String[3];
/* 648 */       name[2] = qName.intern();
/* 649 */       int index = qName.indexOf(':');
/*     */       
/*     */ 
/*     */ 
/* 653 */       if (index == -1) {
/* 654 */         if (isAttribute) {
/* 655 */           if ((qName == "xmlns") && (NamespaceSupport.this.namespaceDeclUris)) {
/* 656 */             name[0] = "http://www.w3.org/xmlns/2000/";
/*     */           } else
/* 658 */             name[0] = "";
/*     */         } else {
/* 660 */           name[0] = this.defaultNS;
/*     */         }
/* 662 */         name[1] = name[2];
/*     */ 
/*     */       }
/*     */       else
/*     */       {
/* 667 */         String prefix = qName.substring(0, index);
/* 668 */         String local = qName.substring(index + 1);
/*     */         String uri;
/* 670 */         String uri; if ("".equals(prefix)) {
/* 671 */           uri = this.defaultNS;
/*     */         } else {
/* 673 */           uri = (String)this.prefixTable.get(prefix);
/*     */         }
/* 675 */         if ((uri == null) || ((!isAttribute) && ("xmlns".equals(prefix))))
/*     */         {
/* 677 */           return null;
/*     */         }
/* 679 */         name[0] = uri;
/* 680 */         name[1] = local.intern();
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 685 */       table.put(name[2], name);
/* 686 */       return name;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     String getURI(String prefix)
/*     */     {
/* 700 */       if ("".equals(prefix))
/* 701 */         return this.defaultNS;
/* 702 */       if (this.prefixTable == null) {
/* 703 */         return null;
/*     */       }
/* 705 */       return (String)this.prefixTable.get(prefix);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     String getPrefix(String uri)
/*     */     {
/* 722 */       if (this.uriTable == null) {
/* 723 */         return null;
/*     */       }
/* 725 */       return (String)this.uriTable.get(uri);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Enumeration getDeclaredPrefixes()
/*     */     {
/* 738 */       if (this.declarations == null) {
/* 739 */         return NamespaceSupport.EMPTY_ENUMERATION;
/*     */       }
/* 741 */       return this.declarations.elements();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     Enumeration getPrefixes()
/*     */     {
/* 757 */       if (this.prefixTable == null) {
/* 758 */         return NamespaceSupport.EMPTY_ENUMERATION;
/*     */       }
/* 760 */       return this.prefixTable.keys();
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     private void copyTables()
/*     */     {
/* 779 */       if (this.prefixTable != null) {
/* 780 */         this.prefixTable = ((Hashtable)this.prefixTable.clone());
/*     */       } else {
/* 782 */         this.prefixTable = new Hashtable();
/*     */       }
/* 784 */       if (this.uriTable != null) {
/* 785 */         this.uriTable = ((Hashtable)this.uriTable.clone());
/*     */       } else {
/* 787 */         this.uriTable = new Hashtable();
/*     */       }
/* 789 */       this.elementNameTable = new Hashtable();
/* 790 */       this.attributeNameTable = new Hashtable();
/* 791 */       this.declSeen = true;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 804 */     String defaultNS = "";
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 812 */     private Vector declarations = null;
/* 813 */     private boolean declSeen = false;
/* 814 */     private Context parent = null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\NamespaceSupport.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */