/*     */ package net.rubyeye.xmemcached.command.binary;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.command.ServerAddressAware;
/*     */ import net.rubyeye.xmemcached.exception.UnknownCommandException;
/*     */ import net.rubyeye.xmemcached.transcoders.CachedData;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BinaryStatsCommand
/*     */   extends BaseBinaryCommand
/*     */   implements ServerAddressAware
/*     */ {
/*     */   private InetSocketAddress server;
/*     */   private String itemName;
/*     */   private String currentResponseItem;
/*     */   
/*     */   public String getItemName()
/*     */   {
/*  49 */     return this.itemName;
/*     */   }
/*     */   
/*     */   public final InetSocketAddress getServer() {
/*  53 */     return this.server;
/*     */   }
/*     */   
/*     */   public final void setServer(InetSocketAddress server) {
/*  57 */     this.server = server;
/*     */   }
/*     */   
/*     */   public void setItemName(String item) {
/*  61 */     this.itemName = item;
/*     */   }
/*     */   
/*     */   public BinaryStatsCommand(InetSocketAddress server, CountDownLatch latch, String itemName)
/*     */   {
/*  66 */     super(null, null, CommandType.STATS, latch, 0, 0L, null, false, null);
/*  67 */     this.server = server;
/*  68 */     this.itemName = itemName;
/*  69 */     this.opCode = OpCode.STAT;
/*  70 */     this.result = new HashMap();
/*     */   }
/*     */   
/*     */ 
/*     */   protected boolean finish()
/*     */   {
/*  76 */     if (this.currentResponseItem == null) {
/*  77 */       return super.finish();
/*     */     }
/*     */     
/*  80 */     this.currentResponseItem = null;
/*  81 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void readStatus(ByteBuffer buffer)
/*     */   {
/*  89 */     ResponseStatus responseStatus = ResponseStatus.parseShort(buffer.getShort());
/*     */     
/*  91 */     if (responseStatus == ResponseStatus.UNKNOWN_COMMAND) {
/*  92 */       setException(new UnknownCommandException());
/*     */     }
/*     */   }
/*     */   
/*     */   protected boolean readKey(ByteBuffer buffer, int keyLength)
/*     */   {
/*  98 */     if (buffer.remaining() < keyLength) {
/*  99 */       return false;
/*     */     }
/* 101 */     if (keyLength > 0) {
/* 102 */       byte[] bytes = new byte[keyLength];
/* 103 */       buffer.get(bytes);
/* 104 */       this.currentResponseItem = new String(bytes);
/*     */     }
/* 106 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected boolean readValue(ByteBuffer buffer, int bodyLength, int keyLength, int extrasLength)
/*     */   {
/* 113 */     int valueLength = bodyLength - keyLength - extrasLength;
/* 114 */     if (buffer.remaining() < valueLength) {
/* 115 */       return false;
/*     */     }
/* 117 */     if (valueLength > 0) {
/* 118 */       byte[] bytes = new byte[valueLength];
/* 119 */       buffer.get(bytes);
/* 120 */       String value = new String(bytes);
/* 121 */       ((Map)this.result).put(this.currentResponseItem, value);
/*     */     }
/*     */     
/* 124 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void fillExtras(CachedData data) {}
/*     */   
/*     */ 
/*     */ 
/*     */   protected void fillValue(CachedData data) {}
/*     */   
/*     */ 
/*     */ 
/*     */   protected byte getExtrasLength()
/*     */   {
/* 139 */     return 0;
/*     */   }
/*     */   
/*     */   protected int getValueLength(CachedData data)
/*     */   {
/* 144 */     return 0;
/*     */   }
/*     */   
/*     */   protected void fillKey()
/*     */   {
/* 149 */     if (this.itemName != null) {
/* 150 */       byte[] keyBytes = ByteUtils.getBytes(this.itemName);
/* 151 */       this.ioBuffer.put(keyBytes);
/*     */     }
/*     */   }
/*     */   
/*     */   protected int getKeyLength()
/*     */   {
/* 157 */     if (this.itemName != null) {
/* 158 */       return this.itemName.length();
/*     */     }
/* 160 */     return 0;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\binary\BinaryStatsCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */