/*     */ package net.rubyeye.xmemcached.transcoders;
/*     */ 
/*     */ import net.rubyeye.xmemcached.exception.MemcachedDecodeException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TokyoTyrantTranscoder
/*     */   implements Transcoder<Object>
/*     */ {
/*     */   private final SerializingTranscoder serializingTranscoder;
/*     */   
/*     */   public TokyoTyrantTranscoder(int maxSize)
/*     */   {
/*  37 */     this.serializingTranscoder = new SerializingTranscoder(maxSize);
/*  38 */     this.serializingTranscoder.setPackZeros(false);
/*     */   }
/*     */   
/*     */   public TokyoTyrantTranscoder() {
/*  42 */     this.serializingTranscoder = new SerializingTranscoder();
/*  43 */     this.serializingTranscoder.setPackZeros(false);
/*     */   }
/*     */   
/*     */   public final Object decode(CachedData d) {
/*  47 */     byte[] compositeData = d.getData();
/*  48 */     if (compositeData.length <= 4) {
/*  49 */       throw new MemcachedDecodeException("There are no four bytes before value for TokyoTyrantTranscoder");
/*     */     }
/*  51 */     byte[] flagBytes = new byte[4];
/*  52 */     byte[] realData = new byte[compositeData.length - 4];
/*  53 */     System.arraycopy(compositeData, 0, flagBytes, 0, 4);
/*  54 */     System.arraycopy(compositeData, 4, realData, 0, compositeData.length - 4);
/*     */     
/*  56 */     int flag = this.serializingTranscoder.getTranscoderUtils().decodeInt(flagBytes);
/*     */     
/*  58 */     d.setFlag(flag);
/*  59 */     if ((flag & 0x2) != 0) {
/*  60 */       realData = this.serializingTranscoder.decompress(realData);
/*     */     }
/*  62 */     flag &= 0xFF00;
/*  63 */     return this.serializingTranscoder.decode0(d, realData, flag);
/*     */   }
/*     */   
/*     */ 
/*     */   public void setCompressionMode(CompressionMode compressMode)
/*     */   {
/*  69 */     this.serializingTranscoder.setCompressionMode(compressMode);
/*     */   }
/*     */   
/*     */   public final CachedData encode(Object o) {
/*  73 */     CachedData result = this.serializingTranscoder.encode(o);
/*  74 */     byte[] realData = result.getData();
/*  75 */     int flag = result.getFlag();
/*  76 */     byte[] flagBytes = this.serializingTranscoder.getTranscoderUtils().encodeInt(flag);
/*     */     
/*     */ 
/*  79 */     byte[] compisiteData = new byte[4 + realData.length];
/*  80 */     System.arraycopy(flagBytes, 0, compisiteData, 0, 4);
/*  81 */     System.arraycopy(realData, 0, compisiteData, 4, realData.length);
/*     */     
/*  83 */     result.setData(compisiteData);
/*  84 */     return result;
/*     */   }
/*     */   
/*     */   public final int getMaxSize() {
/*  88 */     return this.serializingTranscoder.getMaxSize();
/*     */   }
/*     */   
/*     */   public boolean isPackZeros() {
/*  92 */     return this.serializingTranscoder.isPackZeros();
/*     */   }
/*     */   
/*     */   public boolean isPrimitiveAsString() {
/*  96 */     return this.serializingTranscoder.isPrimitiveAsString();
/*     */   }
/*     */   
/*     */   public void setCharset(String to) {
/* 100 */     this.serializingTranscoder.setCharset(to);
/*     */   }
/*     */   
/*     */   public void setCompressionThreshold(int to) {
/* 104 */     this.serializingTranscoder.setCompressionThreshold(to);
/*     */   }
/*     */   
/*     */   public void setPackZeros(boolean packZeros) {
/* 108 */     throw new UnsupportedOperationException("TokyoTyrantTranscoder doesn't support pack zeros");
/*     */   }
/*     */   
/*     */   public void setPrimitiveAsString(boolean primitiveAsString)
/*     */   {
/* 113 */     throw new UnsupportedOperationException("TokyoTyrantTranscoder doesn't support save primitive type as String");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\transcoders\TokyoTyrantTranscoder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */