/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.builder;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientFile;
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientReference;
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientReferenceableFile;
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientReportUnit;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.support.decorator.ReportUnitResourceOperationProcessorDecorator;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.sun.jersey.multipart.FormDataMultiPart;
/*    */ import java.io.InputStream;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import javax.ws.rs.core.MediaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ReportUnitResourceBuilder
/*    */   extends ReportUnitResourceOperationProcessorDecorator
/*    */ {
/*    */   public ReportUnitResourceBuilder(ClientReportUnit entity, SessionStorage sessionStorage)
/*    */   {
/* 40 */     super(entity, sessionStorage);
/*    */   }
/*    */   
/*    */   public ReportUnitResourceBuilder withJrxml(InputStream jrxml, ClientFile jrxmlDescriptor) {
/* 44 */     this.multipart.field("jrxml", jrxml, MediaType.APPLICATION_XML_TYPE);
/* 45 */     this.reportUnit.setJrxml(jrxmlDescriptor);
/* 46 */     return this;
/*    */   }
/*    */   
/*    */   public ReportUnitResourceBuilder withJrxml(String jrxml, ClientFile jrxmlDescriptor) {
/* 50 */     this.multipart.field("jrxml", jrxml, MediaType.APPLICATION_XML_TYPE);
/* 51 */     this.reportUnit.setJrxml(jrxmlDescriptor);
/* 52 */     return this;
/*    */   }
/*    */   
/*    */   public ReportUnitResourceBuilder withNewFile(String content, String fileName, ClientFile fileDescriptor) {
/* 56 */     this.multipart.field("files." + fileName, content, MediaType.TEXT_PLAIN_TYPE);
/* 57 */     Map<String, ClientReferenceableFile> files = this.reportUnit.getFiles();
/* 58 */     if (files != null) {
/* 59 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     } else {
/* 61 */       this.reportUnit.setFiles(new HashMap());
/* 62 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     }
/* 64 */     return this;
/*    */   }
/*    */   
/*    */   public ReportUnitResourceBuilder withNewFile(InputStream content, String fileName, ClientFile fileDescriptor) {
/* 68 */     this.multipart.field("files." + fileName, content, MediaType.TEXT_PLAIN_TYPE);
/* 69 */     Map<String, ClientReferenceableFile> files = this.reportUnit.getFiles();
/* 70 */     if (files != null) {
/* 71 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     } else {
/* 73 */       this.reportUnit.setFiles(new HashMap());
/* 74 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     }
/* 76 */     return this;
/*    */   }
/*    */   
/*    */   public ReportUnitResourceBuilder withNewFileReference(String fileName, ClientReference fileDescriptor) {
/* 80 */     Map<String, ClientReferenceableFile> files = this.reportUnit.getFiles();
/* 81 */     if (files != null) {
/* 82 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     } else {
/* 84 */       this.reportUnit.setFiles(new HashMap());
/* 85 */       this.reportUnit.getFiles().put(fileName, fileDescriptor);
/*    */     }
/* 87 */     return this;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\support\builder\ReportUnitResourceBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */