/*    */ package com.sun.xml.bind.v2.model.impl;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*    */ import com.sun.xml.bind.v2.model.annotation.AnnotationSource;
/*    */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*    */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*    */ import javax.activation.MimeType;
/*    */ import javax.activation.MimeTypeParseException;
/*    */ import javax.xml.bind.annotation.XmlMimeType;
/*    */ import javax.xml.bind.annotation.XmlSchemaType;
/*    */ import javax.xml.bind.annotation.XmlSchemaTypes;
/*    */ import javax.xml.namespace.QName;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class Util
/*    */ {
/*    */   static <T, C, F, M> QName calcSchemaType(AnnotationReader<T, C, F, M> reader, AnnotationSource primarySource, C enclosingClass, T individualType, Locatable src)
/*    */   {
/* 25 */     XmlSchemaType xst = (XmlSchemaType)primarySource.readAnnotation(XmlSchemaType.class);
/* 26 */     if (xst != null) {
/* 27 */       return new QName(xst.namespace(), xst.name());
/*    */     }
/*    */     
/*    */ 
/* 31 */     XmlSchemaTypes xsts = (XmlSchemaTypes)reader.getPackageAnnotation(XmlSchemaTypes.class, enclosingClass, src);
/* 32 */     XmlSchemaType[] values = null;
/* 33 */     if (xsts != null) {
/* 34 */       values = xsts.value();
/*    */     } else {
/* 36 */       xst = (XmlSchemaType)reader.getPackageAnnotation(XmlSchemaType.class, enclosingClass, src);
/* 37 */       if (xst != null) {
/* 38 */         values = new XmlSchemaType[1];
/* 39 */         values[0] = xst;
/*    */       }
/*    */     }
/* 42 */     if (values != null) {
/* 43 */       for (XmlSchemaType item : values) {
/* 44 */         if (reader.getClassValue(item, "type").equals(individualType)) {
/* 45 */           return new QName(item.namespace(), item.name());
/*    */         }
/*    */       }
/*    */     }
/*    */     
/* 50 */     return null;
/*    */   }
/*    */   
/*    */   static MimeType calcExpectedMediaType(AnnotationSource primarySource, ModelBuilder builder)
/*    */   {
/* 55 */     XmlMimeType xmt = (XmlMimeType)primarySource.readAnnotation(XmlMimeType.class);
/* 56 */     if (xmt == null) {
/* 57 */       return null;
/*    */     }
/*    */     try {
/* 60 */       return new MimeType(xmt.value());
/*    */     } catch (MimeTypeParseException e) {
/* 62 */       builder.reportError(new IllegalAnnotationException(Messages.ILLEGAL_MIME_TYPE.format(new Object[] { xmt.value(), e.getMessage() }), xmt));
/*    */     }
/*    */     
/*    */ 
/* 66 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\Util.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */