/*    */ package com.sun.xml.bind.v2.util;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import java.io.InputStreamReader;
/*    */ import java.io.Reader;
/*    */ import javax.activation.DataHandler;
/*    */ import javax.activation.DataSource;
/*    */ import javax.activation.MimeType;
/*    */ import javax.activation.MimeTypeParseException;
/*    */ import javax.xml.transform.stream.StreamSource;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class DataSourceSource
/*    */   extends StreamSource
/*    */ {
/*    */   private final DataSource source;
/*    */   private final String charset;
/*    */   
/*    */   public DataSourceSource(DataHandler dh)
/*    */     throws MimeTypeParseException
/*    */   {
/* 38 */     this(dh.getDataSource());
/*    */   }
/*    */   
/*    */   public DataSourceSource(DataSource source) throws MimeTypeParseException {
/* 42 */     this.source = source;
/*    */     
/* 44 */     String ct = source.getContentType();
/* 45 */     if (ct == null) {
/* 46 */       this.charset = null;
/*    */     } else {
/* 48 */       MimeType mimeType = new MimeType(ct);
/* 49 */       this.charset = mimeType.getParameter("charset");
/*    */     }
/*    */   }
/*    */   
/*    */   public void setReader(Reader reader)
/*    */   {
/* 55 */     throw new UnsupportedOperationException();
/*    */   }
/*    */   
/*    */   public void setInputStream(InputStream inputStream)
/*    */   {
/* 60 */     throw new UnsupportedOperationException();
/*    */   }
/*    */   
/*    */   public Reader getReader()
/*    */   {
/*    */     try {
/* 66 */       if (this.charset == null) return null;
/* 67 */       return new InputStreamReader(this.source.getInputStream(), this.charset);
/*    */     }
/*    */     catch (IOException e) {
/* 70 */       throw new RuntimeException(e);
/*    */     }
/*    */   }
/*    */   
/*    */   public InputStream getInputStream()
/*    */   {
/*    */     try {
/* 77 */       if (this.charset == null) return this.source.getInputStream();
/* 78 */       return null;
/*    */     }
/*    */     catch (IOException e) {
/* 81 */       throw new RuntimeException(e);
/*    */     }
/*    */   }
/*    */   
/*    */   public DataSource getDataSource() {
/* 86 */     return this.source;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\util\DataSourceSource.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */