/*    */ package net.rubyeye.xmemcached.transcoders;
/*    */ 
/*    */ import org.slf4j.Logger;
/*    */ import org.slf4j.LoggerFactory;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class LongTranscoder
/*    */   extends PrimitiveTypeTranscoder<Long>
/*    */ {
/* 12 */   private static final Logger log = LoggerFactory.getLogger(LongTranscoder.class);
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public CachedData encode(Long l)
/*    */   {
/* 19 */     if (this.primitiveAsString) {
/* 20 */       byte[] b = encodeString(l.toString());
/* 21 */       int flags = 0;
/* 22 */       if (b.length > this.compressionThreshold) {
/* 23 */         byte[] compressed = compress(b);
/* 24 */         if (compressed.length < b.length) {
/* 25 */           if (log.isDebugEnabled()) {
/* 26 */             log.debug("Compressed " + l.getClass().getName() + " from " + b.length + " to " + compressed.length);
/*    */           }
/*    */           
/*    */ 
/* 30 */           b = compressed;
/* 31 */           flags |= 0x2;
/*    */         }
/* 33 */         else if (log.isDebugEnabled()) {
/* 34 */           log.debug("Compression increased the size of " + l.getClass().getName() + " from " + b.length + " to " + compressed.length);
/*    */         }
/*    */       }
/*    */       
/*    */ 
/*    */ 
/* 40 */       return new CachedData(flags, b, b.length, -1L);
/*    */     }
/* 42 */     return new CachedData(768, this.tu.encodeLong(l.longValue()));
/*    */   }
/*    */   
/*    */   public Long decode(CachedData d) {
/* 46 */     if (this.primitiveAsString) {
/* 47 */       byte[] data = d.getData();
/* 48 */       if ((d.getFlag() & 0x2) != 0) {
/* 49 */         data = decompress(d.getData());
/*    */       }
/* 51 */       int flag = d.getFlag();
/* 52 */       if (flag == 0) {
/* 53 */         return Long.valueOf(decodeString(data));
/*    */       }
/* 55 */       return null;
/*    */     }
/*    */     
/* 58 */     if (768 == d.getFlag()) {
/* 59 */       return Long.valueOf(this.tu.decodeLong(d.getData()));
/*    */     }
/* 61 */     log.error("Unexpected flags for long:  " + d.getFlag() + " wanted " + 768);
/*    */     
/* 63 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\transcoders\LongTranscoder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */