/*    */ package org.apache.avro.file;
/*    */ 
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.AvroRuntimeException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class CodecFactory
/*    */ {
/*    */   public static CodecFactory nullCodec()
/*    */   {
/* 41 */     return NullCodec.OPTION;
/*    */   }
/*    */   
/*    */ 
/*    */   public static CodecFactory deflateCodec(int compressionLevel)
/*    */   {
/* 47 */     return new DeflateCodec.Option(compressionLevel);
/*    */   }
/*    */   
/*    */   public static CodecFactory snappyCodec()
/*    */   {
/* 52 */     return new SnappyCodec.Option();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 61 */   private static final Map<String, CodecFactory> REGISTERED = new HashMap();
/*    */   
/*    */   private static final int DEFAULT_DEFLATE_LEVEL = -1;
/*    */   
/*    */   static
/*    */   {
/* 67 */     addCodec("null", nullCodec());
/* 68 */     addCodec("deflate", deflateCodec(-1));
/* 69 */     addCodec("snappy", snappyCodec());
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public static CodecFactory fromString(String s)
/*    */   {
/* 82 */     CodecFactory o = (CodecFactory)REGISTERED.get(s);
/* 83 */     if (o == null) {
/* 84 */       throw new AvroRuntimeException("Unrecognized codec: " + s);
/*    */     }
/* 86 */     return o;
/*    */   }
/*    */   
/*    */ 
/*    */   public static CodecFactory addCodec(String name, CodecFactory c)
/*    */   {
/* 92 */     return (CodecFactory)REGISTERED.put(name, c);
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 97 */     Codec instance = createInstance();
/* 98 */     return instance.toString();
/*    */   }
/*    */   
/*    */   protected abstract Codec createInstance();
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\file\CodecFactory.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */