/*     */ package org.apache.avro.util;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ByteBufferOutputStream
/*     */   extends OutputStream
/*     */ {
/*     */   public static final int BUFFER_SIZE = 8192;
/*     */   private List<ByteBuffer> buffers;
/*     */   
/*     */   public ByteBufferOutputStream()
/*     */   {
/*  36 */     reset();
/*     */   }
/*     */   
/*     */   public List<ByteBuffer> getBufferList()
/*     */   {
/*  41 */     List<ByteBuffer> result = this.buffers;
/*  42 */     reset();
/*  43 */     ByteBuffer buffer; for (Iterator i$ = result.iterator(); i$.hasNext(); buffer.flip()) buffer = (ByteBuffer)i$.next();
/*  44 */     return result;
/*     */   }
/*     */   
/*     */   public void prepend(List<ByteBuffer> lists)
/*     */   {
/*  49 */     for (ByteBuffer buffer : lists) {
/*  50 */       buffer.position(buffer.limit());
/*     */     }
/*  52 */     this.buffers.addAll(0, lists);
/*     */   }
/*     */   
/*     */   public void append(List<ByteBuffer> lists)
/*     */   {
/*  57 */     for (ByteBuffer buffer : lists) {
/*  58 */       buffer.position(buffer.limit());
/*     */     }
/*  60 */     this.buffers.addAll(lists);
/*     */   }
/*     */   
/*     */   public void reset() {
/*  64 */     this.buffers = new LinkedList();
/*  65 */     this.buffers.add(ByteBuffer.allocate(8192));
/*     */   }
/*     */   
/*     */   public void write(ByteBuffer buffer) {
/*  69 */     this.buffers.add(buffer);
/*     */   }
/*     */   
/*     */   public void write(int b)
/*     */   {
/*  74 */     ByteBuffer buffer = (ByteBuffer)this.buffers.get(this.buffers.size() - 1);
/*  75 */     if (buffer.remaining() < 1) {
/*  76 */       buffer = ByteBuffer.allocate(8192);
/*  77 */       this.buffers.add(buffer);
/*     */     }
/*  79 */     buffer.put((byte)b);
/*     */   }
/*     */   
/*     */   public void write(byte[] b, int off, int len)
/*     */   {
/*  84 */     ByteBuffer buffer = (ByteBuffer)this.buffers.get(this.buffers.size() - 1);
/*  85 */     int remaining = buffer.remaining();
/*  86 */     while (len > remaining) {
/*  87 */       buffer.put(b, off, remaining);
/*  88 */       len -= remaining;
/*  89 */       off += remaining;
/*  90 */       buffer = ByteBuffer.allocate(8192);
/*  91 */       this.buffers.add(buffer);
/*  92 */       remaining = buffer.remaining();
/*     */     }
/*  94 */     buffer.put(b, off, len);
/*     */   }
/*     */   
/*     */   public void writeBuffer(ByteBuffer buffer) throws IOException
/*     */   {
/*  99 */     if (buffer.remaining() < 8192) {
/* 100 */       write(buffer.array(), buffer.position(), buffer.remaining());
/*     */     } else {
/* 102 */       ByteBuffer dup = buffer.duplicate();
/* 103 */       dup.position(buffer.limit());
/* 104 */       this.buffers.add(dup);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\util\ByteBufferOutputStream.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */