/*     */ package org.codehaus.jackson.map.ser;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import org.codehaus.jackson.map.JsonMappingException;
/*     */ import org.codehaus.jackson.map.JsonSerializer;
/*     */ import org.codehaus.jackson.map.ResolvableSerializer;
/*     */ import org.codehaus.jackson.map.SerializerProvider;
/*     */ import org.codehaus.jackson.map.ser.impl.ReadOnlyClassToSerializerMap;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class SerializerCache
/*     */ {
/*  35 */   private HashMap<TypeKey, JsonSerializer<Object>> _sharedMap = new HashMap(64);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  40 */   private ReadOnlyClassToSerializerMap _readOnlyMap = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReadOnlyClassToSerializerMap getReadOnlyLookupMap()
/*     */   {
/*     */     ReadOnlyClassToSerializerMap m;
/*     */     
/*     */ 
/*     */ 
/*  52 */     synchronized (this) {
/*  53 */       m = this._readOnlyMap;
/*  54 */       if (m == null) {
/*  55 */         this._readOnlyMap = (m = ReadOnlyClassToSerializerMap.from(this._sharedMap));
/*     */       }
/*     */     }
/*  58 */     return m.instance();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public synchronized int size()
/*     */   {
/*  71 */     return this._sharedMap.size();
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public JsonSerializer<Object> untypedValueSerializer(Class<?> type)
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: dup
/*     */     //   2: astore_2
/*     */     //   3: monitorenter
/*     */     //   4: aload_0
/*     */     //   5: getfield 4	org/codehaus/jackson/map/ser/SerializerCache:_sharedMap	Ljava/util/HashMap;
/*     */     //   8: new 9	org/codehaus/jackson/map/ser/SerializerCache$TypeKey
/*     */     //   11: dup
/*     */     //   12: aload_1
/*     */     //   13: iconst_0
/*     */     //   14: invokespecial 10	org/codehaus/jackson/map/ser/SerializerCache$TypeKey:<init>	(Ljava/lang/Class;Z)V
/*     */     //   17: invokevirtual 11	java/util/HashMap:get	(Ljava/lang/Object;)Ljava/lang/Object;
/*     */     //   20: checkcast 12	org/codehaus/jackson/map/JsonSerializer
/*     */     //   23: aload_2
/*     */     //   24: monitorexit
/*     */     //   25: areturn
/*     */     //   26: astore_3
/*     */     //   27: aload_2
/*     */     //   28: monitorexit
/*     */     //   29: aload_3
/*     */     //   30: athrow
/*     */     // Line number table:
/*     */     //   Java source line #80	-> byte code offset #0
/*     */     //   Java source line #81	-> byte code offset #4
/*     */     //   Java source line #82	-> byte code offset #26
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	31	0	this	SerializerCache
/*     */     //   0	31	1	type	Class<?>
/*     */     //   2	26	2	Ljava/lang/Object;	Object
/*     */     //   26	4	3	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   4	25	26	finally
/*     */     //   26	29	26	finally
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public JsonSerializer<Object> untypedValueSerializer(JavaType type)
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: dup
/*     */     //   2: astore_2
/*     */     //   3: monitorenter
/*     */     //   4: aload_0
/*     */     //   5: getfield 4	org/codehaus/jackson/map/ser/SerializerCache:_sharedMap	Ljava/util/HashMap;
/*     */     //   8: new 9	org/codehaus/jackson/map/ser/SerializerCache$TypeKey
/*     */     //   11: dup
/*     */     //   12: aload_1
/*     */     //   13: iconst_0
/*     */     //   14: invokespecial 13	org/codehaus/jackson/map/ser/SerializerCache$TypeKey:<init>	(Lorg/codehaus/jackson/type/JavaType;Z)V
/*     */     //   17: invokevirtual 11	java/util/HashMap:get	(Ljava/lang/Object;)Ljava/lang/Object;
/*     */     //   20: checkcast 12	org/codehaus/jackson/map/JsonSerializer
/*     */     //   23: aload_2
/*     */     //   24: monitorexit
/*     */     //   25: areturn
/*     */     //   26: astore_3
/*     */     //   27: aload_2
/*     */     //   28: monitorexit
/*     */     //   29: aload_3
/*     */     //   30: athrow
/*     */     // Line number table:
/*     */     //   Java source line #90	-> byte code offset #0
/*     */     //   Java source line #91	-> byte code offset #4
/*     */     //   Java source line #92	-> byte code offset #26
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	31	0	this	SerializerCache
/*     */     //   0	31	1	type	JavaType
/*     */     //   2	26	2	Ljava/lang/Object;	Object
/*     */     //   26	4	3	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   4	25	26	finally
/*     */     //   26	29	26	finally
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public JsonSerializer<Object> typedValueSerializer(JavaType type)
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: dup
/*     */     //   2: astore_2
/*     */     //   3: monitorenter
/*     */     //   4: aload_0
/*     */     //   5: getfield 4	org/codehaus/jackson/map/ser/SerializerCache:_sharedMap	Ljava/util/HashMap;
/*     */     //   8: new 9	org/codehaus/jackson/map/ser/SerializerCache$TypeKey
/*     */     //   11: dup
/*     */     //   12: aload_1
/*     */     //   13: iconst_1
/*     */     //   14: invokespecial 13	org/codehaus/jackson/map/ser/SerializerCache$TypeKey:<init>	(Lorg/codehaus/jackson/type/JavaType;Z)V
/*     */     //   17: invokevirtual 11	java/util/HashMap:get	(Ljava/lang/Object;)Ljava/lang/Object;
/*     */     //   20: checkcast 12	org/codehaus/jackson/map/JsonSerializer
/*     */     //   23: aload_2
/*     */     //   24: monitorexit
/*     */     //   25: areturn
/*     */     //   26: astore_3
/*     */     //   27: aload_2
/*     */     //   28: monitorexit
/*     */     //   29: aload_3
/*     */     //   30: athrow
/*     */     // Line number table:
/*     */     //   Java source line #97	-> byte code offset #0
/*     */     //   Java source line #98	-> byte code offset #4
/*     */     //   Java source line #99	-> byte code offset #26
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	31	0	this	SerializerCache
/*     */     //   0	31	1	type	JavaType
/*     */     //   2	26	2	Ljava/lang/Object;	Object
/*     */     //   26	4	3	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   4	25	26	finally
/*     */     //   26	29	26	finally
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public JsonSerializer<Object> typedValueSerializer(Class<?> cls)
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: dup
/*     */     //   2: astore_2
/*     */     //   3: monitorenter
/*     */     //   4: aload_0
/*     */     //   5: getfield 4	org/codehaus/jackson/map/ser/SerializerCache:_sharedMap	Ljava/util/HashMap;
/*     */     //   8: new 9	org/codehaus/jackson/map/ser/SerializerCache$TypeKey
/*     */     //   11: dup
/*     */     //   12: aload_1
/*     */     //   13: iconst_1
/*     */     //   14: invokespecial 10	org/codehaus/jackson/map/ser/SerializerCache$TypeKey:<init>	(Ljava/lang/Class;Z)V
/*     */     //   17: invokevirtual 11	java/util/HashMap:get	(Ljava/lang/Object;)Ljava/lang/Object;
/*     */     //   20: checkcast 12	org/codehaus/jackson/map/JsonSerializer
/*     */     //   23: aload_2
/*     */     //   24: monitorexit
/*     */     //   25: areturn
/*     */     //   26: astore_3
/*     */     //   27: aload_2
/*     */     //   28: monitorexit
/*     */     //   29: aload_3
/*     */     //   30: athrow
/*     */     // Line number table:
/*     */     //   Java source line #104	-> byte code offset #0
/*     */     //   Java source line #105	-> byte code offset #4
/*     */     //   Java source line #106	-> byte code offset #26
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	31	0	this	SerializerCache
/*     */     //   0	31	1	cls	Class<?>
/*     */     //   2	26	2	Ljava/lang/Object;	Object
/*     */     //   26	4	3	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   4	25	26	finally
/*     */     //   26	29	26	finally
/*     */   }
/*     */   
/*     */   public void addTypedSerializer(JavaType type, JsonSerializer<Object> ser)
/*     */   {
/* 122 */     synchronized (this) {
/* 123 */       if (this._sharedMap.put(new TypeKey(type, true), ser) == null)
/*     */       {
/* 125 */         this._readOnlyMap = null;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void addTypedSerializer(Class<?> cls, JsonSerializer<Object> ser)
/*     */   {
/* 132 */     synchronized (this) {
/* 133 */       if (this._sharedMap.put(new TypeKey(cls, true), ser) == null)
/*     */       {
/* 135 */         this._readOnlyMap = null;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addAndResolveNonTypedSerializer(Class<?> type, JsonSerializer<Object> ser, SerializerProvider provider)
/*     */     throws JsonMappingException
/*     */   {
/* 147 */     synchronized (this) {
/* 148 */       if (this._sharedMap.put(new TypeKey(type, false), ser) == null)
/*     */       {
/* 150 */         this._readOnlyMap = null;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 159 */       if ((ser instanceof ResolvableSerializer)) {
/* 160 */         ((ResolvableSerializer)ser).resolve(provider);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addAndResolveNonTypedSerializer(JavaType type, JsonSerializer<Object> ser, SerializerProvider provider)
/*     */     throws JsonMappingException
/*     */   {
/* 172 */     synchronized (this) {
/* 173 */       if (this._sharedMap.put(new TypeKey(type, false), ser) == null)
/*     */       {
/* 175 */         this._readOnlyMap = null;
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 184 */       if ((ser instanceof ResolvableSerializer)) {
/* 185 */         ((ResolvableSerializer)ser).resolve(provider);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public synchronized void flush()
/*     */   {
/* 195 */     this._sharedMap.clear();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static final class TypeKey
/*     */   {
/*     */     protected int _hashCode;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     protected Class<?> _class;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     protected JavaType _type;
/*     */     
/*     */ 
/*     */ 
/*     */     protected boolean _isTyped;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     public TypeKey(Class<?> key, boolean typed)
/*     */     {
/* 225 */       this._class = key;
/* 226 */       this._type = null;
/* 227 */       this._isTyped = typed;
/* 228 */       this._hashCode = hash(key, typed);
/*     */     }
/*     */     
/*     */     public TypeKey(JavaType key, boolean typed) {
/* 232 */       this._type = key;
/* 233 */       this._class = null;
/* 234 */       this._isTyped = typed;
/* 235 */       this._hashCode = hash(key, typed);
/*     */     }
/*     */     
/*     */     private static final int hash(Class<?> cls, boolean typed) {
/* 239 */       int hash = cls.getName().hashCode();
/* 240 */       if (typed) {
/* 241 */         hash++;
/*     */       }
/* 243 */       return hash;
/*     */     }
/*     */     
/*     */     private static final int hash(JavaType type, boolean typed) {
/* 247 */       int hash = type.hashCode() - 1;
/* 248 */       if (typed) {
/* 249 */         hash--;
/*     */       }
/* 251 */       return hash;
/*     */     }
/*     */     
/*     */     public void resetTyped(Class<?> cls) {
/* 255 */       this._type = null;
/* 256 */       this._class = cls;
/* 257 */       this._isTyped = true;
/* 258 */       this._hashCode = hash(cls, true);
/*     */     }
/*     */     
/*     */     public void resetUntyped(Class<?> cls) {
/* 262 */       this._type = null;
/* 263 */       this._class = cls;
/* 264 */       this._isTyped = false;
/* 265 */       this._hashCode = hash(cls, false);
/*     */     }
/*     */     
/*     */     public void resetTyped(JavaType type) {
/* 269 */       this._type = type;
/* 270 */       this._class = null;
/* 271 */       this._isTyped = true;
/* 272 */       this._hashCode = hash(type, true);
/*     */     }
/*     */     
/*     */     public void resetUntyped(JavaType type) {
/* 276 */       this._type = type;
/* 277 */       this._class = null;
/* 278 */       this._isTyped = false;
/* 279 */       this._hashCode = hash(type, false);
/*     */     }
/*     */     
/* 282 */     public final int hashCode() { return this._hashCode; }
/*     */     
/*     */     public final String toString() {
/* 285 */       if (this._class != null) {
/* 286 */         return "{class: " + this._class.getName() + ", typed? " + this._isTyped + "}";
/*     */       }
/* 288 */       return "{type: " + this._type + ", typed? " + this._isTyped + "}";
/*     */     }
/*     */     
/*     */ 
/*     */     public final boolean equals(Object o)
/*     */     {
/* 294 */       if (o == this) return true;
/* 295 */       TypeKey other = (TypeKey)o;
/* 296 */       if (other._isTyped == this._isTyped) {
/* 297 */         if (this._class != null) {
/* 298 */           return other._class == this._class;
/*     */         }
/* 300 */         return this._type.equals(other._type);
/*     */       }
/* 302 */       return false;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\ser\SerializerCache.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */