package prefuse.data.expression;

import prefuse.data.Schema;
import prefuse.data.Tuple;
import prefuse.util.TypeLib;

public class NumericLiteral
  extends Literal
{
  private final Number m_number;
  private final Class m_type;
  
  public NumericLiteral(int paramInt)
  {
    this.m_number = new Integer(paramInt);
    this.m_type = Integer.TYPE;
  }
  
  public NumericLiteral(long paramLong)
  {
    this.m_number = new Long(paramLong);
    this.m_type = Long.TYPE;
  }
  
  public NumericLiteral(float paramFloat)
  {
    this.m_number = new Float(paramFloat);
    this.m_type = Float.TYPE;
  }
  
  public NumericLiteral(double paramDouble)
  {
    this.m_number = new Double(paramDouble);
    this.m_type = Double.TYPE;
  }
  
  public NumericLiteral(Object paramObject)
  {
    if ((paramObject instanceof Number))
    {
      this.m_number = ((Number)paramObject);
      this.m_type = TypeLib.getPrimitiveType(this.m_number.getClass());
    }
    else
    {
      throw new IllegalArgumentException("Invalid type!");
    }
  }
  
  public Class getType(Schema paramSchema)
  {
    return this.m_type;
  }
  
  public Object get(Tuple paramTuple)
  {
    return this.m_number;
  }
  
  public int getInt(Tuple paramTuple)
  {
    return this.m_number.intValue();
  }
  
  public long getLong(Tuple paramTuple)
  {
    return this.m_number.longValue();
  }
  
  public float getFloat(Tuple paramTuple)
  {
    return this.m_number.floatValue();
  }
  
  public double getDouble(Tuple paramTuple)
  {
    return this.m_number.doubleValue();
  }
  
  public String toString()
  {
    return this.m_number.toString();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\expression\NumericLiteral.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */