package prefuse.data.util;

import java.util.BitSet;
import java.util.NoSuchElementException;
import prefuse.util.collections.IntIterator;

public class UniqueRowIterator
  extends IntIterator
{
  private IntIterator m_iter;
  private int m_next;
  private BitSet m_visited;
  
  public UniqueRowIterator(IntIterator paramIntIterator)
  {
    this.m_iter = paramIntIterator;
    this.m_visited = new BitSet();
    advance();
  }
  
  private void advance()
  {
    int i = -1;
    while ((i == -1) && (this.m_iter.hasNext()))
    {
      i = this.m_iter.nextInt();
      if (visit(i)) {
        i = -1;
      }
    }
    this.m_next = i;
  }
  
  private boolean visit(int paramInt)
  {
    if (this.m_visited.get(paramInt)) {
      return true;
    }
    this.m_visited.set(paramInt);
    return false;
  }
  
  public boolean hasNext()
  {
    return this.m_next != -1;
  }
  
  public int nextInt()
  {
    if (this.m_next == -1) {
      throw new NoSuchElementException();
    }
    int i = this.m_next;
    advance();
    return i;
  }
  
  public void remove()
  {
    throw new UnsupportedOperationException();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\UniqueRowIterator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */