package prefuse.util.force;

public class GravitationalForce
  extends AbstractForce
{
  private static final String[] pnames = { "GravitationalConstant", "Direction" };
  public static final int GRAVITATIONAL_CONST = 0;
  public static final int DIRECTION = 1;
  public static final float DEFAULT_FORCE_CONSTANT = 1.0E-4F;
  public static final float DEFAULT_MIN_FORCE_CONSTANT = 1.0E-5F;
  public static final float DEFAULT_MAX_FORCE_CONSTANT = 0.001F;
  public static final float DEFAULT_DIRECTION = -1.5707964F;
  public static final float DEFAULT_MIN_DIRECTION = -3.1415927F;
  public static final float DEFAULT_MAX_DIRECTION = 3.1415927F;
  
  public GravitationalForce(float paramFloat1, float paramFloat2)
  {
    this.params = new float[] { paramFloat1, paramFloat2 };
    this.minValues = new float[] { 1.0E-5F, -3.1415927F };
    this.maxValues = new float[] { 0.001F, 3.1415927F };
  }
  
  public GravitationalForce()
  {
    this(1.0E-4F, -1.5707964F);
  }
  
  public boolean isItemForce()
  {
    return true;
  }
  
  protected String[] getParameterNames()
  {
    return pnames;
  }
  
  public void getForce(ForceItem paramForceItem)
  {
    float f1 = this.params[1];
    float f2 = this.params[0] * paramForceItem.mass;
    int tmp24_23 = 0;
    float[] tmp24_20 = paramForceItem.force;
    tmp24_20[tmp24_23] = ((float)(tmp24_20[tmp24_23] + Math.cos(f1) * f2));
    int tmp43_42 = 1;
    float[] tmp43_39 = paramForceItem.force;
    tmp43_39[tmp43_42] = ((float)(tmp43_39[tmp43_42] + Math.sin(f1) * f2));
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\force\GravitationalForce.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */